$LARGE
C Levels.for - sets up contour levels for CONREC
C
C----------------------------------------------------------------------
C  Set Up Levels - set contour levels and labels

	SUBROUTINE Set Up Levels
	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'conrec.dec'

	CHARACTER*10	Dummy, Fmt, Field Name1, Field Name2, Debug*75 
	REAL*4		Tlevel
	INTEGER*4	Fld Index, Ifield, Ipos1, Ipos2, Width
	LOGICAL		Normalize

C calculate format for contour labels, determine scalefactor
	Normalize = .FALSE.
	ScaleFactor = 1.0
	Width = 10                                     
	CALL SetFmt (ContourInc, Fmt, Width)

C set levels
	DO 10 I = 1, MAXCONTOUR
	   CLABEL (I) 	  = '                '
	   IF (I .LT. 10) THEN
	      WRITE (Field Name1, '(A6,I1,3X)') 'CLEVEL',I
	      WRITE (Field Name2, '(A6,I1,3X)') 'CLABEL',I
	   ELSE
	      WRITE (Field Name1, '(A6,I2,2X)') 'CLEVEL',I
	      WRITE (Field Name2, '(A6,I2,2X)') 'CLABEL',I
	   ENDIF
	   Tlevel = ContourMin + (ContourInc * (I-1))
	   IF (Tlevel .LE. ContourMax) THEN
	      NcLevel = I
	      Clevel (I) = TLevel
	      WRITE (CLabel (I), Fmt)   Clevel (I)
	      CALL Left Justify (Clabel (I))	   	  
              CALL Set 4FloatingPoint Value (Field Name1, Clevel (I), 3)
	   ELSE
	      CALL Set Character Value (Field Name1, Clabel (I))
	   ENDIF
	   CALL Set Character Value (Field Name2, Clabel (I))
 10	CONTINUE 	

	CALL Display Levels
	RETURN
	END

C----------------------------------------------------------------------
C Display Levels - Put Contour Levels on the Screen

	SUBROUTINE Display Levels

$INCLUDE: 'conrec.dec'

	CHARACTER*10	Dummy, Field Name1, Field Name2, Fmt1, Fmt2 
	DATA 		Fmt1 /'(A6,I1,3X)'/, Fmt2  /'(A6,I2,2X)'/
	
	IF (NcLevel .LE. 0) RETURN
 	DO 10 I = 1, MAXCONTOUR
	   IF (I .GT. NcLevel) RETURN
	   IF (I .LT. 10) THEN
	      WRITE (Field Name1, Fmt1) 'CLEVEL',I
	      WRITE (Field Name2, Fmt1) 'CLABEL',I
	   ELSE
	      WRITE (Field Name1, Fmt2) 'CLEVEL',I
	      WRITE (Field Name2, Fmt2) 'CLABEL',I
	   ENDIF
	   CALL Display One Field (Field Name1)
	   CALL Display One Field (Field Name2)
  10	CONTINUE  	
	WRITE (Dummy, '(I10)') NcLevel
	CALL Putstr (Dummy, 10, 6, 31, 0)
	RETURN
	END

C----------------------------------------------------------------------
C Reset Levels - erase the levels and labels part of CONREC screen 3
	
	SUBROUTINE Reset Levels
	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'conrec.dec'

	CHARACTER*10  Field Name1, Field Name2, Fmt1, Fmt2

	DATA	Fmt1 /'(A6,I1,3X)'/, Fmt2  /'(A6,I2,2X)'/
	
	IF (NcLevel .LE. 0) RETURN

 	DO 10 I = 1, MAXCONTOUR
	   IF (I .LT. 10) THEN
	      WRITE (Field Name1, Fmt1) 'CLEVEL',I
	      WRITE (Field Name2, Fmt1) 'CLABEL',I
	   ELSE
	      WRITE (Field Name1, Fmt2) 'CLEVEL',I
	      WRITE (Field Name2, Fmt2) 'CLABEL',I
	   ENDIF
	   Clabel (I) = '                '
	   Clevel (I) = 0.0
	   CALL Set Character Value (Field Name1, Clabel (I))
	   CALL Set Character Value (Field Name2, Clabel (I))
	   CALL Erase Field (Field Name1)
	   CALL Erase Field (Field Name2)
  10	CONTINUE  	
	CALL Erase (6, 31, 10)
	NcLevel = 0
	RETURN
	END


