	PROGRAM Sctest
	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'\msfort\screen\screen.str'

	INTEGER*4 SCnumber, Screen

	CALL Read Structure ('CONREC.SCR')
	CALL New Screen (1)
	CALL Get Screen Fields
	CALL Clear Screen
	END
		
C----------------------------------------------------------------------
C Get Screen Fields - 	displays screen frame/label/fields
C			gets the screen fields for the current screen
C
C Used in GEOSTAT software (Allen Sparks)
C
C  This routine was written to enable the linking of multiple menus 
C   under a single screen.  Menu choices 
C	
C
C Assumes : The Starting Field Name for a screen always points 
C		to a Menu Field which begins the program.
C	  : Menu choices are 'linked' either to
C			- other menus in other screens
C                       - submenus (on the current screen)
C	    		- screen fields, where options are chosen
C	  : SUBROUTINE New Screen (1) has been called just prior to
C		entry into this routine 
C       

	SUBROUTINE Get Screen Fields 
	IMPLICIT INTEGER*4 (A-Z)
 
$INCLUDE:'\msfort\screen\screen.str'

	PARAMETER (MENUTYPE = 3)
	INTEGER*4 SCnumber, Screen
	CHARACTER*10	Menu Name

C
C	Initialize the value of the current screen
C
        Screen = Current Screen  	
C
C  A new screen has been displayed
C  put out the initial menu (the one which starting field points to)
C
 10 	CALL Put Menu (SC Field Name (Starting Field (Screen)))

 20     IF (Screen .EQ. 0) THEN
 	   RETURN
C
C  check if choice has led to a new screen
C
	ELSE IF (Screen .NE. Current Screen) THEN	
	   CALL New Screen (Screen)
	   GOTO 10
	ELSE
C
C process the next field
C
	   CALL GetField
           IF (SC Field Type (Next Field) .EQ. MENUTYPE) 
     +          CALL Put Menu (SC Field Name (Next Field))
C
C  variable Screen holds the screen number for the next field 
C
	   Screen = SCnumber (Next Field) 
	   GOTO 20
	ENDIF
	END	

C----------------------------------------------------------------------
C New Screen (Screen number) - sets up a new screen
C
	SUBROUTINE New Screen (Screen Number)
	IMPLICIT INTEGER*4 (A-Z)

	CALL Clear Screen
	CALL Set Screen (Screen Number)
	CALL Display Frame
	CALL Display Fields
	CALL Display Labels
	RETURN
	END

