$LARGE
c**********************************************************************
c*** File name: PREP14.FOR (Source code for the program DATAPREP)
c**********************************************************************
c interface for Delete - delete file
c
      	INTERFACE TO INTEGER*2 FUNCTION DELETE [C,ALIAS:'_remove']
     1 		(NAME)
      	INTEGER*4 NAME
      	END
c----------------------------------------------------------------------
c interface for Rename - rename file
c
      	INTERFACE TO INTEGER*2 FUNCTION RENAME [C,ALIAS:'_rename']
     1 		(OLDNAME, NEWNAME)
      	INTEGER*4 OLDNAME, NEWNAME
      	END
c----------------------------------------------------------------------
c interface for System call
c
      	INTERFACE TO INTEGER*2 FUNCTION SYSTEM [C,ALIAS:'_system']
     1 		(COMMAND)
      	INTEGER*4 COMMAND
      	END
c**********************************************************************
c        D e l e t e  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Delete File(Filename, Returncode)

c***  This routine executes the DOS command 'Delete' via a 'C' procedure
c***  called DELETE. 
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to be deleted.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.

$INCLUDE:'Dataprep.dec'

      CHARACTER	 Filename*(*)
      INTEGER*2	 DELETE, Returncode


      CALL Build Prefix Filename (Filename)
      Prefile(77:77) = CHAR (0)
      Returncode = DELETE (LOC (Prefile))

      RETURN
      END
c**********************************************************************
c        R e n a m e  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Rename File(Oldname, Newname, Returncode)

c***  This routine executes the DOS command 'Rename' via a 'C' procedure
c***  called RENAME. 
c***
c***  VARIABLES:
c***  Oldname	 - contains the name of the file to be renamed.
c***  Newname	 - contains the new file name.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Oldname then
c***               contains the Prefix + the Newname.

$INCLUDE:'Dataprep.dec'

      CHARACTER	 Oldname*(*), Newname*(*), Oldfile*77
      INTEGER*2	 RENAME, Returncode


      CALL Build Prefix Filename (Oldname)
      Prefile(77:77) = CHAR (0)
      Oldfile = Prefile
      CALL Build Prefix Filename (Newname)
      Prefile(77:77) = CHAR (0)
      Returncode = RENAME (LOC (Oldfile), LOC (Prefile))

      RETURN
      END
c**********************************************************************
c        C o p y  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Copy File(Oldfile, Newfile, Returncode)

c***  This routine executes the DOS command 'Copy' via a 'C' procedure
c***  called SYSTEM.  The copy command along with the old and new file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Oldfile	 - contains the name of the file from which to copy.
c***  Newfile    - contains the name of the file to copy to.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      CHARACTER	 Oldfile*(*), Newfile*(*), Progrm*80
      INTEGER*2	 SYSTEM, Returncode, L, K, J, I


      Returncode = 0
c***  Check if command is larger than 'Progrm' array.  If so return
c***  a '-1' to indicate that 'Copy' command is too long.
      CALL Build Prefix Filename (Oldfile)
      J = LENSTR(Prefile) + 6
      IF (J .GT. 79) THEN
	 Returncode = -1
	 RETURN
      ENDIF
c***  ENTER 'COPY' TEXT INTO PROGRM.
      Progrm = 'copy '
      L = 1
c***  ENTER INTO PROGRM THE NAME OF FILE TO BE COPIED.
      DO 15 I = 6, J 
	 Progrm(I:I) = Prefile(L:L)
	 L = L + 1
  15  CONTINUE
      K = 79 - J
      L = 1
      CALL Build Prefix Filename (Newfile)
      I = LENSTR(Prefile) + J
c***  Check if command is larger than 'Progrm' array.  If so return
c***  a '-1' to indicate that 'Copy' command is too long.
      IF (I .GT. 79) THEN
	 Returncode = -1
	 RETURN
      ENDIF
c***  ENTER INTO PROGRM THE NAME OF FILE TO CONTAIN COPY.
      DO 10 I = J + 1, K 
	Progrm(I:I) = Prefile(L:L)
	L = L + 1
  10  CONTINUE
      Progrm(80:80) = CHAR (0)
      Returncode = SYSTEM (LOC (Progrm))

      RETURN
      END
c**********************************************************************
c        P r i n t  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Print File(Filename, Returncode)

c***  This routine executes the DOS command 'Print' via a 'C' procedure
c***  called SYSTEM.  The Print command along with the file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to print.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      CHARACTER	 Filename*(*), Progrm*80
      INTEGER*2	 SYSTEM, Returncode, L, K, J, I


      Returncode = 0
      CALL Build Prefix Filename (Filename)
      J = LENSTR(Prefile) + 6
c***  IF LENGTH OF SYSTEM COMMAND EXCEEDS 79 THEN SET RETURNCODE = -1.
      IF (J .GT. 79) THEN
	Returncode = -1
	RETURN
      ENDIF
c***  ENTER 'PRINT' TEXT INTO PROGRM.
      Progrm = 'print '
      L = 1
c***  ENTER INTO PROGRM THE NAME OF FILE TO BE COPIED.
      DO 15 I = 7, J 
	Progrm(I:I) = Prefile(L:L)
	L = L + 1
  15  CONTINUE
      Progrm(80:80) = CHAR (0)
c***  Execute the command.
      Returncode = SYSTEM (LOC (Progrm))

      RETURN
      END
c**********************************************************************
c        L i s t   F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE List File(Filename, Returncode)

c***  This routine executes the DOS command 'More' via a 'C' procedure
c***  called SYSTEM.  The More command along with the file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to list.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      CHARACTER	 Filename*(*), Progrm*80
      INTEGER*2	 SYSTEM, Returncode, L, K, J, I
      INTEGER*4  Value


      Returncode = 0
      CALL Build Prefix Filename (Filename)
      J = LENSTR(Prefile) + 6
c***  IF LENGTH OF SYSTEM COMMAND EXCEEDS 79 THEN SET RETURNCODE = -1.
      IF (J .GT. 79) THEN
	Returncode = -1
	RETURN
      ENDIF
c***  ENTER 'PRINT' TEXT INTO PROGRM.
      Progrm = 'more< '
      L = 1
c***  ENTER INTO PROGRM THE NAME OF FILE TO BE COPIED.
      DO 15 I = 7, J 
	Progrm(I:I) = Prefile(L:L)
	L = L + 1
  15  CONTINUE
      Progrm(80:80) = CHAR (0)
      Returncode = SYSTEM (LOC (Progrm))
      WRITE(*,*) ' PRESS ENTER to return to menu'
      READ (*, '(A)') Progrm
 
      RETURN
      END
c**********************************************************************
c        L i s t   D i r e c t o r y     (subroutine)
c**********************************************************************
      SUBROUTINE List Directory(Returncode)

c***  This routine executes the DOS command 'Dir' via a 'C' procedure
c***  called SYSTEM.  The Directory command along with the directory
c***  is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Doscom	 - global variable which contains the directory.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.



$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      CHARACTER	 Progrm*80
      INTEGER*2	 SYSTEM, Returncode, L, K, J, I


      Returncode = 0
      J = LENSTR(Doscom) + 6
c***  IF LENGTH OF SYSTEM COMMAND EXCEEDS 79 THEN SET RETURNCODE = -1.
      IF (J .GT. 79) THEN
	Returncode = -1
	RETURN
      ENDIF
c***  ENTER 'dir' TEXT INTO PROGRM.
      Progrm = 'dir   '
      L = 1
c***  ENTER INTO PROGRM THE NAME OF DIRECTORY.
      DO 15 I = 7, J 
	Progrm(I:I) = Doscom(L:L)
	L = L + 1
  15  CONTINUE
      Progrm(80:80) = CHAR (0)
      Returncode = SYSTEM (LOC (Progrm))
      WRITE(*,*) ' Press <Enter> to return to menu'
      READ (*, '(A)') Progrm
 
      RETURN
      END

c**********************************************************************
c        S y s t e m  C o m m a n d     (subroutine)
c**********************************************************************
      SUBROUTINE System Command

c***  This routine executes the command 'Command' via a 'C' procedure
c***  called SYSTEM.  Once this command is executed, the user is in DOS.
c***  The user can return to DATAPREP by entering 'exit'. 
c***
c***  VARIABLES:
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed but is not returned to the
c***               calling program.
c***  Progrm     - a character array that contains the command.
c***               line for DOS to execute.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      INTEGER*2     I, SYSTEM, Returncode
      CHARACTER*80  Progrm

c***  Erase previous contents of Progrm.
  10  DO 13, I = 1,80
	Progrm(I:I) = ' '
  13  CONTINUE

c***  Insert 'COMMAND' and interface with the C routine 'SYSTEM'.
      Progrm = 'COMMAND'
  20  Returncode = SYSTEM (LOC (Progrm))

      RETURN
      END
c**********************************************************************
 
