C**********************************************************************
C
C GEOEAS.FOR  - system menu for Geo-EAS programs 
C Written by Allen Sparks - (3/13/88) - Computer Sciences Corporation
C
C Compile using Microsoft FORTRAN 4.01:
C
C FL /c /Od /4Ns /4I2 /4Nt /FPc  GEOEAS.for
C FL /c /Od /4Ns /4I2 /4Nt /FPc  BLOCK.FOR
C
C LINK /NOD /E Geoeas+Block,geoeas,nul,asmlib+
C              \msfort\Clibfore+\msfort\llibc;
C--------------------------------------------------------------------
C Subroutine calling structure
C
C GeoEAS - ASMLIB (Setmod)
C        |
C        | Set Screen
C        |
C        | Display Fields ---- Put Str
C        |
C        | Display Frame  ---- Draw Line ------ Draw Char - PutStr
C        |
C        | Display Labels ---- Put Str
C        |
C        | Flash ------------- Put Str
C        |                   | ASMLIB (Getcha)
C        |                   + Erase ---------- Put Str
C        |             
C        | Put Str ----------- PutVmem
C        |
C        | Get Menu Choice --- Write Field ---- Put Str 
C        |                   | Erase ---------- Put Str 
C        |                   | Write Messages - Put Str
C        |                   + ASMLIB (Getcha, Setmod)
C        |
C        | Erase ------------- Put Str
C        |
C        + C FUNCTION Spawn
C   
C----------------------------------------------------------------------
C interface for SPAWNLP call
C
      	INTERFACE TO INTEGER*2 FUNCTION SPAWN [C,ALIAS:'_spawnlp']
     1 	(MODE, PROGRAM, ARGV0, NUL)
      	INTEGER*2 MODE
	INTEGER*4 PROGRAM, ARGV0, NUL
      	END

C----------------------------------------------------------------------
      	PROGRAM GEOEAS
	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE:'Screen.str'

	CHARACTER*10	Program
      	INTEGER*2 	EXEC, SPAWN, RETURNCODE
	INTEGER*4	Address

C Initialize
	Address = LOC (Program)

C read screen definition file for system menu, display intro screen
	CALL SETMOD (3)
	CALL Set Screen (1)
	CALL Display Fields
	CALL Display Frame
	CALL Display Labels
	CALL Flash (20, 2, 'Press any key to begin ')	

C display screen and menu
 20	CALL SETMOD (3)
	CALL Set Screen (2)
	CALL Display Fields
	CALL Display Frame
	CALL Display Labels
	CALL PutStr (
     + 'Use arrow keys to move cursor, <enter> to select program'
     + ,56,20,2,0)

 	CALL Get Menu Choice ('MAINMENU  ', Program)
	IF (Program (1:4) .NE. 'Quit') THEN
	   RETURN CODE = 0
	   RETURNCODE = SPAWN (INT2 (0), Address, Address, INT4 (0))
	   IF (RETURNCODE .NE. 0) THEN
	     CALL Erase (20, 2, 75)
	     CALL FLASH (20, 2, 'ERROR loading program ')
	   ENDIF
	   GOTO 20
	ENDIF
	CALL SETMOD (3)
      	END

C----------------------------------------------------------------------
C       Get Menu Choice - returns string containing chosen item
C
        SUBROUTINE Get Menu Choice (Menu Name, Menu Choice)
        IMPLICIT INTEGER*2 (A-Z)

	PARAMETER (UP        = 272)
	PARAMETER (DOWN      = 280)
	PARAMETER (LEFT      = 275)
	PARAMETER (RIGHT     = 277)
	PARAMETER (CARRIAGE RETURN =  13)

$INCLUDE:'Screen.str'        

        CHARACTER       Menu Name*(*), Menu Choice*(*)
        INTEGER*2       Field, Fld Index, OldField
	INTEGER*2	First Field, Position, Length
	INTEGER*2   	Scan, Ascii, CF

        First Field     = Fld Index (Menu Name)
 10	CF		= First Field + SC Position (First Field)        
	OldField	= CF
	CALL Write Field (CF, SC Chosen Attribute (CF))
	CALL Erase (22, 2, 76)
	IF (SC Message (CF) .NE. 0) CALL Write Messages (CF)

	CALL GETCHA (Scan, Ascii)
	Character   = Ascii
	IF (Character .EQ. 0) THEN
	    Character = 200 + Scan
	ELSEIF (Character .EQ. 81 .OR. Character .EQ. 113) THEN
	    CALL SETMOD (3)
	    STOP
	ENDIF

	IF (Character .EQ. CARRIAGE RETURN) THEN
	    Field = First Field
	    Position = SC Position (Field)
	    Length   = SC Length   (Field+Position)
	    Pointer  = SC Pointer  (Field+Position)
	    Menu Choice = Record (Pointer : Pointer + Length - 1)
	    CALL Write Field (CF, SC Attribute (CF))
	    IF (Menu Choice (1:1) .NE. ' ') RETURN
	ELSE IF (Character .EQ. UP   ) THEN
	  CF = CF + SC Up (CF)
	ELSE IF (Character .EQ. DOWN ) THEN
	  CF = CF + SC Down (CF)
	ELSE IF (Character .EQ. LEFT ) THEN
	  CF = CF + SC Left (CF)
	ELSE IF (Character .EQ. RIGHT) THEN
	  CF = CF + SC Right (CF)
	ELSE
	  GOTO 10
	ENDIF

	SC Position (First Field) = CF - First Field
	CALL Write Field (OldField, SC Attribute (OldField))
	GOTO 10	
        END 

*********************************************************************

	SUBROUTINE Write Field (Field, Attribute)
	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	Pointer = SC Pointer (Field) +
     +	          SC Length (Field) * SC Position (Field)

	CALL PutStr (
     +	          Record (Pointer :
     +	                  Pointer + SC Length (Field) - 1),
     +                    SC Length (Field),
     +		  SC Row (Field), SC Column (Field),   
     +	          Attribute)

	RETURN
	END

*********************************************************************
	SUBROUTINE Write Messages (Field)

	IMPLICIT INTEGER*2 (A-Z)
	CHARACTER*80 Out

$INCLUDE: 'SCREEN.STR'

	Pointer = SC M Pointer (Field)
	Length  = SC M Length  (Field)

	DO 10 i = 1, SC Message (Field)
	  READ (Record (Pointer : Pointer + 6), '(2(I2,1X),I1)')
     +	       Row, Column, Attribute
	  CALL PutStr (Record (Pointer+8 : Pointer+Length-1),
     +                 Length-8, 
     +		       Row, Column, Attribute)
	  Pointer = Pointer + Length
  10	CONTINUE

	RETURN
	END


*********************************************************************
	SUBROUTINE Display Labels

	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	DO 10 i = Begin Label (Current Screen),
     +	         End Label (Current Screen)

	  CALL PutStr (
     +	       Record (LB Pointer (i) :
     +	               LB Pointer (i) + LB Length (i) - 1),
     +                 LB Length  (i),
     +	               LB Row (i), LB Column (i),
     +	       LB Attribute (i))
  10	CONTINUE

	RETURN
	END

*********************************************************************

	SUBROUTINE Display Fields

	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	DO 10 i = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)
	  CALL Write Field (i, SC Attribute (i))
  10	CONTINUE

	RETURN
	END

C----------------------------------------------------------------------
C geoscr.for   Screen processing code for GeoEAS System Menu program
C
C  *** All code has been modified to handle menu fields only ***
C
C**********************************************************************
	interface to integer*2 function putvmem[C]
     1		(str[reference],nchars,row,
     1		 col,attr)
 	character*80 str
	integer*2 nchars,row,col
	integer*1 attr
	end

C----------------------------------------------------------------------
	SUBROUTINE Set Screen (Screen Number)

	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	IF (Screen Number .GT. 0 .AND. Screen Number .LE. MAX SCREENS)
     +		THEN
	  Current Screen = Screen Number
	  Number of Input Fields = End Screen (Current Screen)
	  Current Field = Starting Field (Current Screen)
	  Next Field = Starting Field (Current Screen)
	ENDIF

	RETURN
	END

*********************************************************************
	INTEGER*2 FUNCTION Fld Index (Name)

	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Name

	DO 10 i = 1, End Screen (Total Number of Screens)
	  IF (Name .EQ. SC Field Name (i)) THEN
	    Fld Index = i
	    RETURN
	  ENDIF
  10	CONTINUE
	Fld Index = 0
	RETURN
	END


C----------------------------------------------------------------------
C These routines were added to the SAM Screen subroutines for use by 
C   the GEOSTAT programs.
C   Programmer:	Allen Sparks
c----------------------------------------------------------------------
C       Erase - erase N characters from column, row

        SUBROUTINE Erase (Row, Column, N)
        IMPLICIT INTEGER*2 (A-Z)
	CHARACTER*80	Blanks
        INTEGER*2       Row, Column, N

	CALL PutStr (Blanks, N, Row, Column, 0)
        RETURN
        END

C----------------------------------------------------------------------
C       Flash   - flash string Message at Row, Col, wait for keystroke

        SUBROUTINE FLASH (Row, Column, Message)
        IMPLICIT INTEGER*2 (A-Z)
        INTEGER*2       Row, Column
	INTEGER*2	Scan, Ascii
        CHARACTER       Message*(*) 
	CALL PutStr (Message, INT2 (LEN (Message)), Row, Column, 2)
        CALL GetCha (Scan, Ascii)
        CALL Erase (Row, Column, INT2(LEN (Message)))
        RETURN
        END

C**********************************************************************
C   Screen Access Management (SAM) Utilities - Machine Dependent routines
C**********************************************************************
C**********************************************************************
c         P u t  S t r                (subroutine)
c**********************************************************************
c  Put Str - Places a character string at the specified row and column
c	   Ch: Character string to be placed
c	   Len: Length of character string
c	   Row: row position
c	   Col: column position
c	   Att: attribute (normal,blinking,bold,etc.)
c		          **************
C------------------------------------------------------------------------
C	NORMAL    = 0
C	BOLD      = 1
C	REVERSE   = 2
C	BLINK     = 4
C	UNDERLINE = 8
C------------------------------------------------------------------------
       SUBROUTINE Put Str (Ch,Len,Row,Col,Att)

       CHARACTER*(*)  Ch
       INTEGER*2      Len,Row,Col,Att
       INTEGER*2      ReturnCode, PutVmem
       INTEGER*1      A

C Normal
	A = 7
C Reverse
	IF (BTEST (Att, 1)) A = 112
C Bold
	IF (BTEST (Att, 0)) A = A + 8

       Return Code = 
     +		 PutVmem (Ch, Len, Row, Col, A)

       RETURN
       END

C**********************************************************************
        SUBROUTINE Display Frame
	IMPLICIT INTEGER*2 (A-Z)
	PARAMETER (BOX  = 0)
	PARAMETER (LINE = 1)
	INTEGER*2 Matrix    (0:24, 0:79)
	INTEGER*2 Attribute (0:24, 0:79)

$INCLUDE: 'SCREEN.STR'

      DO 10 i = 0, 24
        DO 10 j = 0, 79
          Matrix    (i, j) = 0
          Attribute (i, j) = 0
  10  CONTINUE

      DO 20 i = Begin Frame (Current Screen),
     +            End Frame (Current Screen)

        IF (FR Command (i) .EQ. BOX) THEN

          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row1(i), FR Column2(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column2(i),
     +                    FR Row2(i), FR Column2(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row2(i), FR Column1(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row2(i), FR Column1(i),
     +                    FR Row2(i), FR Column2(i))

        ELSE
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row2(i), FR Column2(i))

        ENDIF

  20  CONTINUE

      RETURN
      END

***********************************************************************

      SUBROUTINE Draw Line (Matrix, Attribute, f,
     +                      Row1, Column1, Row2, Column2)
	IMPLICIT INTEGER*2 (A-Z)

$INCLUDE: 'SCREEN.STR'

	INTEGER*2 Matrix    (0:24, 0:79)
	INTEGER*2 Attribute (0:24, 0:79)
      LOGICAL*1 Double Line

      Double Line = .FALSE.
      att = FR Attribute (f)

      Line Type   = 0

      IF (FR Type (f) .EQ. 2) Double Line = .TRUE.

C*----- Horizontal Line -----*/
      IF (Row1 .EQ. Row2) THEN

        IF (Double Line) Line Type = 16

C*----- Left edge -----------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column1, 1, Line Type, att)

        DO 10 col = Column1+1, Column2-1

C*----- Horizontal edge -----*/

          CALL Draw Char (Matrix, Attribute,
     +                    Row1, col, 3, Line Type, att)

  10    CONTINUE

C*----- Right edge ----------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column2, 2, Line Type, att)

C*----- Vertical Line -------*/

      ELSE

        IF (Double Line) Line Type = 32

C*----- Top edge ------------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column1, 8, Line Type, att)

        DO 20 row = Row1+1, Row2-1

C*----- Vertical edge -------*/

          CALL Draw Char (Matrix, Attribute,
     +                    row, Column1, 12, Line Type, att)

  20    CONTINUE

C*----- Bottom edge ---------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row2, Column1, 4, Line Type, att)

      ENDIF

      RETURN
      END

***********************************************************************

      SUBROUTINE Draw Char (Matrix, Attribute,
     +                      row, col, ch, Line Type, att)
	IMPLICIT INTEGER*2 (A-Z)
	INTEGER*2 Matrix    (0:24, 0:79)
	INTEGER*2 Attribute (0:24, 0:79)

      CHARACTER*1 Box Chars (0:63)
      DATA Box Chars /
     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '' /

      ch2 = IOR (ch, Line Type)
      Matrix (row, col) = IOR (Matrix (row, col), ch2)

      Attribute (row, col) = att

	CALL PutStr (Box Chars (Matrix (row, col)),
     +			 1, Row, Col, Attribute (row, col))

      RETURN
      END








