'Program CONHP-WP.BAS, written in MicroSoft QuickBASIC (R) v. 4.0
'by S. Evett, 4 Nov. 88.
Start:
y$ = "S"
CLS
PRINT
PRINT "   Program CONHP-WP.BAS converts plot files (*.plt) output by the"
PRINT "   Geo-EAS program HPPLOT.EXE into plot files which can be read into"
PRINT "   WordPerfect 5.0.  Written by S. Evett, 4 Nov. 88."
PRINT
PRINT "   Output file name will have the same prefix as the input file but"
PRINT "   will have the extension  '.wp', i.e. *.plt will convert to *.wp."
PRINT
INPUT "   Enter input file name: "; file$
PRINT

ON ERROR GOTO FileErr
FileOpen:
OPEN "i", #2, file$
ON ERROR GOTO 0
IF y$ = CHR$(13) THEN GOTO Start   'Try another file name.

IF INSTR(file$, ".") = 0 THEN
    outfile$ = file$ + ".wp"
ELSE
    place = INSTR(file$, ".")
    outfile$ = LEFT$(file$, place - 1) + ".wp"
END IF
OPEN "o", #3, outfile$
PRINT "   Output file name is: "; outfile$

'Note: This routine assumes that the scale command "SC" is found entirely
'within the first 2 lines.  IT WILL NOT WORK IF THIS IS NOT TRUE.
'Input first line and parse it looking for "SC".  IF "SC" is not found then
'save 1st line in print1$ otherwise print all of it before the "SC".
LINE INPUT #2, a$
a$ = LTRIM$(a$)
GOSUB Parse1   'Returns print$ and a$. Print$ contains leader,
'a$ may contain "SC".  If len(a$)>0 then a$ contains "SC" and we should
'print leader otherwise save leader in print1$ and look for "SC" in line 2:
IF LEN(a$) > 0 THEN PRINT #3, print$ ELSE print1$ = print$: PrintFlag = 0

'Input second line looking for "SC", etc.
LINE INPUT #2, a2$
a$ = a$ + a2$  'Make new string consisting of what was left from 1st string
'plus second string.
GOSUB Parse1   'Again look for "SC"
'Print leader if not already done:
IF PrintFlag = 0 THEN print$ = print1$ + print$: PRINT #3, print$
'Now a$ contains "SC" as first characters, proceed to parse it.
'Also, can print replacement user defined scale command to file now:
PRINT #3, "SC0,0,7962,7962;"

'Search second line for 1st 'PA'.  Save rest of line in l$ to parse later.
'Parse part of line occuring before 'PA' to get divisor for conversions:
PRINT
PRINT "   Substring containing scale command is parsed here:"
s2$ = a$'LINE INPUT #2, s2$
place = INSTR(s2$, "PA")   'Assumes 1st command after scale command is "PA".
l$ = MID$(s2$, place)      'Save rest of string.
s2$ = MID$(s2$, 1, place - 1)'Get 1st part of string in s2$.
'Now find first "SC":
place = INSTR(s2$, "SC")
s2$ = MID$(s2$, place)     'Get substring containing only scale command.
PRINT "    1 ", s2$
'Find first comma:
place = INSTR(s2$, ",")
s2$ = MID$(s2$, place + 1)   'Get substring after first comma.
PRINT "    2 ", s2$
'Find second comma:
place = INSTR(s2$, ",")
n1 = VAL(LEFT$(s2$, place - 1))  'Get value of 1st upper limit.
s2$ = MID$(s2$, place + 1)   'Get substring after second comma.
PRINT "    3 ", s2$
'Find 3rd comma:
place = INSTR(s2$, ",")
s2$ = MID$(s2$, place + 1)   'Get last part of substring.
PRINT "    4 ", s2$
n2 = VAL(s2$)  'Get value of 1st upper limit.
IF n1 > n2 THEN divisor = n1 ELSE divisor = n2
PRINT
PRINT "   Horizontal and vertical ranges were "; n1; " and"; n2
PRINT "   Divisor is"; divisor

'Now parse, convert and print saved string:
a$ = l$
GOSUB Parse

PRINT
PRINT "   Wait while processing ..........."
DO WHILE NOT EOF(2)
    LOCATE 22, 40: PRINT TIME$
    LINE INPUT #2, a$
    a$ = LTRIM$(a$)         'Get rid of leading blanks.
    IF LEFT$(a$, 1) = ";" THEN
        print$ = print$ + ";"
        a$ = MID$(a$, 2)
    END IF
    IF LEN(print$) > 0 THEN PRINT #3, print$
    GOSUB Parse
LOOP
'Print last string returned by Parse:
IF LEN(print$) > 0 THEN PRINT #3, print$
BEEP
END

Parse:
'Build output string from input string while converting coordinates:
StartFlag = 0: print$ = ""
DO WHILE LEN(a$) > 0
    l$ = LEFT$(a$, 1): a$ = MID$(a$, 2)
    IF INSTR("1234567890.", l$) THEN
        'Its a number, add it to the number substring:
        IF StartFlag = 0 THEN
            n$ = l$: StartFlag = 1
        ELSE
            n$ = n$ + l$
        END IF
    ELSE
        'Its not a number.  If its the first alpha character after a number
        'then convert the previous number substring and add it to the
        'output string. Add the alpha character after.
        IF StartFlag = 1 THEN
            'A number was just read in.
            'Must change number and add it to output string before adding
            'alpha character.
            StartFlag = 0
            number = INT((VAL(n$) / divisor) * 7962)
            print$ = print$ + LTRIM$(STR$(number))
        END IF
        'If alpha character is not a space then add it to output string:
        IF l$ <> " " THEN print$ = print$ + l$
    END IF
LOOP
IF StartFlag = 1 THEN
    'A number was just read in but not added to output string.
    'Convert and add it now.
    number = INT((VAL(n$) / divisor) * 7962)
    print$ = print$ + LTRIM$(STR$(number))
END IF
RETURN

Parse1:
'Build output string from input string while converting coordinates:
StartFlag = 0: print$ = ""
DO WHILE LEN(a$) > 0
    'Get 1st character in l$, rest of string in a$:
    l$ = LEFT$(a$, 1): a$ = MID$(a$, 2)
    IF INSTR("1234567890.", l$) THEN
        'Its a number, add it to the number substring:
        IF StartFlag = 0 THEN
            n$ = l$: StartFlag = 1
        ELSE
            n$ = n$ + l$
        END IF
    ELSE
        'Its not a number.  If its the first alpha character after a number
        'then convert the previous number substring and add it to the
        'output string. Add the alpha character after.
        IF StartFlag = 1 THEN
            'A number was read in just before the character in l$ was read.
            'Must change number and add it to output string before adding
            'alpha character.
            StartFlag = 0
            print$ = print$ + n$
        END IF
        'If alpha character is not a space then add it to output string:
        IF l$ <> " " THEN print$ = print$ + l$
        'Look for "SC" here
        IF INSTR(print$, "SC") > 0 THEN
             'Remove the "SC" from print$
             print$ = LEFT$(print$, LEN(print$) - 2)
             a$ = "SC" + a$    'Put "SC" back in a$
             EXIT DO
        END IF
    END IF
LOOP
IF StartFlag = 1 THEN
    'A number was just read in but not added to output string.
    'Convert and add it now.
    print$ = print$ + n$
END IF
RETURN

FileErr:
CLS
PRINT
PRINT "   Error.  File "; file$; " not found."
PRINT "   Bad file name or path."
PRINT "   Enter q to quit, or hit carriage return to try again: ";
y$ = INPUT$(1)
IF y$ = "q" OR y$ = "Q" THEN END
IF ASC(y$) <> 13 THEN GOTO FileErr
RESUME NEXT

