$LARGE
C---------------------------------------------------------------------- 
C Hershy.for - Hershey character plotting subroutines
C	       Taken from VAX 11-780 implementation and modified for
C	       an IBM PC under Microsoft FORTRAN 4.0 (A.Sparks 10/87)
C
C----------------------------------------------------------------------
	SUBROUTINE HCINIT(LUN)
C
C		Initialize Hershy character plotting routines
C
	EXTERNAL BARZLE
	INTEGER*2 FINAL
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Open the Hershy character pen movement file.
C
	INPUT=LUN
	OPEN(UNIT=INPUT,STATUS='OLD',ACCESS='DIRECT',
     +	     FILE='HERSHY.BAR',FORM='BINARY',RECL=80)
C
C		Read the last record number in the file.
C
	READ(UNIT=INPUT,REC=1) FINAL
	LAST=FINAL
C
	RETURN
	END
 
C----------------------------------------------------------------------
	BLOCKDATA BARZLE
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
	DATA FONT,LNGTH,SCRPTS/0,.FALSE.,0.5/
	DATA HEIGHT,ANGLE,ASPECT/1.0,0.0,1.0/
	DATA OLDX,OLDY/12*0.0/
	END

C----------------------------------------------------------------------
	SUBROUTINE HCASP(ASP)
C
C		This routine sets the Hershy character aspect
C		ratio (width:height)
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
	IF(ASP.GT.0.0) ASPECT=ASP
C
9	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCFONT(IFONT)
C
C		This routine sets the default font.
C
C	The description as Simplex, Complex, or Gothic, indicates the
C	extent to which the characters contain tapered segments. Four
C	sizes of characters are available: the Principal or Normal size
C	(21 raster units high, em=32), the Indexical size (13 raster
C	units high, em=21), the Cartographic size (9 raster units
C	high), and the centered symbol size (20 raster units).
C
C	IFONT	Size	Description
C	-----	----	-----------
C
C	 0	Cart	Cartographic Roman
C	 1	Cart	Cartographic Greek
C	 2	Prin	Simplex Roman
C	 3	Prin	Simplex Greek
C	 4	Prin	Simplex Script
C	 5-6	Prin	Simplex Special Characters
C	 7	Index	Complex Roman
C	 8	Index	Complex Greek
C	 9	Index	Complex Italic
C	10-11	Index	Complex Special Characters
C	12	Prin	Complex Roman
C	13	Prin	Complex Greek
C	14	Prin	Complex Italic
C	15-17	Prin	Complex Special Characters
C	18-19	Prin	Duplex Roman
C	20-21	Prin	Complex Script
C	22-23	Prin	Complex Cyrillic
C	24-25	Prin	Triplex Roman
C	26-27	Prin	Triplex Italic
C	28	Prin	Gothic German
C	29	Prin	Gothic English
C	30	Prin	Gothic Italian
C	31	Prin	Gothic Special Characters
C	32	c.s.	Centered Symbols
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Set the new default font.
C
	IF(IFONT.GE.0 .AND. IFONT.LE.32) FONT=IFONT
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCLEN(TEXT,N,XLEN)
C
C		The purpose of this routine is to give the length of
C		the specified HERSHY character string.
C
	INTEGER*1 TEXT(1)
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Find the length of the string.
C
	IF(N.GT.0) THEN
	   LNGTH=.TRUE.
	   CALL HCOUT(TEXT,N)
	   LNGTH=.FALSE.
	   XLEN=XL
	ELSE
	   XLEN=0.0
	ENDIF
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCOUT(TEXT,N)
C
C	Plot the N Hershy characters stored in TEXT.  The input
C	textual string must be composed of the FORTRAN characters A-Z,
C	a-z, and <space>!$&'()*+,-./0123456789:;=?@ and the FORTRAN
C	special characters which are described below.
C
C	TEXT = Input textual array or CHARACTER string
C	N    = Number of characters in text string
C
C	The following is a list of special characters which will not
C	produce a character, but will control how the character following
C	it is treated.
C
C	" - (34) - Backspace by one character position
C	# - (35) - Indicates that a 3 digit style selection will follow
C	% - (37) - Return to the default style
C	< - (60) - Subscript the next character
C	> - (62) - Superscript the next character
C	_ - (95) - Underline the text
C
C		Declare all local variables in this program.
C
	REAL*4		XMIN, XMAX, YMIN, YMAX
	INTEGER*2	MINX, MAXX, MINY, MAXY

	INTEGER*1 BMARK(2),BTEXT,R1,R2,XA(40),YA(40)
	INTEGER*1 CHAR(0:127),CSIZES(0:33),TEXT(1)
	INTEGER*2 B(40),C(80),CHIGH(40),CLOW(40),MARK,TOTAL

	INTEGER CSHIFT(5),IREC,RR1,RR2,STYLE2,VALUE,XXI,YYI
	REAL CHGHT(5),OLDX2(6),OLDY2(6)
	LOGICAL UNDLIN
	EQUIVALENCE (C,CLOW),(C(41),CHIGH),(MARK,BMARK(1))
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT

	DATA PITCH,UNDERL/0.0,-0.03/
	DATA XMIN /0./, XMAX /3277./, YMIN /0.0/, YMAX /3277./
C
C		Define the values to be associated with all 128 ASCII
C		characters. A value of 0 means it is not defined. If
C		value > 0, this is an allowable input/output character.
C		If value < 0, this is one of the reserved control
C		characters.
C
	DATA CHAR/32*0, 1, 2,-1,-2, 3,-3, 4, 5, 6, 7, 8, 9,10,11,12,
     +                 13,14,15,16,17,18,19,20,21,22,23,24,25,-4,26,-5,
     +                 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,
     +                 43,44,45,46,47,48,49,50,51,52,53,54, 0, 0, 0, 0,
     +                 -6, 0,55,56,57,58,59,60,61,62,63,64,65,66,67,68,
     +                 69,70,71,72,73,74,75,76,77,78,79,80,5*0/
C
C		There are five possible character sizes: 1 is the
C		Principal or Normal size, 2 is the Indexical size,
C		3 is the Cartographic size, 4 the centered symbol size,
C		and 5 is the solid character size (2 * Principal)
C
	DATA CSIZES/2*3,5*1,5*2,20*1,4,5/
C
C		For each the of three sizes, there is a different
C		number of rasters to be shifted and different number
C		of rasters making its height up.
C
	DATA CHGHT/21.0,13.0,9.0,20.0,42.0/
	DATA CSHIFT/9,6,4,9,18/
C
C		Declare statement functions.
C
	R(XX,YY)=(TCOS*XX)-(TSIN*YY)
C
C		Calculate initial local default values.
C
	TSIN=SIN(ANGLE)
	TCOS=COS(ANGLE)
	STYLE2=FONT
	ISIZES=CSIZES(STYLE2)
	ISHIFT=CSHIFT(ISIZES)
	SCALE=HEIGHT/CHGHT(ISIZES)

	CALL GETDEV (MINX, MAXX, MINY, MAXY)

	XFACT=(XMAX-XMIN)/FLOAT(MAXX-MINX)
	YFACT=(YMAX-YMIN)/FLOAT(MAXY-MINY)
	STRTCH=ASPECT*(XFACT/YFACT)
	NN=N

	CALL ZWHERE(X,Y)

	XORG=X
	YORG=Y
	OLDX2(1)=OLDX(1)
	OLDY2(1)=OLDY(1)
	DO 30 I=2,6
	   OLDX2(I)=OLDX(I)
	   OLDY2(I)=OLDY(I)
  30	CONTINUE
	OLDX(6)=X
	OLDY(6)=Y
C
C		If N < 1, determine if a centered symbol is to be drawn
C		or a single right justified character is to be drawn.
C
	IF(N.LE.0) NN=1
	IF(N.LT.0) THEN
	   IF(N.LT.-1) CALL ZPLOT(X,Y)
	   STYLE2=32
	   ISIZES=CSIZES(STYLE2)
	   ISHIFT=CSHIFT(ISIZES)
	   SCALE=HEIGHT/CHGHT(ISIZES)
	   WIDTH=20.0*SCALE*STRTCH
	   X=X-(0.50*R(WIDTH,0.0))
	   Y=Y-(0.50*R(0.0,-WIDTH))
	ENDIF
C
C		Initialize any values needed to decode the character string.
C
	LOOP=-1
	J=1+MOD(STYLE2,40)
	IREC=(STYLE2/40)+2
	READ(UNIT=INPUT,REC=IREC) 	(B(II), II = 1, 40)
	IREC=B(J)
	READ(UNIT=INPUT,REC=IREC)   	(CLOW(II), II = 1, 40)
	READ(UNIT=INPUT,REC=IREC+1) 	(CHIGH(II), II = 1, 40)
	RSCALE=SCALE
	HH=HEIGHT
	VALUE=0
	YOFF=0.0
	UNDLIN=.FALSE.
C
C		Now decode the character string.
C
	DO 300 I=1,NN
	IF(N.LT.0) GO TO 190
	BTEXT=TEXT(I)
	IF(VALUE.EQ.-2) GO TO 120
	VALUE=CHAR(BTEXT)
	IF(VALUE.EQ.0) VALUE=1
	IF(VALUE.GT.0) GO TO 200
C
C		A special control character has been requested. Determine
C		which command needs to be executed.
C
	GO TO (110,120,130,150,140,160), -VALUE
	GO TO 300
C
C		Backspace by one character position.
C
 110	DO 111 J=6,2,-1
	   OLDX(J)=OLDX(J-1)
	   OLDY(J)=OLDY(J-1)
 111	CONTINUE
	X=OLDX(6)
	Y=OLDY(6)
	GO TO 300
C
C		A new style has been requested.
C
 120	LOOP=LOOP+1
	IF(LOOP.EQ.0) NUMBER=0
	IF(LOOP.GT.0) NUMBER=NUMBER*10+(BTEXT-48)
	IF(LOOP.LT.3) GO TO 300
C
C		The entire code has been read in, decode the value.
C
	LOOP=-1
	VALUE=0
	IF(NUMBER.LT.0 .OR. NUMBER.GT.32) GO TO 300
	STYLE2=NUMBER
	GO TO 134
C
C		Return to the default style. Also read the type C records in.
C
 130	STYLE2=FONT
 134	J=1+MOD(STYLE2,40)
	IREC=(STYLE2/40)+2
	READ(UNIT=INPUT,REC=IREC) 	(B(II), II = 1, 40)
	IREC=B(J)
	READ(UNIT=INPUT,REC=IREC) 	(CLOW(II), II = 1, 40)
	READ(UNIT=INPUT,REC=IREC+1) 	(CHIGH(II), II = 1, 40)
	ISIZES=CSIZES(STYLE2)
	ISHIFT=CSHIFT(ISIZES)
	SCALE=HEIGHT/CHGHT(ISIZES)
	RSCALE=SCALE
	GO TO 300
C
C		A Super- or a Sub- Script has been requested.
C
 140	YOFF=YOFF+HH
 150	HH=HH*SCRPTS
	RSCALE=RSCALE*SCRPTS
	YOFF=YOFF-(0.50*HH)
	GO TO 300
C
C		Underline the text.
C
 160	IF(LNGTH) GO TO 300
	IF(UNDLIN) THEN
	   UNDLIN=.FALSE.
	   CALL ZMOVE(X+R(UNDERV,UNDERW),Y+R(UNDERW,-UNDERV))
	   CALL ZPLOT(UNDERX,UNDERY)
	ELSE
	   UNDLIN=.TRUE.
	   UNDERW=YOFF+(UNDERL*HH)
	   UNDERV=UNDERW*PITCH
	   UNDERX=X+R(UNDERV,UNDERW)
	   UNDERY=Y+R(UNDERW,-UNDERV)
	ENDIF
	GO TO 300
C
C		A centered symbol has been requested.
C
 190	BMARK(1)=TEXT(1)
	BMARK(2)=TEXT(2)
	VALUE=MARK+1
C
C		Read in the pen movements for the character and plot it.
C
 200	IREC=C(VALUE)
	IF(IREC.LT.27 .OR. IREC.GT.LAST) GO TO 300
	READ(UNIT=INPUT,REC=IREC)
     +               R1,R2,TOTAL,(XA(JJ),YA(JJ),JJ=3,40)
	RR1=R1
	RR2=R2
	IF(TOTAL.EQ.0 .OR. LNGTH) GO TO 260
C
C		If a single character is to be drawn right justified,
C		adjust the starting coordinates. Also determine if bold
C		characters are to be written.
C
	IF(N.EQ.0) THEN
	   WIDTH=FLOAT(RR2-RR1)*RSCALE*STRTCH
	   X=X-R(WIDTH,0.0)
	   Y=Y-R(0.0,-WIDTH)
	ENDIF
C
C		Read and plot the pen movements.
C
	IPEN=3
	JJ=2
	DO 250 J=1,TOTAL
	   JJ=JJ+1
	   IF(JJ.GT.40) THEN
	      IREC=IREC+1
	      READ(UNIT=INPUT,REC=IREC) (XA(JJ),YA(JJ),JJ=1,40)
	      JJ=1
	   ENDIF
C
	   XXI=XA(JJ)
	   YYI=YA(JJ)
	   IF(XXI.NE.-64 .OR. YYI.NE.0) THEN
	      YI=(FLOAT(ISHIFT-YYI)*RSCALE)+YOFF
	      XI=(FLOAT(XXI-RR1)*RSCALE*STRTCH)+(YI*PITCH)
	      IF(IPEN.EQ.2) THEN
	         CALL ZPLOT(X+R(XI,YI),Y+R(YI,-XI))
	      ELSE
	         CALL ZMOVE(X+R(XI,YI),Y+R(YI,-XI))
	      ENDIF
	      IPEN=2
	   ELSE
	      IPEN=3
	   ENDIF
 250	CONTINUE
C
C		Store the new location of the pen in storage arrays.
C
 260	WIDTH=FLOAT(RR2-RR1)*RSCALE*STRTCH
	X=X+R(WIDTH,0.0)
	Y=Y+R(0.0,-WIDTH)
	DO 270 J=1,5
	   OLDX(J)=OLDX(J+1)
	   OLDY(J)=OLDY(J+1)
 270	CONTINUE
	OLDX(6)=X
	OLDY(6)=Y
C
C		Character has been written out, return to original
C		scaling factors.
C
	YOFF=0.0
	HH=HEIGHT
	RSCALE=SCALE
 300	CONTINUE
C
C		If finding the length of string, do calculations and
C		restore arrays, then return to the calling program.
C
	XL=SQRT((X-XORG)**2+(Y-YORG)**2)
	IF(LNGTH) THEN
	   DO 400 I=1,6
	      OLDX(I)=OLDX2(I)
	      OLDY(I)=OLDY2(I)
 400	   CONTINUE
	ENDIF
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCPOS(TEXT,N,IPOS)
C
C		The purpose of this routine is to position the
C		character string according to the value in IPOS.
C		IPOS = 1, centered
C		     = 2, right justified
C		     = 0 or other, left justified.
C
C		The variables TEXT and N are used the same way as in
C		HCOUT.
C
	INTEGER*1 TEXT(1)
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Get current beam (pen) location.
C
	CALL ZWHERE(X,Y)
C
C		Determine how TEXT is to be centered.
C		Need to find the length of the character string.
C
	IF(IPOS.EQ.1 .OR. IPOS.EQ.2) THEN
	   CALL HCLEN(TEXT,N,XLEN)
	   IF(IPOS.EQ.1) XLEN=XLEN*0.50
	   X=X-(XLEN*COS(ANGLE))
	   Y=Y-(XLEN*SIN(ANGLE))
	   CALL ZMOVE(X,Y)
	ENDIF
C
C		Draw the TEXT.
C
	CALL HCOUT(TEXT,N)
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCROT(DEGREE)
C
C		This routine sets the angle of rotation (counter-
C		clockwise from the postiive x-axis) for Hershy text.
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Store rotation angle in radians.
C
	ANGLE=DEGREE*0.01745329
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCSCR(SCRIPT)
C
C		This routine sets the default sub-/super- scripting
C		scale factor.
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
C		Set the new default scripting scale factor.
C
	IF(SCRIPT.GT.0.0) SCRPTS=SCRIPT
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCSIZ(ISIZE)
C
C		This routine sets the Hershy character height in
C		screen units.
C
	REAL*4		XMIN, XMAX, YMIN, YMAX
	INTEGER*2	MINX, MAXX, MINY, MAXY

	DATA XMIN /0./, XMAX /32767.0/, YMIN /0.0/, YMAX /32767.0/

	CALL GETDEV (MINX, MAXX, MINY, MAXY)

	IF(ISIZE.GT.0) THEN
	   SIZE=REAL(ISIZE)*(YMAX-YMIN)/REAL(MAXY-MINY)
	   CALL HCSIZE(SIZE)
	ENDIF
C
	RETURN
	END
 

C----------------------------------------------------------------------
	SUBROUTINE HCSIZE(SIZE)
C
C		This routine sets the Hershy character height in
C		virtual units.
C
	INTEGER FONT
	LOGICAL LNGTH
	COMMON/HERSHY/ OLDX(6),OLDY(6),SCRPTS,XL,FONT,
     +	               INPUT,LAST,LNGTH,HEIGHT,ANGLE,ASPECT
C
	IF(SIZE.GT.0.0) HEIGHT=SIZE
C
	RETURN
	END












