$LARGE
C----------------------------------------------------------------------
C These routines were added to the SAM Screen subroutines for use by 
C   the GEOSTAT programs.
C   Programmer:	Allen Sparks
c----------------------------------------------------------------------
	interface to integer*2 function putvmem[C]
     1		(str[reference],nchars,row,
     1		 col,attr)
	character*80 str
	integer*2 nchars,row,col
	integer*1 attr
	end
C----------------------------------------------------------------------
		function lenstr(string)
		character string*(*)
		n = len(string)
		do 10 i = n,1,-1
			if(string(i:i) .ne. ' ') then
				lenstr = i
				return
			endif
 10		continue
		lenstr = 0
		end

C----------------------------------------------------------------------
C       Erase - erase N characters from column, row

        SUBROUTINE Erase (Row, Column, N)
        IMPLICIT INTEGER*4 (A-Z)
	CHARACTER*80	Blanks
        INTEGER*4       Row, Column, N

	CALL PutStr (Blanks, N, Row, Column, 0)

C        CALL PUTCUR (HFIX(0), HFIX(Row), HFIX(Column))
C        CALL PUTVCH (HFIX(0), HFIX(32), HFIX(7), HFIX(N))
        RETURN
        END

C----------------------------------------------------------------------
C       Flash   - flash string Message at Row, Col, wait for keystroke

        SUBROUTINE FLASH (Row, Column, Message)
        IMPLICIT INTEGER*4 (A-Z)
        INTEGER*4       Row, Col Key
        CHARACTER       Message*(*) 

C        CALL Locate Cursor (Row, Column)
C        CALL Put Characters (Message, LEN (Message), 2)

	CALL PutStr (Message, LEN (Message), Row, Column, 2)

        CALL Get Key (Key)
        CALL Erase (Row, Column, LEN (Message))
        RETURN
        END

C----------------------------------------------------------------------
C       Get Menu Choice - returns string containing chosen item
C
        SUBROUTINE Get Menu Choice (Menu Name, Menu Choice)
        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'Screen.str'        

        CHARACTER       Menu Name*(*), Menu Choice*(*)
        INTEGER*4       First Field, Last Field, Nitems
        INTEGER*4       Position

        First Field     = Fld Index (Menu Name)
        Nitems          = SC Members (First Field)
        Last Field      = First Field + Nitems
        Next Field      = First Field

        
 10     IF( Next Field .GE. First Field .AND.
     +      Next Field .LE. Last Field)  THEN
            CALL Getfield
        ELSE
            CALL Get Menu Value (Menu Name, Position, Menu Choice)
            RETURN   
        ENDIF
        GOTO 10
        END 

C----------------------------------------------------------------------
C  Put Menu - put out menu fields 

        SUBROUTINE Put Menu (Menu Name)
        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'Screen.str'

        CHARACTER       Menu Name*(*)
        INTEGER*4       Field, First Field, Last Field
	INTEGER*4     Fld Index 

        CALL Erase (22, 1, 78)
        CALL Erase (23, 1, 78)

        First Field     = Fld Index (Menu Name)
        Last Field      = First Field + SC Members (First Field)

        DO 10 Field = First Field+1, Last Field
            CALL Write Field (Field, SC Attribute(Field))
 10     CONTINUE
        RETURN
        END
    
C----------------------------------------------------------------------
C Left Justify (String)
C
        SUBROUTINE Left Justify (String)
        CHARACTER String*(*), Temp(80)
        N = LEN (String) 
        I = 1
 10     IF (String (I:I) .EQ. ' ') THEN
          I = I + 1
          GOTO 10
        ENDIF
        DO 20 J = 1,N-I+1
           K = J+I-1
           String (J:J) = String (K:K)
 20     CONTINUE
        DO 30 K = J,N
 30           String (K:K) = ' '
        RETURN
        END 

C---------------------------------------------------------------------
C       GetYesNo        - get a yes no answer at Row, Column
C
        LOGICAL*1 FUNCTION Get Yes No (Row, Column, Prompt)
        IMPLICIT INTEGER*4 (A-Z)
        INTEGER*4       Row, Column, Key
        CHARACTER       Prompt*(*)
        
C        CALL Locate Cursor (Row, Column)
C        CALL Put Characters (Prompt, LEN(PROMPT), 0)

	CALL PutStr (Prompt, LEN (Prompt), Row, Column, 0)
        CALL Get Key (Key)
        IF (Key .EQ. ICHAR('Y') .OR. Key .EQ. ICHAR('y')) THEN
           Get Yes No = .TRUE.
        ELSE
           Get Yes No = .FALSE.
        END IF
        CALL Erase (Row, Column, LEN(Prompt))
        RETURN
        END

c----------------------------------------------------------------------
c  Toggle - Get toggle field

	INTEGER*4 FUNCTION Toggle (Field Name)

        IMPLICIT INTEGER*4 (A-Z)
$INCLUDE:'Screen.str'

	CHARACTER 	Field Name*(*), Dummy*70 
	INTEGER*4	Field, Position
	INTEGER*4     	Fld Index 

        Next Field      = Fld Index (Field Name)
        CALL Get Field
        CALL Get Toggle Value (Field Name, Position, Dummy)                
        Toggle = Position

        RETURN
	END

C**********************************************************************
C        L o a d  T o g g l e  V a l u e s     Chris Nisse
c********************************************************************** 
c  Loads toggle members into a toggle field
c	  Name:           name of toggle field
c	  Length:         maximum length of a member
c	  Member Total:   maximum number of toggle members permitted
c	  Variable List:  list of toggle members
C added 11/16/87 - sparks
c	  Toggle Position: position to set toggle field (0 is first)
c			 

      SUBROUTINE Load Toggle Values (Name, Length, Member Total,
     +                               Variable List, Toggle Position)

      IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'Screen.str'

      CHARACTER*(*)  Variable List(1), Name
      CHARACTER*30   Value
      INTEGER*4     Fld Index 

C Get Field index
      Field = Fld Index (Name)

C Error checks
      IF (Field .LE. 0 .OR. 
     +      Field .GT. End Screen (Total Number of Screens)) 	RETURN
      IF (SC Field Type (Field) .NE. 5) 			RETURN

C Load field with toggle values
      SC Members (Field) = Member Total
      DO 10 Position = 0, Member Total - 1
         Value (1:Length) = Variable List (Position + 1)
         CALL Set Toggle Value (Name, Position, Value (1:Length))
  10  CONTINUE

C added 11/16/87 - sparks (set default position)
      IF (Toggle Position .LT. 0 .OR. 
     +    Toggle Position .GE. SC Members (Field)) RETURN
      SC Position (Field) = Toggle Position	

      RETURN
      END

C**********************************************************************
c         P u t  S t r                (subroutine)
c**********************************************************************
c  Put Str - Places a character string at the specified row and column
c	   Ch: Character string to be placed
c	   Len: Length of character string
c	   Row: row position
c	   Col: column position
c	   Att: attribute (normal,blinking,bold,etc.)
c		          **************
C------------------------------------------------------------------------
C	NORMAL    = 0
C	BOLD      = 1
C	REVERSE   = 2
C	BLINK     = 4
C	UNDERLINE = 8
C------------------------------------------------------------------------
       SUBROUTINE Put Str (Ch,Len,Row,Col,Att)

       CHARACTER*(*)  Ch
       INTEGER*4      Len,Row,Col,Att
       INTEGER*2      ReturnCode, PutVmem
       INTEGER*1      A

C Normal
	A = 7
C Reverse
	IF (BTEST (Att, 1)) A = 112
C Underline
	IF (BTEST (Att, 3)) A = 1
C Bold
	IF (BTEST (Att, 0)) A = A + 8
C Blink
	IF (BTEST (Att, 2)) A = A + 128

C Modified for direct to video-memory write using C function PutVmem
C
       Return Code = 
     +		 PutVmem (Ch, INT2 (Len), INT2 (Row), INT2 (Col), A)
C
C      CALL Locate Cursor (Row,Col)
C      CALL Put Characters (Ch,Len,Att)

       RETURN
       END

C---------------------------------------------------------------------
C SCnumber - returns the screen number for a given field index
C

	INTEGER*4 FUNCTION SCnumber (Field)
	INTEGER*4 Field, i

$INCLUDE:'Screen.str'

	SCnumber = 0
	DO 10 i = 1, Total Number of Screens
	   IF (Field .GE. Begin Screen (i) .AND. 
     +         Field .LE. End Screen (i)) THEN
               SCnumber = i
               RETURN
	   ENDIF
 10	CONTINUE
	RETURN
	END

C----------------------------------------------------------------------
C Set Toggle Position - set the position of a toggle field
C

	SUBROUTINE Set Toggle Position (Name, Position)

$INCLUDE: 'Screen.str'

	CHARACTER 	Name*(*)
	INTEGER*4	Position, Field, Fld Index

	Field = Fld Index (Name)
	IF (Field .LE. 0 .OR. 
     +      Field .GT. End Screen (Total Number of Screens)) RETURN

	IF (Position .LT. 0 .OR. 
     +      Position .GE. SC Members (Field)) RETURN

	IF (SC Field Type (Field) .NE. 5) RETURN

	SC Position (Field) = Position
	RETURN
	END

C----------------------------------------------------------------------
C  Erase Field - erases a field, given the name
C
	SUBROUTINE Erase Field (Name)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'screen.str'

	CHARACTER 	Name*(*)
	INTEGER*4	Fld Index, Field

	Field = Fld Index (Name)
	IF (Current Screen .LE. 0 .OR. Field .LE. 0) RETURN

	IF (Field .GE. Begin Screen (Current Screen) .AND.
     +      Field .LE. End Screen   (Current Screen)) THEN                              Number of Screens)) RETURN
            CALL Erase (SC Row (Field), SC Column (Field), 
     +                                  SC Length (Field))
	ENDIF
	RETURN
	END

C----------------------------------------------------------------------
C Set Menu Position - set the position of a Menu field
C

	SUBROUTINE Set Menu Position (Name, Position)

$INCLUDE: 'Screen.str'

	CHARACTER 	Name*(*)
	INTEGER*4	Position, Field, Fld Index

	Field = Fld Index (Name)
	IF (Field .LE. 0 .OR. 
     +      Field .GT. End Screen (Total Number of Screens)) RETURN

	IF (Position .LT. 0 .OR. 
     +      Position .GE. SC Members (Field)) RETURN

	IF (SC Field Type (Field) .NE. 3) RETURN

	SC Position (Field) = Position
	RETURN
	END

C------------------------------------------------------------------------
C Build File Name
C
	SUBROUTINE Build File Name (Name1, File Name, Extension)
	CHARACTER	Name1*(*), File Name*(*), Extension*4
	INTEGER*4	LENSTR, K

	K = Index (Name1, '.')
	IF (K .NE. 0) THEN
	   K = AMIN0 (K, 9)
	ELSE
	   L = LENSTR (Name1)
	   K = AMIN0 (L, 9) + 1
	ENDIF
	File Name = Name1 (1:K-1)//Extension
	RETURN
	END


C----------------------------------------------------------------------
C Get File Name, builds a file name

	SUBROUTINE Get File Name (File Name, File Prefix,
     +			          File, Fexist)

	CHARACTER 	File Name *(*), File Prefix*(*), File*(*)
	LOGICAL 	Fexist
	INTEGER*4	N, LENSTR

	CALL Left Justify (File)
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	   File Name = File Prefix (1:N) // File
	ELSE
	   File Name = File
	ENDIF
	INQUIRE (FILE = File Name, EXIST = Fexist)  
	RETURN
	END


C----------------------------------------------------------------------
C Blank File - blanks a file name and field
	SUBROUTINE Blank File (Field Name, File Name)
	CHARACTER 	Field Name*10, File Name*(*)

	File Name = ' '
        CALL Set Character Value (Field Name, File Name)   
	RETURN
	END	


