$LARGE
C Screen1.for
C**********************************************************************
C   Computer Sciences Corporation
C
C   Screen Access Management (SAM) Utilities - Read_Structure routine.
C
C   Programmers:  Suleiman S. Lalani (Sam)
C
C**********************************************************************

	SUBROUTINE Read Structure (Screen File)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Screen File
	CHARACTER*150 Line, Blanks*50
	CHARACTER*10  Start
	CHARACTER*4   Command
	INTEGER*4     LENSTR, Klen, Ptr1, Ptr2

C	DATA Debug Screen /.FALSE./

	IF (Debug Screen) WRITE (*, *) 'Structure File = ', Screen File

	Record = ' '

	Screen Fields = 1
	OPEN (UNIT   = Screen Fields,
     +	      FILE   = Screen File,
     +	      STATUS = 'OLD',
     +	      IOSTAT = IO status)

	IF (IO status .NE. 0) THEN
	  WRITE (*, *) 'File ', Screen File, ' Not Found.'
	  RETURN
	ENDIF

	End Screen (0) = 0
	End Label  (0) = 0
	End Frame  (0) = 0
	Pointer = 1
	Current Screen = 1

   5	IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	IF (Line(1:7) .EQ. 'ENDFILE') GO TO 70

	i = End Screen (Current Screen - 1)  + 1
	Begin Screen (Current Screen) = i

	READ (Line, '(1X,A10)', ERR=99, END=99) Start
	IF (Debug Screen) WRITE (*, *) 'Start = *', Start, '*'
	Line = ' '

C----------------------------------------------------------------------
C   READ FIELDS.
C----------------------------------------------------------------------

  10	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 100	    FORMAT (1X, A10, I4, 1X, 2(I3, 1X), 4(I2, 1X), 8(I3, 1X))
	    READ (Line, 100, ERR=99, END=99)
     +	          SC Field Name (i),
     +	          SC Length     (i),
     +	          SC Row        (i),
     +	          SC Column     (i),
     +	          SC Attribute  (i),
     +	          SC Chosen Attribute (i),
     +	          SC Field Type (i),
     +	             Next,
     +	          SC Carriage Return (i),
     +	          SC Up         (i),
     +	          SC Down       (i),
     +	          SC Left       (i),
     +	          SC Right      (i),
     +	          SC Members    (i),
     +	          SC Position   (i),
     +	          SC Message    (i)

	    IF (Next .EQ. 0) THEN
	      SC Next (i) = .FALSE.
	    ELSE
	      SC Next (i) = .TRUE.
	    ENDIF

	    SC Pointer (i) = Pointer
	    Record (Pointer : Pointer + SC Length (i) - 1) = ' '

	    IF (Debug Screen) THEN
	      WRITE (*, *) 'Field = ', i
	      WRITE (*, *) 'Field Name = *', SC Field Name (i), '*'
	      WRITE (*, *) 'Before processing, Pointer = ', Pointer
	    ENDIF

	    IF (SC Field Type (i) .EQ. 5) THEN
	      Position = 12
	      IF (Get Line (Screen Fields, line) .NE. 0) GO TO 99
	      DO 20 f = 1, SC Members (i)
	        Record (Pointer:Pointer+SC Length(i)-1) =
     +	          Line(Position:Position+SC Length(i)-1)
	        Position = Position + SC Length(i) + 2
	        Pointer  = Pointer  + SC Length(i)
  20	      CONTINUE

	    ELSE
	      IF (SC Field Type (i) .EQ. 4) THEN
	        Record (Pointer : Pointer + SC Length (i) - 1) =
     +	           Line (70 : 69 + SC Length (i))
	        IF (Debug Screen)
     +	           WRITE(*,*) '*', Line (70:69+SC Length(i)), '*'
	      ENDIF
	      Pointer = Pointer + SC Length (i)
	    ENDIF

	    IF (SC Message (i) .NE. 0) THEN
	      IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	      SC M Length (i) = STR Len (Line) - 11
	      SC M Pointer (i) = Pointer
	      DO 30 m = 1, SC Message (i)
	        Record (Pointer : Pointer + SC M Length (i) - 1) =
     +	          Line (12 : 11+ SC M Length (i))
	        Pointer = Pointer + SC M Length (i)
	        IF (m .LT. SC Message (i)) THEN
	          IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	        ENDIF
  30	      CONTINUE
	    ENDIF

	    i = i + 1
	  ENDIF
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'After processing , Pointer = ', Pointer
	  ENDIF

	  GO TO 10
	ENDIF

	End Screen (Current Screen) = i - 1

	IF (Debug Screen) WRITE (*, *) 'Number of Input Fields = ',
     +	    End Screen (Current Screen)

	Starting Field (Current Screen) = Fld Index (Start)
	IF (Starting Field (Current Screen) .EQ. 0) THEN
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'Starting Field Not Found! = *', Start, '*'
	  ENDIF
	  Starting Field (Current Screen) = 1
	ENDIF

	i = End Label (Current Screen - 1) + 1
	Begin Label (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Label ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ LABELS.
C----------------------------------------------------------------------

  40	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Debug Screen) THEN
	      WRITE (*, *) 'Before processing, Pointer = ', Pointer
	      WRITE (*, *) 'I = ', i
	      WRITE (*, *) Line
	  ENDIF
	  IF (Line(1:3) .NE. 'END') THEN
 120	    FORMAT (I4, 2X, 2(I2, 2X))
	    READ (Line, 120, ERR=99, END=99)
     +	          LB Row (i),
     +	          LB Column (i),
     +	          LB Attribute (i)

	    Length = STR Len (Line) - 13

	    Record (Pointer : Pointer+Length-1) = Line (14:13+Length)
	    LB Pointer (i) = Pointer
	    LB Length  (i) = Length

	    Pointer = Pointer + Length

	    i = i + 1
	  ENDIF
	  IF (Debug Screen) THEN
	      WRITE (*, *) 'After processing , Pointer = ', Pointer
	      WRITE (*, *) 'I = ', i
	      WRITE (*, *) Line
	      WRITE (*, *) Record (Pointer-Length : Pointer - 1)
	  ENDIF

	  GO TO 40
	ENDIF

	End Label (Current Screen) = i - 1

	i = End Frame (Current Screen - 1) + 1
	Begin Frame (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Frame ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ FRAMES.
C----------------------------------------------------------------------

  50	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 130	    FORMAT (A4, 1X, I1, 5(1X, I3))
	    READ (Line, 130, ERR=99, END=99)
     +	          Command,
     +	          FR Type (i),
     +	          FR Row1 (i),
     +	          FR Column1 (i),
     +	          FR Row2 (i),
     +	          FR Column2 (i),
     +	          FR Attribute (i)

	    IF (Debug Screen)
     +	      WRITE (*, *) 'Command = *', Command, '*', ' i = ', i

	    IF (Command .EQ. 'BOX') THEN
	      IF (FR Row1 (i) .EQ. FR Row2 (i)) THEN
	        FR Command (i) = 1
	      ELSE IF (FR Column1 (i) .EQ. FR Column2 (i)) THEN
	        FR Command (i) = 1
	      ELSE
	        FR Command (i) = 0
	      ENDIF

	    ELSE IF (Command .EQ. 'LINE') THEN
	      FR Command (i) = 1

	    ELSE
	      i = i - 1
	    ENDIF

	    i = i + 1

	  ENDIF

	  GO TO 50
	ENDIF

	End Frame (Current Screen) = i - 1

	Current Screen = Current Screen + 1
	GO TO 5

  70	CLOSE (Screen Fields)

	Total Number of Screens = Current Screen - 1
	Current Screen = 1
	Current Field = Starting Field (Current Screen)
	Next Field = Current Field
	Number of Input Fields = End Screen (Current Screen)

	IF (Debug Screen) THEN
	  WRITE (*, *) 'Total Screens = ', Total Number of Screens
	  WRITE (*, *) 'Begin Screen  = ', Begin Screen (1)
	  WRITE (*, *) 'End   Screen  = ', End   Screen (1)
	  WRITE (*, *) 'Begin Label   = ', Begin Label  (1)
	  WRITE (*, *) 'End   Label   = ', End   Label  (1)
	  WRITE (*, *) 'Begin Frame   = ', Begin Frame  (1)
	  WRITE (*, *) 'End   Frame   = ', End   Frame  (1)
	  CALL Get Key (Character)
	ENDIF

	RETURN

  99	WRITE (*, *) '*** ERROR in SCREEN Definition. Field = ', i
	CLOSE (Screen Fields)
	STOP

	END

*********************************************************************

	INTEGER*4 FUNCTION STR Len (Line)
	CHARACTER*(*) Line

	STR Len = 1
	DO 10 i = 150, 1, -1
	  IF (Line(i:i) .EQ. ';') THEN
	    STR Len = i - 1
	    GO TO 90
	  ENDIF
  10	CONTINUE

  90	RETURN
	END

*********************************************************************

	INTEGER*4 FUNCTION Get Line (Screen Fields, Line)

C *** Note that no screen file may have lines more than A150 chars.

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	CHARACTER*(*) Line

	Line(1:1) = 'C'
  10	IF (Line .EQ. ' ' .OR.
     +	          Line(1:1) .EQ. 'C' .OR. Line(1:1) .EQ. 'c') THEN
	  READ (Screen Fields, '(A150)', ERR=99, END=99) Line
	  IF (Debug Screen)
     +	    WRITE (*, *) Line
	  GO TO 10
	ENDIF

	Get Line = 0
	RETURN

  99	Get Line = 1
	RETURN

	END

C----------------------------------------------------------------------
	SUBROUTINE Get Field

	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Alpha Field     = 0)
	PARAMETER (Integer Field   = 1)
	PARAMETER (Real Field      = 2)
	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)
	PARAMETER (Toggle Field    = 5)

$INCLUDE: 'SCREEN.STR'
$INCLUDE: 'KEYCHECK.INC'

	CHARACTER Buffer*80, TestFmt*16
	REAL*4	  TestReal
	INTEGER*4 TestInt

	LOGICAL*1 Alphanumeric
	LOGICAL*1 Integer
	LOGICAL*1 Real
	LOGICAL*1 Decimal
	LOGICAL*1 Exponent
	LOGICAL*1 Sign
	LOGICAL*1 Blanks
	LOGICAL*1 Menu
	LOGICAL*1 Toggle
	LOGICAL*1 Done

        Alphanumeric 	= .FALSE.
	Integer  	= .FALSE.
	Real     	= .FALSE.
	Decimal  	= .TRUE.
	Exponent 	= .TRUE.
	Sign     	= .TRUE.
	Blanks   	= .TRUE.
	Menu     	= .FALSE.
	Toggle   	= .FALSE.
	Length   	= 0
	Done     	= .FALSE.

	Current Field = Next Field
	CF = Current Field

	IF (SC Field Type (CF) .EQ. Alpha Field) THEN
	  Alphanumeric = .TRUE.
	ELSE IF (SC Field Type (CF) .EQ. Integer Field) THEN
	  Integer  = .TRUE.
	  Decimal  = .FALSE.
	  Exponent = .FALSE.
	ELSE IF (SC Field Type (CF) .EQ. Real Field) THEN
	  Real = .TRUE.
	ELSE IF (SC Field Type (CF) .EQ. Main Menu Field) THEN
	  Menu       = .TRUE.
	  Main Field = Current Field
	  Current Field = Current Field + SC Position (CF)
	  CF = Current Field
	ELSE IF (SC Field Type (CF) .EQ. Menu Field) THEN
	  Menu = .TRUE.
	ELSE IF (SC Field Type (CF) .EQ. Toggle Field) THEN
	  Toggle = .TRUE.
	ENDIF

C Restart Here if an error in numeric input
 5	CALL Write Field (Current Field,
     +	                  SC Chosen Attribute (CF))

	IF (SC Message (CF) .NE. 0)
     +	   CALL Write Messages (Current Field)

	Row    = SC Row    (CF)
	Column = SC Column (CF)

	CALL Locate Cursor (Row, Column)

	Attribute  = SC Chosen Attribute (CF)
	Max Length = SC Length (CF)

	Buffer = ' '

C Main Keyboard Input Loop
  10	Old Length = Length

	IF (.NOT. Done) CALL Get Key (Character)

	Error Status = Key Check (0)

	IF (Error Status .EQ. KEY ERROR) THEN
	  CALL Beep

	ELSE IF (Error Status .EQ. KEY IGNORE) THEN

	ELSE IF (Error Status .EQ. KEY EXIT SCREEN .OR.
     +	           Character .EQ. CARRIAGE RETURN .OR.
     +	           Character .EQ. UP    .OR.
     +	           Character .EQ. DOWN  .OR.
     +	           Character .EQ. LEFT  .OR.
     +	           Character .EQ. RIGHT .OR.
     +	           Done                     ) THEN

	  IF (Character .EQ. CARRIAGE RETURN) THEN
	    Next Field = Current Field +
     +	                      SC Carriage Return (CF)
	  ELSE IF (Character .EQ. UP   ) THEN
	    Next Field = Current Field + SC Up (CF)
	  ELSE IF (Character .EQ. DOWN ) THEN
	    Next Field = Current Field + SC Down (CF)
	  ELSE IF (Character .EQ. LEFT ) THEN
	    Next Field = Current Field + SC Left (CF)
	  ELSE IF (Character .EQ. RIGHT) THEN
	    Next Field = Current Field + SC Right (CF)
	  ENDIF

	  IF (Length .NE. 0) THEN
C Error Check for Numeric Fields, If error, restart @ Label 5
	    IF (Real .OR. Integer) THEN
	        TestFmt = '                '
     	        CALL Right Justify (Buffer, Max Length)
	        IF (Real) THEN
	          WRITE (TestFmt, 600) MaxLength
 600              FORMAT ('(G',I2,'.0)')
	          READ (Buffer, TestFmt, ERR=700) TestReal                
	        ELSE
	          WRITE (TestFmt, 650) MaxLength
 650              FORMAT ('(I',I2,')')
	          READ (Buffer, TestFmt, ERR=700) TestInt                
	        ENDIF 
	        GOTO 750
 700		CALL Beep
	        Length = 0
	        GOTO 5
	      ENDIF
 750	      CONTINUE
	      P = SC Pointer (CF)
	      Record (P : P+Max Length-1) = Buffer (1 : Max Length)

	   ELSE IF (Menu) THEN
	    IF (SC Field Type (Next Field) .EQ. Menu Field) THEN
	      SC Position (Main Field) = Next Field - Main Field
	      CALL Write Field (Next Field, Attribute)
	    ENDIF
	  ENDIF

	  CALL Write Field (Current Field,
     +	                      SC Attribute (CF))

	  IF (SC Message (CF) .NE. 0)
     +	      CALL Erase Messages (Current Field)
	  RETURN

	ELSE IF (Toggle) THEN
	  IF (Character .EQ. SPACE) THEN
	    SC Position (CF) = SC Position (CF) + 1
	    IF (SC Position (CF) .GE. SC Members (CF))
     +	        SC Position (CF) = 0
	    CALL Write Field (Current Field, Attribute)
	  ELSE
	    CALL Beep
	  ENDIF

	ELSE IF (Menu) THEN
	  Little A = ICHAR ('a')
	  Little Z = ICHAR ('z')
	  Big A    = ICHAR ('A')
	  Big Z    = ICHAR ('Z')
	  IF (Character .GE. Little A .AND. Character .LE. Little Z)
     +	      THEN
	    Char2 = Character + Big A - Little A
	  ELSE IF (Character .GE. Big A .AND. Character .LE. Big Z)
     +	      THEN
	    Char2 = Character + Little A - Big A
	  ELSE
	    Char2 = Character
	  ENDIF

	  DO 20 i = 1, SC Members (Main Field)
	    f = Main Field + i
	    j = SC Pointer (f)
	    c = ICHAR (Record (j:j))
	    IF (Character .EQ. c .OR. Char2 .EQ. c) THEN
	      SC Position (Main Field) = f - Main Field
	      IF (SC Message (CF) .NE. 0)
     +	          CALL Erase Messages (Current Field)
	      CALL Write Field (Current Field,
     +	                          SC Attribute (CF))
	      CALL Write Field (f, SC Chosen Attribute (f))
	      Current Field = f
	      Next Field = f + SC Carriage Return (f)
	      RETURN
	    ENDIF
  20	  CONTINUE
	  CALL Beep

	ELSE IF (Character .EQ. BACK SPACE .OR.
     +	         Character .EQ. DELETE) THEN
	  IF (Length .GT. 0) THEN
	    IF (Buffer(Length:Length) .EQ. '.') THEN
	      Decimal = .TRUE.
	    ELSE IF (Buffer (Length:Length) .EQ. 'e' .OR.
     +	             Buffer (Length:Length) .EQ. 'E') THEN
	      Exponent = .TRUE.
	    ELSE IF (Buffer (Length:Length) .EQ. '-' .OR.
     +	             Buffer (Length:Length) .EQ. '+') THEN
	      Sign = .TRUE.
	    ENDIF

	    IF (Length .GT. 1) THEN
	      IF (Buffer(Length-1:Length-1) .EQ. ' ')
     +	          Blanks = .TRUE.
	    ENDIF
	    Buffer (Length:Length) = ' '
	    Length = Length - 1
	    Column = Column - 1
	    CALL Locate Cursor (Row, Column)
	    CALL Put Characters (' ', 1, Attribute)
	    CALL Locate Cursor (Row, Column)
	  ELSE
	    CALL Beep
	  ENDIF

	ELSE IF (Length .GE. Max Length) THEN
	  CALL Beep

	ELSE IF (Alphanumeric) THEN
	  Length = Length + 1
	  Buffer (Length:Length) = CHAR (Character)
	  CALL Put Characters (CHAR (Character), 1, Attribute)
	  Column = Column + 1
	  CALL Locate Cursor (Row, Column)

	ELSE IF (Character .EQ. SPACE .AND. Blanks) THEN
	  Length = Length + 1
	  Buffer (Length:Length) = CHAR (Character)
	  CALL Put Characters (CHAR (Character), 1, Attribute)
	  Column = Column + 1
	  CALL Locate Cursor (Row, Column)

	ELSE IF (Character .EQ. ICHAR ('.')) THEN
	  IF (Decimal) THEN
	    Decimal = .FALSE.
	    Blanks  = .FALSE.
	    Length  = Length + 1
	    Buffer (Length:Length) = CHAR (Character)
	    CALL Put Characters (CHAR (Character), 1, Attribute)
	    Column = Column + 1
	    CALL Locate Cursor (Row, Column)
	  ELSE
	    CALL Beep
	  ENDIF

	ELSE IF (Character .EQ. ICHAR ('e') .OR.
     +	         Character .EQ. ICHAR ('E')) THEN
	  IF (Exponent) THEN
	    Exponent = .FALSE.
	    Blanks = .FALSE.
	    Length = Length + 1
	    Buffer (Length:Length) = CHAR (Character)
	    CALL Put Characters (CHAR (Character), 1, Attribute)
	    Column = Column + 1
	    CALL Locate Cursor (Row, Column)
	    Sign = .TRUE.
	  ELSE
	    CALL Beep
	  ENDIF

	ELSE IF (Character .EQ. ICHAR ('+') .OR.
     +	         Character .EQ. ICHAR ('-')) THEN
	  IF (Sign) THEN
	    Sign = .FALSE.
	    Blanks = .FALSE.
	    Length = Length + 1
	    Buffer (Length:Length) = CHAR (Character)
	    CALL Put Characters (CHAR (Character), 1, Attribute)
	    Column = Column + 1
	    CALL Locate Cursor (Row, Column)
	  ELSE
	    CALL Beep
	  ENDIF

	ELSE IF (Character .GE. ICHAR ('0') .AND.
     +	         Character .LE. ICHAR ('9')) THEN
	  Sign = .FALSE.
	  Blanks = .FALSE.
	  Length = Length + 1
	  Buffer (Length:Length) = CHAR (Character)
	  CALL Put Characters (CHAR (Character),1 , Attribute)
	  Column = Column + 1
	  CALL Locate Cursor (Row, Column)

	ELSE
	  CALL Beep
	ENDIF

	IF ((Length .EQ. 1) .AND. (Old Length .EQ. 0)) THEN
C	  CALL Put Characters (Buffer (2:Max Length),
C    +                                   Max Length-1, Attribute)
	  CALL Put Str (Buffer (2:Max Length), Max Length - 1,
     +                                    Row, Column, Attribute)
	  CALL Locate Cursor (Row, Column)

	ELSE IF ((Length .EQ. 0) .AND. (Old Length .NE. 0)) THEN
	  P = SC Pointer (CF)
	  CALL PutStr (Record (P:P+Max Length-1),
     +                        Max Length, Row, Column, Attribute)
C	  CALL Put Characters (Record (P:P+Max Length-1),
C    +                        Max Length, Attribute)
	  CALL Locate Cursor (Row, Column)
	ENDIF

	IF (Length .EQ. Max Length .AND. SC Next (CF)) THEN
	  Done = .TRUE.
	  Next Field = Current Field + SC Carriage Return (CF)
	ENDIF
	GO TO 10
	RETURN
	END

*********************************************************************

	SUBROUTINE Right Justify (Buffer, Max Length)

	IMPLICIT INTEGER*4 (A-Z)
	CHARACTER Buffer*(*)
	CHARACTER Temp*80

c------------------------------------------------------------------------
c	Length = INDEX (Buffer(1:), ' ') - 1
c	IF (Length .GT. 0) THEN
c	  Temp = Buffer (1 : Length)
c	  Buffer (1 : Length) = ' '
c	  Buffer (Max Length - Length + 1 : Max Length) = Temp
c	ENDIF
c------------------------------------------------------------------------

	DO 10 i = Len(Buffer), 1, -1
	  IF (Buffer(i:i) .NE. ' ') THEN
	    Temp = Buffer (1 : i)
	    Buffer (1 : i) = ' '
	    Buffer (Max Length - i + 1 : Max Length) = Temp
	    RETURN
	  ENDIF
  10	CONTINUE

	RETURN
	END

C----------------------------------------------------------------------
	SUBROUTINE Set Screen (Screen Number)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	IF (Screen Number .GT. 0 .AND. Screen Number .LE. MAX SCREENS)
     +		THEN
	  Current Screen = Screen Number
	  Number of Input Fields = End Screen (Current Screen)
	  Current Field = Starting Field (Current Screen)
	  Next Field = Starting Field (Current Screen)
	ENDIF

	RETURN
	END

*********************************************************************

	SUBROUTINE Display Labels

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	DO 10 i = Begin Label (Current Screen),
     +	         End Label (Current Screen)

	  CALL PutStr (
     +	       Record (LB Pointer (i) :
     +	               LB Pointer (i) + LB Length (i) - 1),
     +                 LB Length  (i),
     +	               LB Row (i), LB Column (i),
     +	       LB Attribute (i))

C	    CALL Locate Cursor (LB Row (i), LB Column (i))
C	  CALL Put Characters (
C     +	       Record (LB Pointer (i) :
C     +	               LB Pointer (i) + LB Length (i) - 1),
C     +                 LB Length  (i),
C     +	       LB Attribute (i))

  10	CONTINUE

	RETURN
	END

*********************************************************************

	SUBROUTINE Display Fields

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	DO 10 i = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)

	  CALL Write Field (i, SC Attribute (i))

  10	CONTINUE

	RETURN
	END

*********************************************************************

	SUBROUTINE Display One Field (Field Name)

	IMPLICIT INTEGER*4 (A-Z)
	CHARACTER*(*) Field Name

$INCLUDE: 'SCREEN.STR'

	i = Fld Index (Field Name)
	CALL Write Field (i, SC Attribute (i))

	RETURN
	END

*********************************************************************

	SUBROUTINE Clear Fields

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	DO 10 i = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)

	  IF (SC Field Type (i) .LT. 3) THEN
	    IF (SC Length (i) .NE. 0)
     +	        Record (SC Pointer (i) :
     +	                SC Pointer (i) + SC Length (i) - 1) = ' '
	  ENDIF

  10	CONTINUE

	RETURN
	END



