	TITLE 'Video Stuff'
	NAME VideoID
	page ,132

ARGpVID		EQU	word ptr [bp+6]

VIDstruct	STRUC
Video0Type	DB	?
Display0Type	DB	?
Video1Type	DB	?
Display1Type	DB	?
VIDstruct	ENDS

Device0		EQU	word ptr Video0Type[di]
Device1		EQU	word ptr Video1Type[di]

MDA		EQU	1
CGA		EQU	2
EGA		EQU	3
MCGA		EQU	4
VGA		EQU	5
HGC		EQU	80h
HGCPlus		EQU	81h
InColor		EQU	82h

MDADisplay	EQU	1
CGADisplay	EQU	2
EGAColorDisplay	EQU	3
PS2MonoDisplay	EQU	4
PS2ColorDisplay EQU	5

TRUE		EQU	1
FALSE		EQU	0

DGROUP		GROUP _DATA
_TEXT		SEGMENT byte public 'CODE'
		ASSUME CS:_TEXT, DS:DGROUP
		PUBLIC _VideoID

_VideoID	PROC	far
		push	bp
		mov	bp,sp
		push	si
		push	di

		mov	di,ARGpVID
		mov	Device0,0
		mov	Device1,0

		mov 	byte ptr CGAflag,TRUE
		mov 	byte ptr EGAflag,TRUE
		mov 	byte ptr Monoflag,TRUE

		mov	cx,NumberOfTests
		mov	si,offset DGROUP: TestSequence

L01:		lodsb
		test	al,al
		lodsw
		jz	L02

		push	si
		push	cx
		call	ax
		pop 	cx
		pop	si

L02:		loop	L01
		call	FindActive
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_VideoID	ENDP

FindPS2		proc	near
		mov	ax,1a00h
		int	10h
		cmp	ah,1ah
		jne	L13
		
		mov	cx,bx
		xor	bh,bh
		or	ch,ch
		jz	L11
		mov	bl,ch
		add	bx,bx
		mov	ax,[bx+offset DGROUP: DCCtable]
		mov	Device1,ax
		mov	bl,cl
		xor	bh,bh

L11:		add	bx,bx
		mov	ax,[bx+offset DGROUP: DCCtable]
		mov	Device0,ax
		mov	byte ptr CGAflag,FALSE
		mov	byte ptr EGAflag,FALSE
		mov	byte ptr Monoflag,FALSE

		lea	bx,Video0Type[di]
		cmp	byte ptr [bx],MDA
		je	L12
		lea	bx,Video1Type[di]
		cmp	byte ptr [bx],MDA
		jne	L13

L12:		mov	word ptr [bx],0
		mov	byte ptr Monoflag,TRUE
L13:		ret

FindPS2		ENDP

FindEGA		proc near
		
		mov	bl,10h
		mov	ah,12h
		int	10h
		cmp	bl,10h
		je	L22
		mov	al,cl
		shr	al,1
		mov	bx,offset DGROUP: EGADisplays
		xlat
		mov	ah,al
		mov	al,EGA
		call	FoundDevice
		cmp	ah,MDADisplay
		je	L21
		mov	CGAflag,FALSE
		jmp	short L22
L21:		mov	Monoflag,FALSE
L22:		ret
FindEGA		ENDP

FindCGA		proc near
		mov	dx,3d4h
		call	Find6845
		jc	L31
		mov	al,CGA
		mov	ah,CGADisplay
		call	FoundDevice
L31:		ret
FindCGA		ENDP

FindMono	proc near

		mov	dx,3b4h
		call	Find6845
		jc	L44
		mov	dl,0bah
		in	al,dx
		and	al,80h
		mov	ah,al
		mov	cx,8000h
L41:		in	al,dx
		and	al,80h
		cmp	ah,al
		loope	L41
		jne	L42
		mov	al,MDA
		mov	ah,MDADisplay
		call	FoundDevice
		jmp	short L44
L42:		in	al,dx
		mov	dl,al
		mov	ah,MDADisplay
		mov	al,HGC
		and	dl,01110000b
		jz	L43
		mov	al,HGCPlus
		cmp	dl,00010000b
		je	L43
		mov	al,InColor
		mov	ah,EGAColorDisplay
L43:		call 	FoundDevice
L44:		ret
FindMono	ENDP

Find6845	proc near
		mov	al,0fh
		out	dx,al
		inc	dx
		in	al,dx
		mov	ah,al
		mov	al,66h
		out	dx,al
		mov	cx,100h
L51:		loop	L51
		in	al,dx
		xchg	ah,al
		out	dx,al
		cmp	ah,66h
		je	L52
		stc
L52:		ret
Find6845	ENDP

FindActive	proc near
		cmp	word ptr Device1,0
		je	L63
		cmp	Video0Type[di],4
		jge	L63
		cmp	Video1Type[di],4
		jge	L63
		mov	ah,0fh
		int	10h
		and	al,7
		cmp	al,7
		je	L61
		cmp	Display0Type[di],MDADisplay
		jne	L63
		jmp	short L62
L61:		cmp	Display0Type[di],MDADisplay
		je	L63
L62:		mov	ax,Device0
		xchg	ax,Device1
		mov	Device0,ax
L63:		ret
FindActive	ENDP

FoundDevice	proc near
		lea	bx,Video0Type[di]
		cmp	byte ptr [bx],0
		je	L71
		lea	bx,Video1Type[di]
L71:		mov	[bx],ax
		ret
FoundDevice	ENDP

_TEXT		ENDS

_DATA		SEGMENT word public 'DATA'

EGADisplays	db	CGADisplay
		db	EGAColorDisplay
		db	MDADisplay
		db	CGADisplay
		db	EGAColorDisplay
		db	MDADisplay

DCCtable	db	0,0
		db	MDA,MDADisplay
		db	CGA,CGADisplay
		db	0,0
		db	EGA,EGAColorDisplay
		db	EGA,MDADisplay
		db	0,0
		db	VGA,PS2MonoDisplay
		db	VGA,PS2ColorDisplay
		db	0,0
		db	MCGA,EGAColorDisplay
		db	MCGA,PS2MonoDisplay
		db	MCGA,PS2ColorDisplay

TestSequence	db	?
		dw	FindPS2
EGAflag		db	?
		dw	FindEGA
CGAflag		db	?
		dw	FindCGA
Monoflag	db	?
		dw	FindMono

NumberOfTests	EQU	($-TestSequence)/3

_DATA		ENDS
		END
