$LARGE
C*********************************************************************
C*** File Name: WPARAM.FOR (Source code for the program XYGRAPH)
C************************************************************************
C SUBROUTINE WRITE PARAM FILE
C 
C Local Arguments:
C  Signature    - Character string to identify parameter file.
C
C This routine extracts the screen field values, checks and formats
C them, and then writes to the parameter file.
C
	SUBROUTINE Write Param File

        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'
$INCLUDE: 'XYGRAPH.CMN'
 
	CHARACTER  Ax sel*4, Blanks*50, Signature*15, Sel Y*10
        CHARACTER  Lcode
 
	LOGICAL*1  Fexist, FIexist

        DATA   Signature  /' XYGRAPH '/

        Fexist = .FALSE.
        FIexist = .FALSE.

C *** Get selected filenames, independent variable and number curves
        CALL Get Character Value ('PREFIX    ', File Prefix)
	CALL Get Character Value ('PARAMETER ', Param File)
        CALL Get Character Value ('METACODE  ', Metacode File)
	CALL Get Character Value ('DATA FILE ', Data File)
	CALL Get Character Value ('OPARAMETER', User Pfile)

        Position = Toggle Position ('XVAR      ')
        CALL Get Toggle Value ('XVAR', Position, Ind Var)

C *** Open parameter file
        ls = Lenstr(File Prefix)
	IF (ls .NE. 0) FIexist = .TRUE.
        Param File = User Pfile

	IF (FIexist) THEN
   	   File Name = File Prefix(1:ls)//Param File
        ELSE
	   File Name = Param File
        ENDIF
	INQUIRE (FILE=File Name, EXIST=Fexist)
        IF (Fexist) THEN 
       	   CALL Open File (13, File Name, 'OLD', Openerr)
        ELSE
       	   CALL Open File (13, File Name, 'NEW', Openerr)
        ENDIF
			   
C *** Write identification signature

        WRITE (13,'(A15)') Signature

C *** Write first 4 records
c        WRITE(13,'(A50)') File Prefix
	WRITE(13,10) Param File,User Pfile,Data File,Metacode File
   10   FORMAT (4(A14,4X))
        WRITE(13,'(A10)') Ind Var 
	WRITE(13,'(I1)') Num Curves

C *** Set/Write curve variable arguments
	DO 15  i = 1, Num Curves
	   Write(Yvarcod,'(A7,I1)') 'Y VAR C', i
	   YPos  = Toggle Position (Yvarcod)
	   CALL Get Toggle Value(Yvarcod, YPos, Sel Y)
  	   Var Args (i,1) = Sel Y

	   Write(Lccod,'(A7,I1)') 'LTYPE C', i
           Lpos = Toggle Position (Lccod)
           WRITE (Lcode,'(I1)') Lpos
           Var Args (i,2) (27:27) = Lcode

	   Write(Sccod,'(A7,I1)') 'STYPE C', i
	   Spos = Toggle Position (Sccod)
           CALL Get Stype(Spos,Scode)
           Var Args (i,5) (18:23) = Scode

	   Write(Cccod,'(A7,I1)') 'COLOR C', i
	   Cpos = Toggle Position (Cccod) + 1
           CALL Get Color(Cpos,Ccode)
 	   Write (Var Args(i,6)(12:35),'(A8,A1)') Ccode, ')'

	   DO 25  j = 1,6
	      IF (j .EQ. 6) CALL Remove Blanks (Var Args(i,j))
	      WRITE (13,'(A35)') Var Args(i,j)
   25      CONTINUE
15      CONTINUE


C *** Set/Write background argument
        Position = Toggle Position ('AXES      ')
	CALL Get Toggle Value('AXES', Position, Ax sel)

	IF (Ax sel .eq. 'Full') THEN
	   Gen Args(1)(18:18) = '1'
	ELSE IF (Ax sel .eq. 'Grid') THEN
	   Gen Args(1)(18:18) = '2'
        ELSE
	   Gen Args(1)(18:18) = '3'
	ENDIF

	WRITE (13,'(A25)') Gen Args(1)

C *** Set/Write Axes arguments
	XY = 'X'
	CALL Set Axis Args (XY)

	XY = 'Y'
	CALL Set Axis Args (XY)

	DO 30  i = 1,8
	   WRITE(13,'(A50)') Xaxis Args(i)
   30   CONTINUE

	DO 40  i = 1,8
	   WRITE(13,'(A50)') Yaxis Args(i)
   40   CONTINUE

C *** Write line & label control arguments
	WRITE (13,'(A25)') Gen Args(2)
	WRITE (13,'(A25)') Gen Args(3)

C *** Set/Write title and axis label arguments
	CALL Get Character Value ('TITLE     ',Titl)
	CALL Get Character Value ('SUBTITLE1 ',STit1)
	CALL Get Character Value ('SUBTITLE2 ',STit2)
	CALL Get Character Value ('X LABEL   ',Xlab)
	CALL Get Character Value ('Y LABEL   ',Ylab)

	ltitl  = Lenstr(Titl)
	lstit1 = Lenstr(STit1)
	lstit2 = Lenstr(STit2)
	lxlab  = Lenstr(Xlab)
	lYlab  = Lenstr(Ylab)

	LabLin Args(1,3)(16:ltitl+15)  = Titl
	LabLin Args(2,3)(16:lstit1+15) = STit1
	LabLin Args(3,3)(16:lstit2+15) = STit2
	LabLin Args(4,3)(16:lxlab+15)  = Xlab
	LabLin Args(5,3)(16:lylab+15)  = Ylab

	LabLin Args(1,3)(ltitl+16:80)  = ' '')'
	LabLin Args(2,3)(lstit1+16:80) = ' '')'
	LabLin Args(3,3)(lstit2+16:80) = ' '')'
	LabLin Args(4,3)(lxlab+16:80)  = ' '')'
	LabLin Args(5,3)(lylab+16:80)  = ' '')'

	DO 50 i = 1,5
	   DO 55 j = 1,3
	      WRITE(13,'(A60)') LabLin Args(i,j)
   55      CONTINUE
 50     CONTINUE

C *** Set/Write legend argument
        Position = Toggle Position ('LEGEND    ')
        CALL Get Toggle Value ('LEGEND', Position, Legend Position)
        WRITE ( 13, '(A6)') Legend Position

C *** Set/Write regression argument
	Position = Toggle Position ('REGRESS    ')
        CALL Get Toggle Value ('REGRESS', Position, Regression)
        WRITE ( 13, '(A3)') Regression

C *** Write user arguments
c       IF (User Args(i) .NE. Blanks) THEN
c          DO 60 k = 1,Maxuser
c             WRITE (13, '(A80)') User Args (k)
c 60       CONTINUE
c       ENDIF

        CLOSE (13)

	RETURN
	END

C************************************************************************
C SUBROUTINE SET AXIS ARGS (XY)
C
C Formal Arguments:
C  XY   - Indicates which axis to process.
C
C This routine extracts the screen values and sets parameter file 
C arguments for X or Y axis.
C
	SUBROUTINE Set Axis Args (XY)

        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'
$INCLUDE: 'XYGRAPH.CMN'

	CHARACTER     Ctlab*6 
	CHARACTER*10  Fldnam, Ctbas, Cttyp, Ctexp, Ctfrac
        CHARACTER*13  Cmin, Cmax, Cscal

	REAL*4        Nmin, Nmax


C *** Min/Max
        WRITE (Fldnam,'(A4,A1)') 'MIN ', XY
        CALL Get 4 Floating Point Value (Fldnam,Nmin)
        WRITE (Cmin,'(F13.3)') Nmin
      
	WRITE (Fldnam,'(A4,A1)') 'MAX ', XY
        CALL Get 4 Floating Point Value (Fldnam,Nmax)
	WRITE (Cmax,'(F13.3)') Nmax

	IF (XY .eq. 'X') THEN
	   WRITE(Xaxis Args(1)(17:50),'(A13,A1)') Cmin, ')'
	   WRITE(Xaxis Args(2)(17:50),'(A13,A1)') Cmax, ')'
           Xmin=Nmin
           Xmax=Nmax
	ELSE
	   WRITE(Yaxis Args(1)(17:50),'(A13,A1)') Cmin, ')'
	   WRITE(Yaxis Args(2)(17:50),'(A13,A1)') Cmax, ')'
           Ymin=Nmin
           Ymax=Nmax
	ENDIF

C *** Scale
	WRITE (Fldnam,'(A6,A1)') 'SCALE ', XY
        Position = Toggle Position (Fldnam)
        CALL Get Toggle Value (Fldnam, Position, Cscal)
	IF (Cscal .eq. '          Log') THEN
	   Cscal = '1'
	ELSE
	   Cscal = '0'
	ENDIF
      
        IF (XY .eq. 'X') THEN
	   WRITE (Xaxis Args(8)(21:50),'(A10,A1)') Cscal, ')'
	   CALL Remove Blanks (Xaxis Args(8))
	ELSE
	   WRITE (Yaxis Args(8)(21:50),'(A10,A1)') Cscal, ')'
	   CALL Remove Blanks (Yaxis Args(8))
	ENDIF

C *** Tic base
	WRITE (Fldnam,'(A8,A1)') 'TIC BAS ', XY
	CALL Get Character Value (Fldnam,Ctbas)

	IF (Ctbas .eq. '   Auto   ')  Ctbas = '1.E36'

        IF (XY .eq. 'X') THEN
	   WRITE (Xaxis Args(4)(30:50),'(A10,A1)') Ctbas, ')'
	   CALL Remove Blanks (Xaxis Args(4))
	ELSE
	   WRITE (Yaxis Args(4)(28:50),'(A10,A1)') Ctbas, ')'
	   CALL Remove Blanks (Yaxis Args(4))
	ENDIF

C *** Tic type
	WRITE (Fldnam,'(A8,A1)') 'TIC TYP ', XY
	Position = Toggle Position (Fldnam)
	CALL Get Toggle Value (Fldnam, Position, Cttyp)
	Cfttyp = Toggle Position (Fldnam) 

        IF (Cttyp .EQ. '   Auto   ') THEN
	   Cttyp = '1.E36'
	   IF (XY .eq. 'X') THEN
	      WRITE (Xaxis Args(3)(30:50),'(A10,A1)') Cttyp, ')'
	      CALL Remove Blanks (Xaxis Args(3))
	   ELSE
	      WRITE (Yaxis Args(3)(28:50),'(A10,A1)') Cttyp, ')'
	      CALL Remove Blanks (Yaxis Args(3))
	   ENDIF
	ELSE
	   IF (XY .eq. 'X') THEN
	      WRITE (Xaxis Args(3)(30:50),'(I1,A2)') Cfttyp, '.)'
	      CALL Remove Blanks (Xaxis Args(3))
	   ELSE
	      WRITE (Yaxis Args(3)(28:50),'(I1,A2)') Cfttyp, '.)'
	      CALL Remove Blanks (Yaxis Args(3))
	   ENDIF
	ENDIF

C *** Tic label
	WRITE (Fldnam,'(A8,A1)') 'TIC LAB ', XY
	Position = Toggle Position (Fldnam)
	CALL Get Toggle Value (Fldnam, Position, Ctlab)

	IF (Ctlab .eq. ' Auto ') Ctlab  = '1.E36'
	IF (Ctlab .eq. ' None ') Ctlab  = '0.'
	IF (Ctlab .eq. 'Scien.') Ctlab  = '1.'
	IF (Ctlab .eq. 'Expon.') Ctlab  = '2.'
	IF (Ctlab .eq. 'No-Exp') Ctlab  = '3.'

	IF (XY .eq. 'X') THEN
	   WRITE (Xaxis Args(5)(32:50),'(A6,A1)') Ctlab, ')'
	   CALL Remove Blanks (Xaxis Args(5))
	ELSE
	   WRITE (Yaxis Args(5)(30:50),'(A6,A1)') Ctlab, ')'
	   CALL Remove Blanks (Yaxis Args(5))
	ENDIF

C *** Tic exponent
	WRITE (Fldnam,'(A8,A1)') 'TIC EXP ', XY
	CALL Get Character Value (Fldnam,Ctexp)

	IF (Ctexp .eq. '   Auto   ')  Ctexp = '1.E36'

        IF (XY .eq. 'X') THEN
	   WRITE (Xaxis Args(6)(36:47),'(A10,A1)') Ctexp, ')'
	   CALL Remove Blanks (Xaxis Args(6))
	ELSE
	   WRITE (Yaxis Args(6)(34:47),'(A10,A1)') Ctexp, ')'
	   CALL Remove Blanks (Yaxis Args(6))
	ENDIF

C *** Tic fraction
	WRITE (Fldnam,'(A8,A1)') 'TIC FRC ', XY
	CALL Get Character Value (Fldnam,Ctfrac)

	IF (Ctfrac .eq. '   Auto   ')  Ctfrac = '1.E36'

        IF (XY .eq. 'X') THEN
	   WRITE (Xaxis Args(7)(36:47),'(A10,A1)') Ctfrac, ')'
	   CALL Remove Blanks (Xaxis Args(7))
	ELSE
	   WRITE (Yaxis Args(7)(34:47),'(A10,A1)') Ctfrac, ')'
	   CALL Remove Blanks (Yaxis Args(7))
	ENDIF


	RETURN
	END

C********************************************************************
C SUBROUTINE GET STYPE (NT, SCODE)
C
C Formal Arguments:
C  NT     -  Stores the toggle position.
C  SCODE  -  Stores the Hershey character code for the symbol.
C 
C This routine gets the HERSHEY character code for the selected symbol
C based on the toggle position.
C
 
	SUBROUTINE Get Stype (nt, Scode)
 
	IMPLICIT INTEGER*4 (A-Z)
 
	CHARACTER*6 Scode
 
	IF (nt .eq. 0) Scode = '''032J'''
	IF (nt .eq. 1) Scode = '''032&'''
	IF (nt .eq. 2) Scode = '''032:'''
	IF (nt .eq. 3) Scode = '''032'''''
	IF (nt .eq. 4) Scode = '''032?'''
	IF (nt .eq. 5) Scode = '''032B'''
	IF (nt .eq. 6) Scode = '''0322'''
  
	RETURN 
	END
 
C********************************************************************
C SUBROUTINE GET COLOR (NT, CCODE)
C
C Formal Arguments:
C  NT     -  Toggle position.
C  CCODE  -  Color code.
C
C This routine returns the  NCAR OPTN specification of color
C based on the selected toggle position.
C  
	SUBROUTINE Get Color (nt, Ccode)
 
	IMPLICIT INTEGER*4 (A-Z)
 
	CHARACTER*8 Ccode
 
 
	IF (nt .eq. 1) Ccode = '''BLACK'''
	IF (nt .eq. 2) Ccode = '''BLUE'''
	IF (nt .eq. 3) Ccode = '''RED'''
	IF (nt .eq. 4) Ccode = '''YELLOW'''
	IF (nt .eq. 5) Ccode = '''GREEN'''
	IF (nt .eq. 6) Ccode = '''BROWN'''

	RETURN
	END
 

       
               
