cdebug
clarge
C**********************************************************
C
      SUBROUTINE HISTO(A,XLOW,HWID,NCELL,NTOT,IOUT)
C
C     HISTO DRAWS A HISTOGRAM FOR INPUT ARRAY A.
C
C     INPUT VARIABLES.
C
C     A()      ARRAY TO HAVE HISTOGRAM PLOTTED.
C     XLOW     UPPER BOUND OF FIRST CLASS INTERVAL.
C     HWID     WIDTH OF A HISTOGRAM CLASS.
C     NCELL    NUMBER OF CLASS CELLS IN HISTOGRAM.
C     NTOT     NUMBER OF INPUT POINTS IN ARRAY A().
C     IOUT     OUTPUT UNIT FOR WRITTING HISTOGRAM.
C
C**********************************************************
C
      CHARACTER *1 IPLUS,IBLNK,IAST,ICEE,NOUT(50)
      DIMENSION JJCEL(15),A(1)
      DATA IPLUS,IBLNK,IAST,ICEE/'+',' ','*','C'/
C
C     ESTABLISH NUMBER OF POINTS IN EACH CLASS.
C
      DO 10 I = 1,NCELL
        JJCEL(I) = 0
 10   CONTINUE
      DO 20 I = 1,NTOT
        IPOS = IFIX((A(I) - XLOW)/HWID) + 1
        IF(IPOS.LT.1)THEN
          IPOS = 1
        ELSEIF(IPOS.GT.NCELL)THEN
          IPOS = NCELL
        ENDIF
        JJCEL(IPOS) = JJCEL(IPOS) + 1
 20   CONTINUE
      XTOT = FLOAT(NTOT)
      X1 = XLOW
C
C     ECHO HEADING TO OUTPUT FILE.
C
      WRITE(IOUT,40)
      IF(NTOT.EQ.0)THEN
        WRITE (IOUT,130)
        GO TO 200
      ENDIF
C
C     GO THROUGH CALCULATIONS FOR EACH CELL.
C
      CUML = 0.0
      DO 125 J = 1,NCELL
        RELA = FLOAT(JJCEL(J))/XTOT
        CUML = CUML + RELA
        MR = RELA*50.0 + 0.5
        MC = CUML*50.0 + 0.5
        DO 50 N = 1,50
          NOUT(N) = IBLNK
 50     CONTINUE
        NOUT(50)=IPLUS
        IF (MC.GE.1) NOUT(MC) = ICEE
        IF (MR) 122,122,120
  120   DO 121 N=1,MR
          NOUT(N)=IAST
  121   CONTINUE
  122   IF (J-NCELL) 123,124,125
  123   WRITE (IOUT,132) JJCEL(J),RELA,CUML,X1,NOUT
        X1 = X1 + HWID
        GO TO 125
  124   WRITE (IOUT,131) JJCEL(J),RELA,CUML,NOUT
  125 CONTINUE
      WRITE (IOUT,133) NTOT
  40  FORMAT(//,40X,'**HISTOGRAM**',//,5X,'OBSV',
     1 5X,'RELA',5X,'CUML',6X,'  UPPER   ',/,5X,3('FREQ',5X),1X,
     2'CELL LIMIT',6X,'0',8X,'20',8X,'40',8X,'60',8X,'80',7X,'100',
     3/,45X,11(4X,'+'))
  130 FORMAT (///,5X,'NO VALUES RECORDED.')
  131 FORMAT (4X,I5,2(4X,F5.3),9X,'INF',10X,'+',50A1)
  132 FORMAT (4X,I5,2(4X,F5.3),5X,E11.4,6X,'+',50A1)
  133 FORMAT (6X,'---',40X,'+',10(4X,'+')/4X,I5,40X,'0',8X,'20',8X,
     1'40',8X,'60',8X,'80',7X,'100')
C
 200  RETURN
      END
