cdebug
clarge
C**********************************************************
C
      SUBROUTINE SCATTR(X,XMIN,XMAX,Y,YMIN,YMAX,NTOT,IOUT)
C
C     SCATTR PLOTS A DIGIT SCATTERGRAM FOR VARIABLES Y
C     VERSUS X ON AN 8 INCH SQUARE PLOT.  NO SCALING OF
C     AXES IS DONE SO UNEQUAL SCALES BETWEEN X AND Y IS
C     POSSIBLE UNLESS RANGES FOR X AND Y ARE THE SAME.
C
C     INPUT VARIABLES.
C
C     X()       INPUT X ARRAY.
C     XMIN      MINIMUM X VALUE TO BE PLOTTED.
C     XMAX      MAXIMUM X VALUE TO BE PLOTTED.
C     Y()       INPUT Y ARRAY.
C     YMIN      MINIMUM Y VALUE TO BE PLOTTED.
C     YMAX      MAXIMUM Y VALUE TO BE PLOTTED.
C     NTOT      NUMBER OF INPUT DATA POINTS.
C     IOUT      UNIT NUMBER OF OUTPUT FILE.
C
C**********************************************************
C
C     VARIABLE DECLARATIONS.
C
      CHARACTER*1 NCOL(81),CHARA(9)
      INTEGER     MCOL(81)
      REAL        XTIC(9),YTIC(9),X(1),Y(1)
      DATA CHARA /'1','2','3','4','5','6','7','8','9'/
C
C     PRELIMINARY CALCULATIONS, IF RANGE BETWEEN X OR Y
C     IS 0.0, THEN SET MIN AND MAX FOR 4 PERCENT ABOVE
C     AND 4 PERCENT BELOW THESE VALUES.
C
      XRAG = XMAX - XMIN
      YRAG = YMAX - YMIN
      IF(XRAG.EQ.0.0)THEN
        IF(XMIN.EQ.0.0)THEN
          XMIN = -1.0
          XMAX = 1.0
          XRAG = 2.0
        ELSE
          XMIN = 0.8*XMIN
          XMAX = 1.2*XMAX
          XRAG = XMAX - XMIN
        ENDIF
      ENDIF
      IF(YRAG.EQ.0.0)THEN
        IF(YMIN.EQ.0.0)THEN
          YMIN = -1.0
          YMAX = 1.0
          YRAG = 2.0
        ELSE
          YMIN = 0.8*YMIN
          YMAX = 1.2*YMAX
          YRAG = YMAX - YMIN
        ENDIF
      ENDIF
      DO 10 I = 1,9
        XTIC(I) = XMIN + FLOAT(I-1)*XRAG/8.0
        YTIC(I) = YMIN + FLOAT(I-1)*YRAG/8.0
 10   CONTINUE
C
      WRITE(IOUT,20) XTIC
 20   FORMAT(/,45X,'**SCATTERGRAM**',/,12X,9E10.3)
C
      DO 200 IROW = 49,1,-1
        DO 30 ICOL = 1,81
          NCOL(ICOL) = ' '
          MCOL(ICOL) = 0
 30     CONTINUE
        IF(IROW.EQ.1.OR.IROW.EQ.49)THEN
          DO 40 K = 1,81,10
            NCOL(K) = '+'
 40       CONTINUE
        ENDIF
        DO 50 K = 1,49,6
          IF(K.EQ.IROW)THEN
            NCOL(1)  = '+'
            NCOL(81) = '+'
          ENDIF
 50     CONTINUE
        DO 60 I = 1,NTOT
          IYPOS = IFIX(48.0*(Y(I) - YMIN)/YRAG) + 1
          IF(IYPOS.EQ.IROW)THEN
            IXPOS = IFIX(80.0*(X(I) - XMIN)/XRAG) + 1
            IF(IXPOS.GE.1.AND.IXPOS.LE.81)THEN
              MCOL(IXPOS) = MCOL(IXPOS) + 1
            ENDIF
          ENDIF
 60     CONTINUE
        DO 70 I = 1,81
          IF(MCOL(I).GT.9)THEN
            NCOL(I) = '*'
          ELSEIF(MCOL(I).GE.1.AND.MCOL(I).LE.9)THEN
            NCOL(I) = CHARA(MCOL(I))
          ENDIF
 70     CONTINUE
C
        ISIG = 0
        DO 80 I = 1,9
          J = (I-1)*6 + 1
          IF(J.EQ.IROW)THEN
            ISIG = 1
            YSIG = YTIC(I)
          ENDIF
 80     CONTINUE
        IF(ISIG.EQ.0)THEN
          WRITE(IOUT,90) NCOL
 90       FORMAT(21X,81A1)
        ELSE
          WRITE(IOUT,100) YSIG,NCOL
 100      FORMAT(11X,E10.3,81A1)
        ENDIF
 200  CONTINUE
C
      WRITE(IOUT,210) XTIC
 210  FORMAT(12X,9E10.3)
      WRITE(IOUT,220)
 220  FORMAT(//,46X,' **LEGEND**',/,
     1 20X,' VALUES 1-9 INDICATES NUMBER OF POINTS AT SCATTERGRAM',
     2     ' LOCATION.',/,
     3 20X,' VALUE OF * INDICATES MORE THAN 9 POINTS AT SCATTERGRAM',
     4     ' LOCATION.')
C
      RETURN
      END
