#ifndef XENIX
#include <fcntl.h>
/*
  setblock - turn blocking on or off
             Taken from Advanced UNIX Programmin, Sec 4.3
             Enhanced for 4.2 and 4.3 BSD.
             Impossible to implement on Version 7 Xenix.

	     I found it in Advanced C Programming for Displays,
	     by Marc J. Rochkind, sec 4.1.2.
*/
static void setblock(fd,on)
int fd;
int on;
{
  static int blockf, nonblockf;
  static int first = 0;
  static int ndelay = O_NDELAY;
  int flags;

  if (first) {
    first = 1;
    if ((flags = fcntl(fd, F_GETFL, 0)) == -1)
      syserr("fcntl");
    blockf = flags & ndelay; /* make sure O_NDELAY is off */
    nonblockf = flags | ndelay; /* make sure O_NDELAY is on */
  }
  if (fcntl(fd, F_SETFL, on ? blockf : nonblockf) == -1)
    syserr("fcntl2");
}
#endif
