cc $LARGE
C Util.for 
c----------------------------------------------------------------------
c ***	subroutine SearchB - binary search of a vector
c	- returns index of first element <= target in vector

	subroutine SearchB (vector,n,target,index)

	real*4	vector (1), target
	integer*4 n, index, lower, upper, middle

	if(target .lt. vector(1)) then
	   index = 0
	   return
	elseif(target .ge. vector(n)) then
	   index = n+1
	   return
	endif

	lower = 1
	upper = n
 10	middle = (upper + lower)/2
	if(vector(middle) .gt. target) then
	  upper = middle
	elseif(vector(middle) .lt. target) then
	  lower = middle
	elseif(vector(middle) .eq. target) then
	  index = middle
	  return
	endif
	if(lower+1 .ge. upper) then
	    index = lower
	    return
	endif
	goto 10
	end	



c----------------------------------------------------------------------
	real*4 function rmax(a,n)
	real*4	a, t
	integer*4 i, n
	dimension a(n)
	t = a(1)
	do 10 i = 2,n
10	  T = AMAX1 (a(i), T)
	rmax = t
	return
	end
c----------------------------------------------------------------------
	real*4 function rmin(a,n)
	real*4	a, t
	integer*4 i, n
	dimension a(n)
	t = a(1)
	do 10 i = 2,n
10	  T = AMIN1 (a(i), t)
	rmin = t
	return
	end

C----------------------------------------------------------------------
C Stats - calculate stats for a given variable

	SUBROUTINE Stats (Var, Ndata, N, Nmiss, 
     +                         Min, Q1, Median, Q3, Max,
     +                         Mean, StdDev)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAXDATA = 1000)

	REAL*4     Var (1), Min, Q1, Median, Q3, Max, Mean, StdDev
	REAL*8	   Sum, SumSq, Term1, Term2
	REAL*4	   Missing, V (MAXDATA)
	INTEGER*4	I, J, N,  Nmiss, Ndata, Q1Lim, Q2Lim, Q3Lim 
	INTEGER*4	TN

	DATA Missing 	/1.E31/

	IF (NDATA .EQ. 0) RETURN

	Min	= 0.0
	Max 	= 0.0
	Median	= 0.0
	Q1	= 0.0
	Q3	= 0.0
	Mean	= 0.0
	StdDev	= 0.0
	Sum   	= 0.0
	SumSq 	= 0.0
	NMiss 	= 0
	N	= 0
	DO 20 I = 1, Ndata
	   IF (Var (I) .LT. Missing) THEN
              N 	= N + 1
              V (N) 	= Var (I) 
	      Sum 	= Sum   + V (N)
	      SumSq 	= SumSq + (V(N) * V(N))
	   ELSE
              NMiss = NMiss + 1  
	   ENDIF   	
 20	CONTINUE
	
	IF (N .GT. 0) THEN
	   Q1Lim 	= IFIX (N*.25)
	   Q2Lim	= IFIX (N*.50)
	   Q3Lim	= IFIX (N*.75)
	   CALL Qsort1 (V, N)
	   Min 		= V (1)
	   Q1  		= V (Q1Lim)
	   Median 	= V (Q2Lim)
	   Q3		= V (Q3Lim)
	   Max		= V (N)
	   Mean		= Sum / N
	   TN		= N * (N-1) 
	   Term1	= N * SumSq
	   Term2	= Sum * Sum
	   IF ((Term1-Term2) .LT. 1.E-10) THEN
                StdDev  = 0.0
	   ELSE 
	   	StdDev 	= SQRT ((Term1 - Term2) / TN)
	   ENDIF
	ENDIF
	RETURN
	END	
C----------------------------------------------------------------------
C ***	NONRECURSIVE QUICK SORT SUBROUTINE

      SUBROUTINE QSORT (A, P, N)

	IMPLICIT INTEGER*4 (A-Z)

	REAL*4 		A (N), T,  T1
cclong	INTEGER*4 	Tp, P (N)
	INTEGER*4 	Tp, P (N)
cc
	DIMENSION 	LOWER(500),  UPPER(500)

		M	= 1
		I1	= 1
		J1	= N
		I	= I1
		J	= J1

 10		IF (I .GE. J) GOTO 110
 20		K = I
		I2 = INT ((J + I)/2)
C-------------------------------
		T = A(I2)
		TP = P(I2)
C-------------------------------
		IF (A(I) .LE. T) GOTO 30
C-------------------------------
		A(I2) = A(I)
		P(I2) = P(I)
		A(I) = T
		P(I) = TP
		T = A(I2)
		TP = P(I2)
C-------------------------------
 30		L = J
		IF (A(J) .GE. T) GOTO 40
C-------------------------------
		A(I2) = A(J)
		P(I2) = P(J)
		A(J) = T
cclong
cc	print *,' j',j,' a(j)',a(j),' tp',tp,' p(j)',p(j),' n',n
		P(J) = TP
		T = A(I2)
		TP = P(I2)
C-------------------------------
		IF (A(I) .LE. T) GOTO 40
C-------------------------------
		A(I2) = A(I)
		P(I2) = P(I)
		A(I) = T
		P(I) = TP
		T = A(I2)
		TP = P(I2)
C-------------------------------
 40		L = L - 1
		IF (A(L) .GT. T) GOTO 40
C-------------------------------
		T1 = A(L)
		TP1 = P(L)
C-------------------------------
 50		K = K + 1
		IF (A(K) .LT. T) GOTO 50
		IF (K .GT. L) GOTO 60
C-------------------------------
		A(L) = A(K)
		P(L) = P(K)
		A(K) = T1
		P(K) = TP1
C--------------------------------
		GO TO 40

 60		IF (L-I .LE. J-K) GOTO 70
		LOWER(M) = I
		UPPER(M) = L
		I = K
		M = M+1
		GOTO 80
 70		LOWER(M) = K
		UPPER(M) = J
		J = L
		M = M+1
 80		IF (J-I .GE. I1) GOTO 20
		IF (I .EQ. I1) GOTO 10
		I = I-1
 90		I = I+1
		IF (I .EQ. J) GOTO 110
C-------------------------------
		T = A(I+1)
		TP = P(I+1)
C-------------------------------
		IF (A(I) .LE. T) GOTO 90
		K = I
C-------------------------------
 100		A(K+1) = A(K)
		P(K+1) = P(K)
C-------------------------------
		K = K-1
		IF (T .LT. A(K)) GOTO 100
C--------------------------------
		A(K+1) = T
		P(K+1) = TP
C--------------------------------
		GOTO 90
 110		M = M - 1
		IF (M .EQ. 0 ) GOTO 999
		I = LOWER(M)
		J = UPPER(M)
		GO TO 80
 999		RETURN
		END	

C----------------------------------------------------------------------
C ***	NONRECURSIVE QUICK SORT SUBROUTINE

		SUBROUTINE QSORT1(A,N)
		IMPLICIT INTEGER*4 (A-Z)
		REAL*4  A, T, T1
		INTEGER*4 N
		DIMENSION LOWER(500), UPPER(500), A (N)

		M	= 1
		I1	= 1
		J1	= N
		I	= I1
		J	= J1

 10		IF (I .GE. J) GOTO 110
 20		K = I
		I2 = INT ((J + I)/2)
		T = A(I2)
		IF (A(I) .LE. T) GOTO 30
		A(I2) = A(I)
		A(I) = T
		T = A(I2)
 30		L = J
		IF (A(J) .GE. T) GOTO 40
		A(I2) = A(J)
		A(J) = T
		T = A(I2)
		IF (A(I) .LE. T) GOTO 40
		A(I2) = A(I)
		A(I) = T
		T = A(I2)
 40		L = L - 1
		IF (A(L) .GT. T) GOTO 40
		T1 = A(L)
 50		K = K + 1
		IF (A(K) .LT. T) GOTO 50
		IF (K .GT. L) GOTO 60
		A(L) = A(K)
		A(K) = T1
		GO TO 40

 60		IF (L-I .LE. J-K) GOTO 70
		LOWER(M) = I
		UPPER(M) = L
		I = K
		M = M+1
		GOTO 80
 70		LOWER(M) = K
		UPPER(M) = J
		J = L
		M = M+1
 80		IF (J-I .GE. I1) GOTO 20
		IF (I .EQ. I1) GOTO 10
		I = I-1
 90		I = I+1
		IF (I .EQ. J) GOTO 110
		T = A(I+1)
		IF (A(I) .LE. T) GOTO 90
		K = I
 100		A(K+1) = A(K)
		K = K-1
		IF (T .LT. A(K)) GOTO 100
		A(K+1) = T
		GOTO 90
 110		M = M - 1
		IF (M .EQ. 0 ) GOTO 999
		I = LOWER(M)
		J = UPPER(M)
		GO TO 80
 999		RETURN
		END	
