C*********************************************************************
C*** File Name: \GEOEAS\CORRES\RSTSCR.FOR 
C*** Source code for the program CORRES
C*********************************************************************
cclong
cc        INTERFACE TO INTEGER*4 FUNCTION SYSTEM [C,ALIAS:' system']
cc     1  (COMMAND)
cc        INTEGER*4 COMMAND
cc        END

C*********************************************************************
C SUBROUTINE Results Menu
C
C Local Variables:
C  RstMenu    - Name of the results menu in the screen definition file.
C  RstScreen  - Number of the results screen in the screen definition
C                file.
C  FExist     - Logical variable set to .TRUE. if the file exists.
C 
C This routine displays the results screen, accesses the menu option
C selected by the user then calls the routine to process the menu
C option. 
C
	SUBROUTINE Results Menu

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'corres.inc'
		INCLUDE 'screen.str'

        CHARACTER*3   Quote
        CHARACTER*10  RstMenu
        CHARACTER*14  GraphFile
        CHARACTER*70  Program, fmt
ccc        INTEGER*4     SYSTEM, ReturnCode
cclong
        REAL*8  newline(maxvar)
cclong
        INTEGER*4     RstScreen
        LOGICAL       FExist, Exists

        DATA RstMenu    /'RS MENU   '/
        DATA RstScreen  /5/

        Quote = ''''

C *** Set up the screen
10      CALL Get New Screen (RstScreen)
        CALL Dsp Results Screen

15      CALL Put Menu (RstMenu)

        CALL Get Menu Choice (RstMenu,MenuChoice)

C *** QUIT
        IF (MenuChoice .EQ. 'Quit          ') THEN
           RETURN
   
C *** BROWSE                   
        ELSEIF (MenuChoice .EQ. 'Browse      ') THEN
           IF (NVar .LT. 11) GOTO 15
           INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	   IF (.NOT. Exists) THEN
	      CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
              GOTO 15
           ENDIF
           CALL Get F Name (FileName, FilePrefix, 'CA ERPROF.DAT',
     +                      FExist)
           OPEN (UNIT = 12, FILE = FileName,status='unknown')
           WRITE (12, '(A60)') 'Analysis of the Error'
           WRITE (12, '(I2)') 2
           WRITE (12, '(A10, 10X, A10)') 'REC. ERROR', 'G30.3     ' 
           WRITE (12, '(A10, 10X, A10)') 'SUM CR.   ', 'F20.2      ' 
           DO 30 j = 1, NVar
              WRITE (12, '(G37.3, 1X, F25.2, 1X, A1, A10, A1)')
     +             PEJ (j), CCRJ (j), Quote, VarNam (j), Quote
 30        CONTINUE
           CLOSE (12)
 	   CALL Write System Defaults (FilePrefix, 'CA ERPROF.DAT ')
           Program = 'BROWSE' // CHAR (0)
           ReturnCode = 0
cc           ReturnCode = SYSTEM (LOC (Program))
           IF (ReturnCode .NE. 0) THEN
              CALL Ers Line (20, 2, 75)
              CALL Flash (20, 2, 'ERROR loading BROWSE')
           ENDIF

        ELSEIF (MenuChoice .EQ. 'Samples     ') THEN
           INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	   IF (.NOT. Exists) THEN
	      CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
              GOTO 15
           ENDIF
	   CALL Write System Defaults (FilePrefix, SampFile)
           Program = 'BROWSE'
           ReturnCode = 0
cc           ReturnCode = SYSTEM (LOC (Program))
 
           IF (ReturnCode .NE. 0) THEN
              CALL Ers Line (20, 2, 75)
              CALL Flash (20, 2, 'ERROR loading BROWSE')
           ENDIF
      
        ELSEIF (MenuChoice .EQ. 'Variables   ') THEN
           INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	   IF (.NOT. Exists) THEN
	      CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
              GOTO 15
           ENDIF
	   CALL Write System Defaults (FilePrefix, VarFile)
           Program = 'BROWSE'
           ReturnCode = 0
cc           ReturnCode = SYSTEM (LOC (Program))
 
           IF (ReturnCode .NE. 0) THEN
              CALL Ers Line (20, 2, 75)
              CALL Flash (20, 2, 'ERROR loading BROWSE')
           ENDIF

        ELSEIF (MenuChoice .EQ. 'Reconstructe') THEN
           IF (RFlag) THEN
              INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	      IF (.NOT. Exists) THEN
	         CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
                 GOTO 15
              ENDIF
	      CALL Write System Defaults (FilePrefix, ReconFile)
              Program = 'BROWSE'
              ReturnCode = 0
cc              ReturnCode = SYSTEM (LOC (Program))
 
              IF (ReturnCode .NE. 0) THEN
                 CALL Ers Line (20, 2, 75)
                 CALL Flash (20, 2, 'ERROR loading BROWSE')
              ENDIF
           ELSE
              CALL Flash (20, 2, ' Not Computed ')
              GOTO 15
           ENDIF

        ELSEIF (MenuChoice .EQ. 'Residuals   ') THEN
           IF (RFlag) THEN
              INQUIRE (FILE = 'browse.exe', EXIST = Exists)
      	      IF (.NOT. Exists) THEN
	         CALL FLASH (20, 2, ' BROWSE.EXE not found. ')
                 GOTO 15
              ENDIF
	      CALL Write System Defaults (FilePrefix, ResidFile)
              Program = 'BROWSE'
              ReturnCode = 0
cc              ReturnCode = SYSTEM (LOC (Program))
 
              IF (ReturnCode .NE. 0) THEN
                 CALL Ers Line (20, 2, 75)
                 CALL Flash (20, 2, 'ERROR loading BROWSE')
              ENDIF
           ELSE
              CALL Flash (20, 2, ' Not Computed ')
              GOTO 15
           ENDIF

        ELSEIF (MenuChoice .EQ. 'Write       ') THEN
            CALL Wrt Menu

        ELSEIF (MenuChoice .EQ. '3-d-spin    ') THEN

ccclong
           f = Fld Index ('GRAPHFILE')
           i = sc members (f)
           IF (RFLAG) THEN
              CALL Set T Value ('GRAPHFILE',0, SampFile)
              CALL Set T Value ('GRAPHFILE',1, VarFile)
              CALL Set T Value ('GRAPHFILE',2, ResidFile)
              CALL Set T Value ('GRAPHFILE',3, ReconFile)
              CALL Set T Value ('GRAPHFILE',4, dataFile)
              if (outfile_on) then
                 CALL Set T Value ('GRAPHFILE',5, outFile)
              else
                 CALL Set T Value ('GRAPHFILE',5, '')
              end if
           ELSE
              SC Members (f) = 4
              CALL Set T Value ('GRAPHFILE',0, SampFile)
              CALL Set T Value ('GRAPHFILE',1, VarFile)
              CALL Set T Value ('GRAPHFILE',2, dataFile)
              if (outfile_on) then
                 CALL Set T Value ('GRAPHFILE',3, outFile)
              else
                 CALL Set T Value ('GRAPHFILE',3, '')
              end if
           ENDIF
           CALL Get Field
           CALL Get Toggle Value ('GRAPHFILE', Position, GraphFile)
           SC Members (f) = i
ccclong
           CALL Ers Line (20, 2, 78)  

           OPEN (UNIT=12, FILE=fileprefix(1:lenstr(fileprefix))
     &          //graphfile, status='unknown',err=667)
           OPEN (UNIT=13, FILE=fileprefix(1:lenstr(fileprefix))
     &          //graphfile(1:lenstr(graphfile))//'.xgobi'
     &          , status='unknown',err=667)
           OPEN (UNIT=14, FILE=fileprefix(1:lenstr(fileprefix))
     &          //graphfile(1:lenstr(graphfile))//'.xgobi.col'
     &          , status='unknown',err=667)
           read(12,*,err=667,end=667) header
           read(12,*,err=667,end=667) j
           do i = 1, j
              read(12,'(a)',err=667,end=667) program
              write(14,'(a)') program(1:10)
           enddo
           fmt = '(  (e12.5,x))'
           write(fmt(2:3),'(i2)') j
 665       read(12,*,err=666,end=666) (newline(i),i=1,j)
           write(13,fmt,err=666) (newline(i),i=1,j)
           goto 665
 666       CLOSE (12)
           CLOSE (13)
           CLOSE (14)
           call system ('xgobi '//fileprefix(1:lenstr(fileprefix))//
     &          graphfile(1:lenstr(graphfile))//'.xgobi &')

        ENDIF
 667    GOTO 10
        END     


C*********************************************************************
C SUBROUTINE Dsp Results Screen
C
C This routine displays the reconstruction and representation errors
C on the results screen.
C 
        SUBROUTINE Dsp Results Screen

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'corres.inc'

        CHARACTER CPEJ*12, CCCRJ*6
        INTEGER*4 Row

        Row = 8
        DO 5 i = 1, NVar
           IF (Row .LE. 18) THEN
              CALL Put Str (VarNam(i),10,row, 7, 0)
              WRITE (CPEJ, '(E12.3)') PEJ (I)
              CALL Put Str (CPEJ,12, row, 25,0)
              WRITE (CCCRJ, '(F6.2)') CCRJ (I)
              CALL Put Str (CCCRJ, 6, Row, 57, 0)
              Row = Row + 1
           ENDIF
 5      CONTINUE

        RETURN 
        END
