clarge
c**********************************************************************
c*** File name: PREP13.FOR (Source code for the program DATAPREP)
c**********************************************************************
c        D e l e t e  P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Delete Prompts

c***  This routine constructs the Delete screen and displays
c***  the Delete menu.  The user is prompted for a menu 
c***  selection which is then processed.  The subroutine 'Delete File'
c***  which is called from this routine, performs the deletion.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Delete menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***  Tinfile	  - contains the name of the incoming Geo-EAS input
c***                data file.
c***

       include 'dataprep.dec'
       include '../common/screen.str'
		   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      CHARACTER   Tinfile*14
      CHARACTER   Label1*19,Label2*17,Label3*15
      LOGICAL   Exist, Error, Yes, Get Yes No
      INTEGER*4   FLD Index
      INTEGER*4   Returncode

c***  Erase the DOS Utilities screen.
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***      Blank = '              '
      Menu  = 'DL MENU   '
      Yes   = .FALSE.
      Error = .TRUE.

c***  Initialize and display labels upon the screen.
      Label1 = 'File to be deleted:'
      Label2 = 'Data File Prefix:'
      Label3 = 'DELETE FUNCTION'
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Put Str (Label1, 19,  5,  2, 0)
      CALL Put Str (Label2, 17,  3,  2, 0)
      CALL Put Str (Label3, 15,  2, 32, 0)
c***  Initialize and display file name.
      CALL Set Character Value ('DELETEFL', Infil)
      Tinfile = Infil
cccc      CALL Display One Field('DELETEFL')
c*** Display Delete menu and prompt user for choice ***
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Erase the Delete screen.
        CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
        CALL Build Prefix Filename (Tinfile)
c***    If the incoming Geo-EAS input data file still exists then store
c***    that file name into the global variable 'Infil' else insert
c***    white space.
        INQUIRE (FILE = Prefile, EXIST = Exist)
	IF (Exist) THEN
	  Infil  = Tinfile
	ELSE 
	  Infil = '              '
	ENDIF
  	RETURN
      ELSE IF (Menu Choice .EQ. 'File                ') THEN
c***  Prompt user for name of file to be deleted.
	File = 'DELETEFL'
	CALL Get DOS Filename(File,Infil,Error,1,2)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter filename...(Press any key)')
	  GOTO 10
	ELSE
         Yes = Get Yes No (20, 2,
     +        'Do you really want to delete this file? <Y/N>')
	 IF (Yes) THEN
           CALL Delete File (Infil, Returncode)
	   IF (Returncode .EQ. -1) THEN
             CALL Flash (20, 2,
     +           'File was not deleted...(Press any key)')
	   ELSE 
             CALL Flash (20, 2,
     +           ' File has been deleted...(Press any key)')
	   ENDIF
	 ENDIF
	ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        R e n a m e   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Rename Prompts

c***  This routine constructs the Rename screen and displays
c***  the Rename menu.  The user is prompted for a menu 
c***  selection which is then processed.  The subroutine 'Rename File'
c***  which is called from this routine, executes the DOS 'Rename' command.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Rename menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***  Tinfile	  - contains the name of the incoming Geo-EAS input
c***                data file.
c***

       include 'dataprep.dec'
       include '../common/screen.str'
		   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      CHARACTER   Tinfile*14
      CHARACTER   Label1*17,Label2*13,Label3*17,Label4*15
      LOGICAL   Exist, Yes, Get Yes No, Error
      INTEGER*4   Returncode
      INTEGER*4   FLD Index

c***  Erase the DOS Utilities screen.
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***      Blank = '              '
      Menu  = 'RN MENU   '
      Error = .TRUE.

c***  Initialize and display labels upon the screen.
      Label1 = 'Current Filename:'
      Label2 = 'New Filename:'
      Label3 = 'Data File Prefix:'
      Label4 = 'RENAME FUNCTION'
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Put Str (Label1, 17,  5,  2, 0)
      CALL Put Str (Label2, 13,  5, 39, 0)
      CALL Put Str (Label3, 17,  3,  2, 0)
      CALL Put Str (Label4, 15,  2, 32, 0)
      CALL Set Character Value ('OLDNAME ', Infil)
      Tinfile = Infil
      CALL Set Character Value ('NEWNAME ', Outfile1)
cccc      CALL Display One Field('OLDNAME')
cccc      CALL Display One Field('NEWNAME')
c***  Display Rename menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Erase the Rename screen.
	CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
        CALL Build Prefix Filename (Tinfile)
c***    If the incoming Geo-EAS input data file still exists then store
c***    that file name into the global variable Infil else insert
c***    white space.
        INQUIRE (FILE = Prefile, EXIST = Exist)
	IF (Exist) THEN
	  Infil  = Tinfile
	ELSE 
	  Infil = '              '
	ENDIF
   	RETURN
      ELSE IF (Menu Choice .EQ. 'Files               ') THEN
c***  Prompt user for old filename.
	File = 'OLDNAME '
	CALL Get DOS Filename(File,Infil,Error,1,4)
c***    If error return to menu.
	IF (Error) GOTO 10
c***    Prompt user for new filename.
	File = 'NEWNAME '
	CALL Get DOS Filename(File,Outfile1,Error,2,4)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter correct filenames...(Press any key)')
	  GOTO 10
	ELSE
          Yes = Get Yes No (20, 2,
     +        'Do you really want to rename this file? <Y/N>')
	  IF (Yes) Then
            CALL Rename File (Infil, Outfile1, Returncode)
	    IF (Returncode .EQ. 0) THEN
              CALL Flash (20, 2,
     +         ' File has been renamed...(Press any key)')
	    ELSE
              CALL Flash (20, 2,
     +           'File could not be renamed...(Press any key)')
	    ENDIF
	  ENDIF
	ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        C o p y   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Copy Prompts

c***  This routine constructs the Copy screen and displays
c***  the Copy menu.  The user is prompted for a menu 
c***  selection which is then processed.  The subroutine 'Copy File'
c***  which is called from this routine, executes the DOS 'Copy' command.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Copy menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***

       include 'dataprep.dec'
       include '../common/screen.str'
	   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      CHARACTER   Label1*18,Label2*16,Label3*17,Label4*13
      INTEGER*4   FLD Index
      INTEGER*4   Returncode
      LOGICAL   Yes, Get Yes No, Error

c***  Erase the DOS Utilities screen.
      CALL Erase Message Divider
      CALL ClearRows(1,18)
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***      Blank = '              '
      Menu  = 'CO MENU   '
      Error = .TRUE.
c*** Initialize and insert labels ***
      Label1 = 'File to copy from:'
      Label2 = 'File to copy to:'
      Label3 = 'Data File Prefix:'
      Label4 = 'COPY FUNCTION'
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Put Str (Label1, 18,  5,  2, 0)
      CALL Put Str (Label2, 16,  5, 39, 0)
      CALL Put Str (Label3, 17,  3,  2, 0)
      CALL Put Str (Label4, 13,  2, 33, 0)
c***  Display the file names.
      CALL Set Character Value ('OLDFILE ', Infil)
      CALL Set Character Value ('NEWFILE ', Outfile1)
cccc      CALL Display One Field('OLDFILE')
cccc      CALL Display One Field('NEWFILE')
c*** Display the Copy menu and prompt user for choice ***
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Erase the Copy screen.
	CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
  	RETURN
      ELSE IF (Menu Choice .EQ. 'Files               ') THEN
c***    Prompt user for the old filename.
	File = 'OLDFILE '
	CALL Get DOS Filename(File,Infil,Error,1,1)
c***    If error return to menu.
	IF (Error) GOTO 10
c***    Prompt user for the new filename.
	File = 'NEWFILE '
	CALL Get DOS Filename(File,Outfile1,Error,2,1)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter correct filenames...(Press any key)')
	  GOTO 10
	ELSE
          Yes = Get Yes No (20, 2,
     +        'Do you really want to copy this file? <Y/N>')
	  IF (Yes) Then
            CALL Copy File(Infil, Outfile1, Returncode)
	    CALL Erase (20, 2, 70)
	    CALL Erase (22, 2, 70)
            CALL Put Menu (Menu)
	    IF (Returncode .EQ. -1) THEN
              CALL Flash (20, 2,
     +           'Path to file is too long...(Press any key)')
	    ELSE
              CALL Flash (20, 2,
     +           ' File has been copied...(Press any key)')
	    ENDIF
	  ENDIF
	ENDIF

      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        P r i n t  P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Print Prompts

c***  This routine constructs the Print screen via a call to
c***  'Display Print Screen' and displays the Print menu.  The user 
c***  is prompted for a menu selection which is then processed.  The 
c***  subroutine 'Print File' which is called from this routine, 
c***  executes the DOS 'Print' command.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Print menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***

       include 'dataprep.dec'
       include '../common/screen.str'
		   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      LOGICAL   Error, Yes, Get Yes No
      INTEGER*4   Returncode
      INTEGER*4   FLD Index

c***      Blank = '              '
      Menu  = 'PT MENU   '
      Error = .TRUE.
      Yes   = .FALSE.

      CALL Display Print Screen
c***  Display the Print menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
        CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
  	RETURN
      ELSE IF (Menu Choice .EQ. 'File                ') THEN
c***  Prompt user for name of file to be printed ***
	File = 'DELETEFL'
	CALL Get DOS Filename(File,Infil,Error,1,3)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter filename...(Press any key)')
	  GOTO 10
	ELSE
          Yes = Get Yes No (20, 2,
     +        ' Is the printer ready? <Y/N>')
	 IF (Yes) THEN
           CALL Clear Screen
	   CALL Print File (Infil, Returncode)
c***       Clear screen of any DOS prompts that may have resulted
c***       from the call to 'Print File'.
           CALL Clear Screen
c***       Display the Print screen.
           CALL Set Screen(2)
           CALL Display Frame
           CALL Display Labels
           CALL Display Print Screen
c***       Display the name of the printed file.
	   CALL Display One Field('DELETEFL')
           CALL Put Menu (Menu)
           IF (Returncode .EQ. -1) THEN
             CALL Flash (20, 2,
     +           'File was not be printed...(Press any key)')
	   ELSE 
             CALL Flash (20, 2,
     +           ' File is being printed...(Press any key)')
	   ENDIF
	 ENDIF
	ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        D i s p l a y   P r i n t   S c r e e n     (subroutine)
c**********************************************************************
      SUBROUTINE Display Print Screen

c***  This routine constructs the Print screen.
c***
c***  VARIABLES:
c***  Label1 - contains screen labels.
c***  Label2 - contains screen labels.
c***  Label3 - contains screen labels.


       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER   Label1*19, Label2*17, Label3*14
	
c***  Erase the DOS Utilities screen.
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***  Initialize and insert labels.
      Label1 = 'File to be printed:'
      Label2 = 'Data File Prefix:'
      Label3 = 'PRINT FUNCTION'
      CALL Put Str (Label1, 19,  5,  2, 0)
      CALL Put Str (Label2, 17,  3,  2, 0)
      CALL Put Str (Label3, 14,  2, 33, 0)
      CALL Put Str (Prefix, 55,  3, 20, 0)
c***  Display the name of the current global infile.
      CALL Set Character Value ('DELETEFL', Infil)
cccc      CALL Display One Field('DELETEFL')
 
      RETURN
      END
c**********************************************************************
c        L i s t   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE List Prompts

c***  This routine constructs the List screen, via a call to the
c***  subroutine 'Display List Screen', and displays
c***  the List menu.  The user is prompted for a menu 
c***  selection which is then processed.  The subroutine 'List File' 
c***  which is called from this routine, executes the DOS 'More' command.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the List menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.

       include 'dataprep.dec'
       include '../common/screen.str'
  
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      LOGICAL   Error, Yes, Get Yes No
      INTEGER*4   Returncode
      INTEGER*4   FLD Index

c***      Blank = '              '
      Menu  = 'LT MENU   '
      Error = .TRUE.
      Yes   = .FALSE.

      CALL Display List Screen
c***  Display List menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Insert white space into the screen field that displays 
c***    the name of the listed file.
	CALL Set Filename Blank('DELETEFL')
c***    Erase the List screen.
        CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
  	RETURN
      ELSE IF (Menu Choice .EQ. 'File                ') THEN
c***    Prompt user for name of file to be listed.
	File = 'DELETEFL'
	CALL Get DOS Filename(File,Infil,Error,1,5)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter filename...(Press any key)')
	  GOTO 10
	ELSE
c***      Clear the screen so that the file can be listed.
          CALL Clear Screen
	  CALL List File (Infil, Returncode)
c***      After the file has been listed, display the List screen.
          CALL Clear Screen
          CALL Set Screen(2)
          CALL Display Frame
          CALL Display Labels
          CALL Display List Screen
	  CALL Display One Field('DELETEFL')
          CALL Put Menu (Menu)
          IF (Returncode .EQ. -1) 
     +      CALL Flash (20, 2,
     +          'Cannot list file...(Press any key)')
	ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        D i s p l a y   L i s t   S c r e e n     (subroutine)
c**********************************************************************
      SUBROUTINE Display List Screen

c***  This routine constructs the List screen.
c***
c***  VARIABLES:
c***  Label1 - contains screen labels.
c***  Label2 - contains screen labels.
c***  Label3 - contains screen labels.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER   Label1*19, Label2*17, Label3*13
	
c***  Erase the DOS Utilities screen.
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***  Initialize and insert labels.
      Label1 = 'File to be listed:'
      Label2 = 'Data File Prefix:'
      Label3 = 'LIST FUNCTION'
      CALL Put Str (Label1, 19,  5,  2, 0)
      CALL Put Str (Label2, 17,  3,  2, 0)
      CALL Put Str (Label3, 13,  2, 33, 0)
      CALL Put Str (Prefix, 55,  3, 20, 0)
c***  Display the input file name on the screen. 
      CALL Set Character Value ('DELETEFL', Infil)
cccc      CALL Display One Field('DELETEFL')
 
      RETURN
      END
c**********************************************************************
c        D i r e c t o r y   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Directory Prompts

c***  This routine constructs the Directory screen via a call to the 
c***  'Display Directory Screen' and displays the Directory menu.  
c***  The user is prompted for a menu selection which is then processed.
c***  The subroutine 'List Directory' which is called from this routine, 
c***  executes the DOS 'Dir' command.
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Directory menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Error	  - logical variable set to .true. if a fatal error 
c***                occurs during processing.
c***

       include 'dataprep.dec'
       include '../common/screen.str'
  
      CHARACTER   Menu Choice*20, Menu*10, Fieldname*8, Blank*14
      LOGICAL   Error
      INTEGER*4   Returncode
      INTEGER*4   FLD Index

      Blank = '              '
      Menu  = 'DIR MENU  '
      Error = .TRUE.
      CALL Set Doscom Blank
      Fieldname = 'DIRECT  '


      CALL Display Directory Screen
c***  Display the Directory screen field.
cccc      CALL Display One Field('DIRECT ')
c***  Display Directory menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Erase the Directory screen.
        CALL ClearRows(1,18)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
  	RETURN
      ELSE IF (Menu Choice .EQ. 'Directory            ') THEN
c***    Prompt user for name of file to be deleted.
        Next Field = FLD Index (Fieldname)
        CALL Get Field
        CALL Get Character Value (Fieldname, Doscom)
	Error = .FALSE.
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
	  CALL Beep
          CALL Flash (20, 2,
     +     'ERROR - Must enter directory...(Press any key)')
	  GOTO 10
	ELSE
c***      Clear the screen so that the directory can be listed.
          CALL Clear Screen
	  CALL List Directory (Returncode)
c***      After the directory has been listed, display the Directory
c***      screen.
          CALL Clear Screen
          CALL Set Screen(2)
          CALL Display Frame
          CALL Display Labels
          CALL Display Directory Screen
c***      Display the Directory screen field.
	  CALL Display One Field('DIRECT  ')
          CALL Put Menu (Menu)
          IF (Returncode .EQ. -1) 
     +      CALL Flash (20, 2,
     +          'Cannot list directory...(Press any key)')
	ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        D i s p l a y   D i r e c t o r y   S c r e e n     (subroutine)
c**********************************************************************
      SUBROUTINE Display Directory Screen

c***  This routine constructs the Directory screen.
c***
c***  VARIABLES:
c***  Label2 - contains screen labels.
c***  Label3 - contains screen labels.


       include '../common/screen.str'

      CHARACTER   Label2*10, Label3*18
	
c***  Erase the DOS Utilities screen.
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***  Initialize and insert labels.
      Label2 = 'Directory:'
      Label3 = 'DIRECTORY FUNCTION'
      CALL Put Str (Label2, 10,  5,  2, 0)
      CALL Put Str (Label3, 18,  2, 31, 0)
 
      RETURN
      END
c**********************************************************************
c        S e t   D o s c o m   B l a n k      (subroutine)
c**********************************************************************
      SUBROUTINE Set Doscom Blank

c***  This routine inserts white space into the global variable
c***  'Doscom'.
c***
c***  VARIABLE:
c***  Doscom - Global variable that contains the DOS command entered
c***           by the user.


       include 'dataprep.dec'

      INTEGER*4   I

      DO 15 I = 1, 66
        Doscom(I:I) = ' '
  15  CONTINUE

      RETURN
      END
c**********************************************************************


