clarge
c**********************************************************************
c*** File name: PREP7.FOR (Source code for the program DATAPREP)
c**********************************************************************
c        R o w  E x t r a c t  P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Row Extract Prompts

c***  This routine prompts the user for those variables that are
c***  to be extracted from the Geo-EAS input data file and stored
c***  in the Geo-EAS output data file.
c***
c***  VARIABLES:
c***  Vardone	  - logical which is true if the Variables List option
c***                has been accessed.
c***  Const Field - contains the name of a constant field.
c***  Op1 Var	  - contains the variable(column) index of the variable
c***                selected from the toggle field to be Operand 1.
c***  Operator	  - contains the operation indicator selected in the
c***                toggle field.
c***  Op2 Var	  - contains the variable(column) index of the variable
c***                selected from the toggle field to be Operand 2.
c***  Error	  - logical which is set to true if an error occurs during
c***                any step of this routine except for numerical overflow.
c***  Error1	  - logical which is set to true if a numerical overflow 
c***                occurs upon entering a constant value. 
c***  Constant	  - logical which is true if 2nd operand is a constant,
c***  Variable	  - logical which is true if 2nd operand is a variable.
c***  Constant1   - contains the constant value specified by the user.
c***  Menu        - contains field name of Row Extract menu.
c***  Menu Choice - contains menu option selection. 

       include 'dataprep.dec'
       include '../common/screen.str'
		   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      CHARACTER   Toggle Field*8, Label0*22, Readmess*17, Oldfile*14
      CHARACTER   Label4*20, Label5*17
      CHARACTER   Const Field*9, Label1*11,Label2*12,Label3*32
      INTEGER*4   FLD Index, Var, Toggle, Op1 Var, Operator, Op2 Var
      REAL*4	  Zero, Constant1
      LOGICAL   Vardone, Error, Constant, Variable, Error1

c***  Erase File Operations screen from which the Row Extract option
c***  was selected.
      CALL Erase Message Divider
      CALL ClearRows(1,18)
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
c***  Initialize variables.
      Blank = '              '
      Menu  = 'RE MENU   '
      Vardone = .FALSE.
      Error = .TRUE.

c*** Initialize and insert labels.
      Readmess = ' Processing data '
      Label0 = 'Input\Output Variables'
      Label1 = 'Input File:'
      Label2 = 'Output File:'
      Label3 = 'Operand 1   Operator   Operand 2'
      Label4 = 'ROW EXTRACT FUNCTION'
      Label5 = 'Data File Prefix:'
c***  Insert label headings on screen.
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Put Str (Label0, 22, 10, 28, 0)
      CALL Put Str (Label1, 11,  5,  2, 0)
      CALL Put Str (Label2, 12,  5, 39, 0)
      CALL Put Str (Label3, 32,  7, 23, 0)
      CALL Put Str (Label4, 20,  2, 30, 0)
      CALL Put Str (Label5, 17,  3,  2, 0)
c***  Display Infile and Outfile names(if any) on screen. 
      CALL Set Character Value ('INFIL1C ', Infil)
      CALL Set Character Value ('OUTFIL1C ', Outfil)
cccc      CALL Display One Field('INFIL1C ')
cccc      CALL Display One Field('OUTFIL1C')
c***  Set Row Extraction menu and prompt user for choice ***
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
	CALL Clear Rows(1,18)
  	RETURN

      ELSE IF (Menu Choice .EQ. 'Files               ') THEN
	CALL Erase (8, 2, 70)
	CALL Erase Variable List
c***    Initialized Vardone to false to be used later in determining if
c***    Subsetting condition option was accessed before execution option.
	Vardone = .FALSE.
c***    Prompt user for input file ***
  	File = 'INFIL1C '
	CALL Get Name of File(File,Infil,Error,1)
c***    If error in accessing file name then return to menu.
	IF (Error) GOTO 10
c***    Prompt user for outfile ***
	File = 'OUTFIL1C'
	CALL Get Name of File(File, Outfil, Error,2)
      ELSE IF (Menu Choice .EQ. 'Subsetting Condition') THEN
c***     Clear operation line.
	 CALL Erase (8, 2, 70)
c***     If error reading files then return to menu else continue with
c***     processing information.
	 IF (.NOT. Error) THEN
c***       Indicate the variable list has been accessed before the 
c***       execution option.
	   Vardone = .TRUE.
	   Oldfile = Infil
	   CALL File Set Up (Error, Nvar)
	   Recskip = Nvar + 3
	   IF (.NOT. Error) THEN
	     CALL Load All Toggle Fields(Nvar)
	     CALL Erase Variable List
	     CALL Display Variables(Nvar)
c***         Prompt user for the first operand which is a variable ***
	     Toggle Field = 'VTOGGLE0'
	     Op1 Var = Toggle (Toggle Field) + 1
c***         Prompt user for the operator ***
	     Toggle Field = 'OPERATOR'
	     Operator = Toggle (Toggle Field) + 1
c***         Set logicals 'Constant' and 'Variable' to .false. ***
	     Constant = .FALSE.
	     Variable = .FALSE.
c***         Display menu for operand 2 (ie., either a variable 
c***         or constant).
	     Menu = 'RE2MENU'
             CALL Put Menu (Menu)
  15         CALL Get Menu Choice (Menu, Menu Choice)
	     IF (Menu Choice .EQ. 'Constant       ') THEN
c***           Initialize constant field to zero and then
c***           prompt user for constant and maintain value 
c***           in 'Constant1'.
	       Constant = .TRUE.
	       Zero = 0.0
	       Const Field = 'CONSTANT1'
	       CALL Set 4 Floating Point Value (Const Field, Zero, 3)
c***           If numerical overflow upon input then prompt
c***           for a new Operand 2.
               CALL Check Constant Input Overflow(Const Field, Error1)
	       IF (Error1) GOTO 15
c***           If constant is acceptable then assign value to 'Constant1'
c***           and display Row Extract menu.
	       CALL Get 4 Floating Point Value (Const Field, Constant1)
  	       Menu = 'RE MENU   '
	       CALL Put Menu (Menu)
	       GOTO 10

	     ELSE IF (Menu Choice .EQ. 'Variable       ') THEN
c***           Prompt user for variable and maintain position of 
c***           choice in 'Var'.
	       Variable = .TRUE.
	       Toggle Field = 'VTOGGLE1'
	       Op2 Var = Toggle (Toggle Field) + 1
	       Menu = 'RE MENU   '
	       CALL Put Menu (Menu)
	       GOTO 10
	     ENDIF
	     GOTO 15
	   ENDIF
	 ELSE
	   CALL Beep
	   CALL Flash(20, 2, 
     +       'ERROR - Filenames must be entered...(press any key)')
	   GOTO 10
	 ENDIF
	
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
c***     If error reading files then return to menu else continue with
c***     processing information.
	 IF (Error) THEN
	   CALL Beep
	   CALL Flash(20, 2, 
     +       'ERROR - Filenames must be entered...(press any key)')
	   GOTO 10
c***     Check if variable list option's infile is same as 
c***     file option's infile.  This check is to determine if the
c***     variable list option has been opted before the execution process.
	 ELSE IF ((Oldfile .NE. Infil).OR.(.NOT. Vardone)) THEN
	   CALL Beep
	   CALL Flash(20, 2, 
     +     'ERROR - Choice of variables not provided...(press any key)')
	   GOTO 10
	 ENDIF
         CALL Put Str (Readmess, 17, 20, 2, 2)
         Vardone = .FALSE.
c***     Read input file.  if error then return to menu else carry on 
c***     with the data processing ***
	 CALL Open Scratch Files
         CALL Read Numerical Data(1,Infil,Nvar,Nvar,Error,Recskip)
         IF (.NOT. Error) THEN
           CALL Put Str (Readmess, 17, 20, 2, 2)
     	   CALL Row Extract(Operator, Constant, Variable, 
     +                     Constant1, Op1 Var, Op2 Var)
c***       Write data to outfile.  If no records satisfied the logical
c***       expression then do not write to output file but inform the 
c***       user that no samples exist.
	   IF (Ndata .GT. 0) THEN
	     CALL Write to Output File 
	   ELSE 
	     CALL Flash(20, 2, 
     +    'ERROR - No samples satisfy the expression...(press any key)')
	   ENDIF
	 ENDIF
	 CALL Close Scratch Files
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        R o w   E x t r a c t		    (subroutine)
c**********************************************************************
      SUBROUTINE Row Extract(Operator, Constant, Variable,
     +			     Value, Op1 Var, Op2 Var)

c***  This routine extracts rows based on the relational expression
c***  passed by the calling subroutine.
c***
c***  PARAMETERS:
c***  Operator	- contains the integer value corresponding to a specific
c***              operator.
c***  Constant	- logical that is true if Operand 2 is a constant(floating 
c***              pt).
c***  Variable	- logical that is true if Operand 2 is a variable.
c***  Value	- floating point value of Operand 2(if Operand 2 is a
c***              constant).
c***  Op1 Var	- variable(column) index of Operand 1 variable.
c***  Op2 Var	- variable(column) index of Operand 2 variable.
c***  Row Count	- number of rows of data that satisfy the relational
c***              expression.  The global variable 'Ndata' is assigned
c***              this value.

       include 'dataprep.dec'

      REAL*4     Value, Get Element
      INTEGER*4  Operator, I, J, Var, Row Count
      LOGICAL  Constant, Variable

c***  Set row counter to zero.
      Row Count = 0
      IF (Constant) THEN
c***  If operand 2 is a constant and the operator is .LT. Value then 
c***  process data.
	 IF (Operator .EQ. 1) THEN
	    DO 10 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .LT. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  10	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a constant and the operator is .LE. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 2) THEN
	    DO 15 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .LE. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  15	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a constant and the operator is .GT. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 3) THEN
	    DO 20 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .GT. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  20	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a constant and the operator is .GE. Value then 
c***     process data **
	 ELSEIF (Operator .EQ. 4) THEN
	    DO 25 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .GE. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  25	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a constant and the operator is .EQ. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 5) THEN
	    DO 30 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .EQ. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  30	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a constant and the operator is .NE. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 6) THEN
	    DO 35 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar) .NE. Value) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  35	    CONTINUE
	    Ndata = Row Count
	 ENDIF
      ELSE IF (Variable ) THEN
c***     If operand 2 is a Variable and the operator is .LT. Value then 
c***     process data.
	 IF (Operator .EQ. 1) THEN
	    DO 40 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .LT. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  40	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a Variable and the operator is .LE. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 2) THEN
	    DO 45 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .LE. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  45	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a Variable and the operator is .GT. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 3) THEN
	    DO 50 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .GT. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  50	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a Variable and the operator is .GE. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 4) THEN
	    DO 55 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .GE. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  55	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a Variable and the operator is .EQ. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 5) THEN
	    DO 60 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .EQ. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  60	    CONTINUE
	    Ndata = Row Count
c***     If operand 2 is a Variable and the operator is .NE. Value then 
c***     process data.
	 ELSEIF (Operator .EQ. 6) THEN
	    DO 65 I = 1, Ndata
	       IF (Get Element(1,Op1 Var,I,Nvar)
     +            .NE. Get Element(1,Op2 Var,I,Nvar)) THEN
		  CALL Extract(Row Count, I)
	       ENDIF
  65	    CONTINUE
	    Ndata = Row Count
	 ENDIF
      ENDIF
      RETURN
      END
c**********************************************************************
c        E x t r a c t	        	    (subroutine)
c**********************************************************************
      SUBROUTINE Extract(Row Count, I)

c***  This routine relocates the position of the case (row of samples) 
c***  indicated by 'I' to the new position indicated by 'Row Count'.
c***  
c***  VARIABLES:
c***  Row Count	- The new row that the current row of samples(indicated
c***              by position 'I') will be moved to. 
c***  I		- The current position of the row of samples.
c***  Nvar	- The number of variables.
c***  J		- Variable(column) index.
c***  Value	- Floating point value of a data sample.

       include 'dataprep.dec'

      REAL*4    Get Element, Value
      INTEGER*4 Row Count, J, I

c***  Increment row counter.
      Row Count = Row Count + 1
c***  The DO 15 loop moves a case (row of samples) to the its new location.
      DO 15 J =	1, Nvar
	 Value = Get Element(1,J,I,Nvar)
	 CALL Put Element(1,J,Row Count,Nvar,Value)
  15  CONTINUE

      RETURN
      END

c**********************************************************************
c	 Check Constant Input Overflow             (subroutine)
c**********************************************************************
      SUBROUTINE Check Constant Input Overflow(Choice, Error)
 
c***  This routine prompts the user for a constant value, extracts the
c***  value from the screen field (the name of which is contained in
c***  'Choice'), and checks that value for numerical overflow in which 
c***  case an error message is displayed and 'Error' is set to true. 
c***
c***  VARIABLES:
c***  Choice	- contains the name of the screen field from which
c***              to extract the constant(floating point).
c***  Error	- logical which is set to true if the constant
c***              causes overflow.
c***  Tmp Input	- contains the constant value but as a character string.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER    Tmp Input*10, Choice*(*)
      INTEGER*4    K
      REAL*4       M
      LOGICAL    Error

c***  Prompt user for the constant value.
      Error = .FALSE.
      K = 0
      Next Field = FLD Index (Choice)
      CALL Get Field
      CALL Get Character Value (Choice,Tmp Input)
c***  Use an internal read to check if the constant causes numeric overflow.
      READ (Tmp Input,'(G10.0)',IOSTAT=K) M
c***  Check for overflow in missing value input.
      IF (K .GT. 0) THEN
         CALL Beep
         CALL Flash (20, 2,
     +     'ERROR - on input, possible overflow...(press any key)')
         Error = .TRUE.
      ELSE
         Error = .FALSE.
      ENDIF

      RETURN
      END
c**********************************************************************


