C********************************************************************
C SUBROUTINE Get FGroup 
C
C This routine gets the value for a group of screen fields.
C
  	SUBROUTINE Get FGroup 
	
        IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

        INCLUDE '../common/screen.str'
	
 10	CALL Get Field	
	IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +      SC Field Type (Next Field) .NE. Menu Field          ) 
     +     GOTO 10

	RETURN
	END

C*******************************************************************
C SUBROUTINE Intro Screen 
C
C  This routine displays the screen frame/labels/fields for the 
C  introductory screen.           
C
	SUBROUTINE Intro Screen

	CALL Clear Screen
	CALL Set Screen (1)
	CALL Display Frame
	CALL Display Labels
	CALL Locate Cursor (23, 0)
	CALL Flash (20, 2, 'Press any key to begin the program ')
	RETURN
        END  

C*********************************************************************
C SUBROUTINE Display Flds 
C
C This routine displays the current screen fields.
C
        SUBROUTINE Display Flds

        IMPLICIT INTEGER*4 (A-Z)

        INCLUDE '../common/screen.str'

        INTEGER*4   Main Menu Field, Menu Field
  
        PARAMETER (Main Menu Field = 3)
        PARAMETER (Menu Field      = 4)


        DO 10 i = Begin Screen (Current Screen),
     +            End Screen (Current Screen)
           IF (SC Field Type (i) .NE. Main Menu Field .AND.
     +         SC Field Type (i) .NE. Menu Field            )
     +        CALL Write Field (i, SC  Attribute (i))
10      CONTINUE

        RETURN
        END           

C************************************************************************
C SUBROUTINE Read System Defaults 
C 
C This routine reads the system defaults file 'geoeas.def' and  
C initializes the system defaults.
C
        SUBROUTINE Read System Defaults (Prefix, File, intro)
        
        IMPLICIT INTEGER*4 (A-Z)
        CHARACTER   String*80, prefix*(*), file*(*)
        logical intro

        OPEN (UNIT=10,FILE ='geoeas.def',STATUS = 'UNKNOWN',
     +        ERR= 999)
        READ (10, '(A)', ERR = 999,END= 999) Prefix
        READ (10, '(A)', ERR = 999,END= 999) File
        READ (10, '(A)', ERR = 999,END= 999) String
C *** Intro flag embedded as INTRO=ON, INTRO=anything else
C *** Intro is a global logical
        Intro = (String (7:8) .EQ. 'ON' .OR.
     +       String (7:8) .EQ. 'on')
        CALL Set Character Value ('PREFIX    ',Prefix)
        CALL Set Character Value ('DATAFILE  ',File)
        CLOSE (10)
        RETURN
 999    CLOSE (10)
C ***       FilePrefix=''
        Intro = .TRUE.

        RETURN
        END

C************************************************************************
C SUBROUTINE Write System Defaults (Prefix, File)
C
C Formal Arguments:
C  Prefix   -  File prefix 
C  File     -  Data file name
C
C This routine writes the file prefix and the data file name to the
C system defaults file 'geoeas.def'.  
C

        SUBROUTINE Write System Defaults (Prefix, File, intro)
        
        IMPLICIT INTEGER*4 (A-Z)

        CHARACTER*(*) Prefix, File
        logical intro

        OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'UNKNOWN',
     +        ERR= 999)
        WRITE (10, '(A)', ERR = 999) Prefix
        WRITE (10, '(A)', ERR = 999) File
        IF (Intro) THEN
           WRITE (10, '(A)', ERR = 999) 'INTRO=ON'
        ELSE
           WRITE (10, '(A)', ERR = 999) 'INTRO=OFF'
        ENDIF
 999    CLOSE (10)

        RETURN
        END


C**********************************************************************   
C SUBROUTINE Get New Screen (Screen Number) 
C
C Formal Arguments:
C  Screen Number  - Stores the screen number.  
C
C This routine sets the current screen to screen number and then displays
C the frame and labels for that screen. 
C

        SUBROUTINE Get New Screen (Screen Number)
         
        IMPLICIT INTEGER*4 (A-Z)
        INTEGER*4   Screen Number        

        CALL Clear Screen
        CALL Set Screen (Screen Number)
        CALL Display Frame
        CALL Display Labels

        RETURN
        END

