cc$LARGE
C
C Krige.for - 2D kriging program
C------------------------------------------------------------------------
	PROGRAM KRIGE
	IMPLICIT INTEGER*4 (a-z)

       INCLUDE 'krige.dec'
       INCLUDE '../common/screen.str'

        character*80 geoeas_home
        include '../common/color.dec'

C Initialize graphics variables
cc
        call graphics_in
        call get_geoeas_dir(10,geoeas_home)
        CALL Read Structure (geoeas_home(1:lenstr(geoeas_home))
     &       //'/krig/krige.scr')

ccc replaces old grafinit:
        graphics = .true.
        aspect     = 1
        DevCode    = 1
        Gmode      = 31
        Xmaxdev    = 719
        Ymaxdev    = 347
ccc   
	call set up screen()
	CALL Clear Screen

	CALL Initialize
	CALL Read System Defaults
	IF (Intro) CALL Intro Screen
   	CALL Get Screen Fields
	CALL Write System Defaults
	CALL SetMod (INT2 (StartMode))
	END

C----------------------------------------------------------------------
C Initialize - initializes GLOBAL variables for program KRIGE

        SUBROUTINE Initialize

	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE  'krige.dec'

        INTEGER*4       I, J
        DO 10 I = 1, MAXVARK
           KrigVar (I) = 0
	   Nugget  (I) = 0.0
           Mglobal (I) = 0.0
           GamMax  (I) = 0.0
           Cvv     (I) = 0.0
           DO 20 J = 1, MAXDATA
               Data (J, I) = 0.0
 20        CONTINUE
           DO 30 J = 1, MAXSTRUC
               Sill    (J, I) = 0.0
               Mtype   (J, I) = 0
               VrMajor (J, I) = 0.0
               VrMinor (J, I) = 0.0
               VrAngle (J, I) = 0.0
 30        CONTINUE
 10     CONTINUE

        Ndata           = 0
        Var             = 0
        Nvar            = 0
        NkVar           = 0
        Xvar            = 1
        Yvar            = 2
	KrigVar (1)	= 3
        Xorigin         = 0.0
        Yorigin         = 0.0
        XcellSize       = 1.0
        YcellSize       = 1.0
        NxCells         = 0
        NyCells         = 0

        SrMajor         = 0.0
        SrMinor         = 0.0
        SrAngle         = 0.0
        MaxP            = 8
        MinP            = 2
        MaxPs           = 8
        Nsector         = 1
        MaxEmpty        = 0
        Euclidean       = .TRUE.
        Ktype           = 1
        Ndiscr          = 2
        Point           = .FALSE.
        Missing         = 1.E31
        Debug System    = .FALSE.
        Debug Neighbors = .FALSE.
        Debug Weights   = .FALSE.

        DO 50 I = 1, 16
           Xa (I) = 0.0
           Ya (I) = 0.0
 50     CONTINUE
        Na = 1

        DO 60 I = 1, MAXEQ
           B (I)  = 0.0
           B2 (I) = 0.0
           DO 60 J = 1, MAXEQ
              W (I, J) = 0.0
 60     CONTINUE                      
        Minimum = -1.E30
        Maximum = +1.E30
	PolyFile = ' '
	OutFile  = ' '
	IparFile = ' '
	OparFile = ' '
        RETURN
        END
        
C----------------------------------------------------------------------
C ReInitialize - initializes GLOBAL variables for program KRIGE

        SUBROUTINE ReInitialize
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE  'krige.dec'

 	CHARACTER*10	Blanks (MAXVAR), Scratch*13
	INTEGER*4       Pos
	DATA Scratch /'             '/

	CALL Initialize

C----------------------------------------------------------------------
C init variable names

        CALL Load Toggle Values ('GR XVAR   ', 10, 48, Blanks, Xvar-1)
        CALL Load Toggle Values ('GR YVAR   ', 10, 48, Blanks, Yvar-1)
        CALL Load Toggle Values ('KRIGEVAR  ', 10, 48, Blanks, 
     +		KrigVar (1)-1)

C----------------------------------------------------------------------
C init search stuff  

    	CALL Set Character Value ('SE RMAJOR ', Scratch)
    	CALL Set Character Value ('SE RMINOR ', Scratch)
    	CALL Set Character Value ('SE ANGLE  ', Scratch)
	Pos = 1
        IF (Euclidean) Pos = 0
        CALL Set Toggle Position  ('SE DTYPE  ', Pos)
	CALL Set Toggle Position  ('SE MAXPO  ', MaxPs-1)
	CALL Set Toggle Position  ('SE MINPT  ', MinP-1)
	CALL Set Toggle Position  ('SE ETYPE  ', Nsector/4)
	CALL Set Toggle Position  ('SE MAXEMPT', MaxEmpty)

C----------------------------------------------------------------------
C init grid stuff
	CALL Set Character Value ('GR XORG   ', Scratch)
	CALL Set Character Value ('GR YORG   ', Scratch)
	CALL Set Character Value ('GR XCSIZE ', Scratch)
	CALL Set Character Value ('GR YCSIZE ', Scratch)
	CALL Set Character Value ('GR XNCELL ', Scratch)
	CALL Set Character Value ('GR YNCELL ', Scratch)

C----------------------------------------------------------------------
C init kriging type
	CALL Set Toggle Position      ('TY KRIGE  ', 1)

C----------------------------------------------------------------------
C initmodel parameters
	CALL Set Character Value ('VM NUGGET ', Scratch)
	CALL Set Character Value ('VM MGLOBAL', Scratch)
	CALL Set Toggle Position ('VM TYPE  1', 0)
	CALL Set Toggle Position ('VM TYPE  2', 0)
	CALL Set Toggle Position ('VM TYPE  3', 0)
	CALL Set Toggle Position ('VM TYPE  4', 0)
	CALL Set Character Value ('VM SILL  1', Scratch)
	CALL Set Character Value ('VM SILL  2', Scratch)
	CALL Set Character Value ('VM SILL  3', Scratch)
	CALL Set Character Value ('VM SILL  4', Scratch)
	CALL Set Character Value ('VM RMAJOR1', Scratch)
	CALL Set Character Value ('VM RMAJOR2', Scratch)
	CALL Set Character Value ('VM RMAJOR3', Scratch)
	CALL Set Character Value ('VM RMAJOR4', Scratch)
	CALL Set Character Value ('VM RMINOR1', Scratch)
	CALL Set Character Value ('VM RMINOR2', Scratch)
	CALL Set Character Value ('VM RMINOR3', Scratch)
	CALL Set Character Value ('VM RMINOR4', Scratch)
	CALL Set Character Value ('VM ANGLE 1', Scratch)
	CALL Set Character Value ('VM ANGLE 2', Scratch)
	CALL Set Character Value ('VM ANGLE 3', Scratch)
	CALL Set Character Value ('VM ANGLE 4', Scratch)

	CALL Set Character Value ('POLYFILE  ', PolyFile)
	CALL Set Character Value ('OUTFILE   ', OutFile)
	CALL Set Character Value ('IPARFILE  ', IparFile)
	CALL Set Character Value ('OPARFILE  ', OparFile)
	RETURN
	END

C----------------------------------------------------------------------
C Get Field Group - get a group of fields, perform processes

	SUBROUTINE Get Field Group 
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

        INCLUDE '../common/screen.str'
	
	LOGICAL	Error, Repaint

 10	CALL Get Field	
	CALL Perform Process (SC Field Name (Current Field),
     +                     Error, Repaint) 

	IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +	    SC Field Type (Next Field) .NE. Menu Field) GOTO 10

	IF (Repaint) THEN
	   CALL New Screen (Current Screen)
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------
C Get Screen Fields - 	displays screen frame/label/fields
C			gets the screen fields for the current screen

	SUBROUTINE Get Screen Fields 

	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAINSCR  = 2, MSCREEN = 4, OSCREEN = 3)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)
 
        INCLUDE 'krige.dec'
        INCLUDE '../common/screen.str'

	CHARACTER*10	Main Menu, VM Menu, O Menu, File Name*65
	CHARACTER 	Menu Choice*10, Dummy*14
	INTEGER*4	Fld Index
	LOGICAL	GetYesNo, Exit
	LOGICAL		Error, Quit, Fexist

	DATA Main Menu /'MAINMENU  '/
	DATA VM Menu   /'VM MENU   '/
	DATA O Menu    /'OPTIONS   '/ 
	
C Put out default parameter file names
	Dummy = Data File
	IF (Dummy (1:1) .NE. ' ') THEN
	   K = Index (Dummy, '.')
	   IF (K .NE. 0) THEN
	      K = AMIN0 (K, 9)
	   ELSE
	      L = LENSTR (Dummy)
	      K = AMIN0 (L, 9)
	   ENDIF
	   IparFile = Dummy (1:K-1)//'.kpf'
	   OparFile = IparFile
	ENDIF

C Paint Screen
  5	CALL New Screen (MAINSCR)
	CALL Set Character Value ('IPARFILE  ', IparFile)
	CALL Set Character Value ('OPARFILE  ', OparFile)
	
C Main screen
 10 	CALL Put Menu (Main Menu)

 20	CALL Get Menu Choice (Main Menu, Menu Choice)	
 	IF      (Menu Choice .EQ. 'Quit     ') THEN
	  Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N>')
	  IF (Exit) then
cclong
		call clear screen
		call reset screen
cc
	  RETURN
cc
	  end if
cc

C---------------------------------------------------------------------- 
	ELSE IF (Menu Choice .EQ. 'Load Param') THEN
	   CALL Get Field Group
	   IF (Nvar .GT. 0) GOTO 25

C---------------------------------------------------------------------- 
	ELSE IF (Menu Choice .EQ. 'Save Param') THEN
	     IF (Nvar    .LT. 0    .OR. NkVar   .LE. 0   .OR. 
     +           NxCells .LE. 0    .OR. NyCells .LE. 0   .OR.
     +		 SrMajor .LE. 0.0  .OR. SrMinor .LE. 0.0     ) THEN
	        CALL Beep
	        CALL Flash (20, 2,
     +	'ERROR - you must first choose parameter values (press a key)')
	     ELSE
	        CALL Get Field Group
	     ENDIF

C---------------------------------------------------------------------- 
C Options screen
	ELSE IF (Menu Choice .EQ. 'Options/Ex') THEN
 25       CALL New Screen (OSCREEN)
	  CALL Set Character Value ('DATAFILE  ', Data File)
 30	  CALL Put Menu   (O Menu)
 35	  CALL Get Menu Choice (O Menu, Menu Choice)   
	  IF      (Menu Choice .EQ. 'Quit      ') THEN
	     GOTO 5

C---------------------------------------------------------------------- 
	  ELSE IF (Menu Choice .EQ. 'Grid      '.OR.
     +		   Menu Choice .EQ. 'Search    '.OR.  
     +		   Menu Choice .EQ. 'Polygon   ') THEN 

	     IF (Nvar .LT. 1) THEN
	        CALL Beep
	     ELSEIF ((NxCells .EQ. 0 .OR. NyCells .EQ. 0) .AND.
     +	              Menu Choice .EQ. 'Polygon   ') THEN
	        CALL Beep
	        CALL Flash (20, 2,
     +		 'You must select grid parameters first (press a key)')
	     ELSE
	        CALL Get Field Group
	     ENDIF
	     GOTO 30
C---------------------------------------------------------------------- 
C variables and Variogram models selection screen/menu
	  ELSE IF (Menu Choice .EQ. 'Variables/') THEN
	     IF (Nvar .LT. 1) THEN
	         CALL Beep
	         GOTO 30
	     ENDIF
 40          CALL New Screen (MSCREEN)
	     CALL Display KrigList
	     CALL Set Menu Position (VM Menu, 2)
 45	     CALL Put Menu   (VM Menu)
 50 	     CALL Get Menu Choice (VM Menu, Menu Choice)
	     IF (Menu Choice .EQ. 'Quit      ') THEN
	        GOTO 25
	     ELSEIF (Menu Choice .EQ. 'New Variab') THEN
 52		IF (NkVar .LT. MAXVARK) THEN
		   NkVar = NkVar + 1
		   Current Var = NkVar
	           CALL Get Field Group
		ELSE
		   CALL Beep
	           CALL PutStr ('Kriging List is Full',20 ,20, 2, 2)
		ENDIF
	     ELSEIF (Menu Choice .EQ. 'Edit      ') THEN
	        IF (NkVar .GT. 0) THEN
	           CALL Select Variable (Itemp)
	           IF (Itemp .LE. NkVar) THEN
	              Current Var = Itemp
	              CALL Display KrigList
		      CALL Load VarModel
	              IF (Ktype .EQ. SIMPLE) THEN
	                 Next Field = Fld Index ('VM MGLOBAL')
	              ELSE
	                 Next Field = Fld Index ('VM NUGGET ')
	              ENDIF
		      CALL Get Field Group
	           ENDIF
	        ELSE
		   CALL Beep
	        ENDIF
	     ELSEIF (Menu Choice .EQ. 'Delete    ') THEN
	        IF (NkVar .GT. 0) THEN
	          CALL Select Variable (Itemp)
	          IF (Itemp .LE. NkVar) THEN
	             Current Var = Itemp
	             CALL Display KrigList
	             CALL Load VarModel
	             CALL Delete VarModel (Itemp)
	          ENDIF
	        ELSE
		   CALL Beep
	           CALL PutStr ('Kriging List is Empty',21 ,20, 2, 2)
	        ENDIF
	     ENDIF 
	     GOTO 50
C---------------------------------------------------------------------- 
C kriging choice
	  ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
	     CALL Set Menu Position (O Menu, 1)

C final error checks on parameters
	     IF (Nkvar .LT. 1) THEN
	         CALL Beep
	         CALL Flash (20, 2, 'No variables or models entered ')
	         GOTO 30
	     ELSEIF (NxCells .LT. 1 .OR. NyCells .LT. 1) THEN
	         CALL Beep
	         CALL Flash (20, 2, 'No grid parameters specified')
	         GOTO 30
	     ELSEIF (SrMajor .LE. 0..OR. SrMinor .LE. 0.) THEN
	         CALL Beep
	         CALL Flash (20, 2, 'No search parameters specified')
	         GOTO 30
	     ENDIF

C read data into internal matrix of (Ndata x NkVar) samples
	     CALL Read Data (Error)
	     IF (Error) THEN
	       CALL Flash
     +	       (20, 2, 'ERROR in '//Data File//' (press any key)')
	     ELSE

C process polygon file (if any)
	       CALL InitGrid
	       CALL Get File Name (File Name, File Prefix,
     +			 PolyFile, Fexist)
	       IF (.NOT. Fexist .or. lenstr(polyfile) .eq. 0) THEN
	         CALL Blank File ('POLYFILE  ', Poly File)
	         CALL Display One Field ('POLYFILE  ')
	       ELSE
                  CALL Read Polygon File (File Name, Error)
		 IF (Error) THEN
		    CALL Beep
	            CALL Flash (20, 2, 'Error reading '//Polyfile//
     +                     ' press any key to continue kriging')
	            CALL InitGrid
	         ENDIF
	       ENDIF

C Begin kriging the grid of estimates
	       CALL Kriger (Quit, Error)
               CALL NewScreen (OSCREEN)
C Messages
	       IF (Quit) THEN
	          CALL Flash
     +		  (20, 2,'Kriging cancelled, Press any key')
	       ELSE IF (Error) THEN
	          CALL Flash
     +		  (20, 2, 'Error occurred writing to '//OutFile//
     +			  ' (Press any key)')
	       ELSE
                  CALL erase (23, 2, 70)
                  CALL putstr('Kriging is completed.',21,23,30, 2)
	          CALL Flash (20, 2,
     + 'Results have been written to '//OutFile//' (Press any key)')
	       ENDIF
	       GOTO 30
	     ENDIF

C----------------------------------------------------------------------
C Screen field processing for options screen
	  ELSE
	    CALL Get Field Group
	  ENDIF
	  GOTO 30
C----------------------------------------------------------------------
C Screen field processing for read and save parameter files
	ELSE
          CALL Get Field Group
	ENDIF

	GOTO 20
	END	

C----------------------------------------------------------------------
C Select Variable 
C
	SUBROUTINE Select Variable (VarNum)
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'
        INCLUDE '../common/screen.str'

	CHARACTER*10	Menu Choice, MenuName
	INTEGER*4	VarNum, Fld Index, Field

	DATA MenuName /'VSELECT'/

C Check for no items in list, or just one
	IF (NkVar .LT. 1) THEN
	   RETURN
	ELSEIF (NkVar .EQ. 1) THEN
	   VarNum = 1
	   RETURN
	ENDIF

C Put out message for use of menu

	CALL PutStr ( 
     + 'Select Variable (Use , or , to position, <enter> to select)'
     + , 61, 20, 2, 2)

C Set up arrow key links so that only NkVar elements are used
	Field = Fld Index (Menu Name)
	DO  5 I = 2, NkVar-1
	  SC Up   (Field+I) =  -1
	  SC Down (Field+I) =   1
 5	CONTINUE
	SC Up   (Field+1)     =  NkVar - 1
	SC Down (Field+NkVar) = -(NkVar - 1)

C Get Menu Choice
 10	CALL Get Menu Choice (Menu Name, Menu Choice)
	READ (Menu Choice (1:2), '(I2)', ERR = 10) VarNum
	CALL Erase (20, 2, 75)
	RETURN
	END

C---------------------------------------------------------------------
	SUBROUTINE Finish Beep
	INTEGER*4	I, One
	DATA One /1/

	DO 10 I = 1,5
cclong This didn't exist, so use beep	   CALL SOUND (I, One)
		call beep
cc
 10	CONTINUE	
	RETURN
	END 





