C*************************************************************
C
		      SUBROUTINE ESTCOK
C
C     Subroutine ESTCOK cokrigs a grid of points/blocks
C     given an initial set of parameters, etc., listed in
C     the include file "cokrig.inc".
C
C*************************************************************
C
		INCLUDE  'cokrig.inc'

cclong
	character*25 fmtt, stuff*77
cclong

      REAL TCBVAR
      NG = 0

cc	fmtt = '(3(e13.6,x),  (e8.1,x))'
cc	write(fmtt(13:14),'(i2)') 2*mvar
C*****Compute block variances if block kriging.
      IF(IPKRIG.EQ.1)THEN
        TCBVAR = 0.0
        CALL DISCRT
        IF(IDBUG.EQ.1)THEN
          WRITE(IOUT,5) NPX,NPY,NPZ,NDP
C          write(*,5)NPX,NPY,NPZ,NDP
 5        FORMAT(//,' Echo of generated discrete points!',//,
     1    ' Number of easting discrete points   = ',I5,/,
     2    ' Number of northing discrete points  = ',I5,/,
     3    ' Number of elevation discrete points = ',I5,/,
     4    ' Number of discrete points per block = ',I5,/)
          DO 15 I = 1,NDP
            WRITE(IOUT,10) I,XDB(I),YDB(I),ZDB(I)
 10         FORMAT(1X,' I = ',I2,' XDB = ',E12.5,' YDB = ',E12.5,
     1                           ' ZDB = ',E12.5)
 15       CONTINUE
        ENDIF
        DO 20 I = 1,MVAR
          II = NDG(I) + I
          CBKVAR(I) = BKVAR(II)
          TCBVAR = TCBVAR + CBKVAR(I)
 20     CONTINUE
        WRITE(IOUT,25) TCBVAR,(NAME(J),CBKVAR(J),J=1,MVAR)
C        WRITE(*,25) TCBVAR,(NAME(J),CBKVAR(J),J=1,MVAR)
 25     FORMAT(//,' Echo of block variances!',//,
     1  ' Total cokrig   block variance = ',E15.7,/,
     2       100(1X,A15,'Block variance = ',E15.7,/))
      ENDIF
C*****List header if desired.
      IF(ILIST.GE.1)THEN
        WRITE(IOUT,40)
 40     FORMAT('1',//,10X,'***Output of cokriging results***',//,
     1 '    Easting  Northing Elevation Variable         Wt.',
     2 '     Cok Std.     Cok Est.',/)
      ENDIF
C*****Cokrig the block network.
      WRITE(stuff(1:8),'(i8)',err=198) 
     &     (nfb-nsb+1)*(nfe-nse+1)*(nfn-nsn+1)
      stuff = ' of a total of '//stuff(1:8)//' points.'
 198  call put str (stuff,60,20,11,0)
      DO 200 ISZ = NSB,NFB
      DO 200 ISX = NSE,NFE
      DO 200 ISY = NSN,NFN
C*******Coordinates of blocks origin.

        XCB  = XEAST  + FLOAT(ISX - 1)*XLBL
        YCB  = YNORTH + FLOAT(ISY - 1)*YLBL
        ZCB  = ZELEV  - FLOAT(ISZ - 1)*ZLBL
        IF(IPKRIG.EQ.0)THEN
          XMID = XCB
          YMID = YCB
          ZMID = ZCB
        ELSE
          XMID = XEAST + (FLOAT(ISX - 1) + 0.5)*XLBL
          YMID = YNORTH + (FLOAT(ISY - 1) + 0.5)*YLBL
          ZMID = ZELEV - (FLOAT(ISZ - 1) + 0.5)*ZLBL
        ENDIF
C*******Pull in nearest maxhol samples with the
C*******current kriging search radius parameters.

        DO 45 I = 1,NUMHOL
          DIST(I) = DELH(X(I),Y(I),Z(I),XMID,YMID,ZMID,
     1                   AFF1,AFF2,SAZM,CAZM,SDIP,CDIP)
 45     CONTINUE

        CALL IDSORT(NUMHOL,DIST,IHOL)
        ICOUNT = 0
        DO 50 I = 1,NUMHOL
          IF(DIST(IHOL(I)).GT.RADIIA) GO TO 55
          ICOUNT = ICOUNT + 1
          IF(ICOUNT.GE.MAXHOL*MVAR) GO TO 55
 50     CONTINUE
C*******If have more than NXCOL samples in kriging nbhd, then cokrig.
 55     IF(((MVAR*ICOUNT).LE.NXCOL).OR.(ICOUNT.LT.MINHOL))THEN
cclong
          WRITE(IPCH,*) XMID,YMID,ZMID,
     &                    (1e31,1e31,J=1,MVAR)
	  go to 200
cclong          GO TO 200
        ELSE
C*********Loop to make sure that at least NTERM(I) samples
C*********of attribute I are included in kriging nbhd.

          DO 60 I = 1,MVAR
            G(I) = 0.0
 60       CONTINUE
          NSAMP = 0
          DO 70 I = 1,ICOUNT
            IPT = (IHOL(I) - 1)*MVAR
            DO 65 J = 1,MVAR
              IPT = IPT + 1
              IF(GRADE(IPT).LT.TEST(J))THEN
                G(J) = G(J) + 1.0
                IF (G(J).GT.FLOAT(MAXHOL)) GO TO 65
                NSAMP = NSAMP + 1
                NHOL(NSAMP) = IHOL(I)
                NATR(NSAMP) = J
              ENDIF
 65         CONTINUE
 70       CONTINUE
          DO 75 I = 1,MVAR
cclong           IF(G(I).LT.NTERM(I)) GO TO 200
           IF(G(I).LT.NTERM(I)) then
              WRITE(IPCH,*) XMID,YMID,ZMID,
     &                    (1e31,1e31,J=1,MVAR)
	      go to 200
           end if
cclong
 75       CONTINUE
        ENDIF
C*******Echo points in kriging nbhd if desired.
        IF(IDBUG.EQ.1)THEN
          WRITE(IOUT,80)
 80       FORMAT(//,' Echo of points in kriging NBHD!',//,
     1    '    Easting  Northing Elevation          Grade',
     2    '  Variable')
          WRITE(IOUT,85)
 85       FORMAT(1X)
          DO 100 I = 1,NSAMP
            LOC = (NHOL(I)-1)*MVAR + NATR(I)
cclong            WRITE(IOUT,90) X(NHOL(I)),Y(NHOL(I)),Z(NHOL(I)),
            WRITE(IOUT,*) X(NHOL(I)),Y(NHOL(I)),Z(NHOL(I)),
     1                      GRADE(LOC),NAME(NATR(I))
cclong 90         FORMAT(1X,3F10.2,E15.7,2X,A15)
 100      CONTINUE
        ENDIF
C*******Call subroutines to compute kriging estimate.

        CALL LEFT(IERROR)
        IF(IERROR.GE.1)THEN
C*********Singular design matrix so jump to
C*********the next estimation point.
cclong          GO TO 200
              WRITE(IPCH,*) XMID,YMID,ZMID,
     &                    (1e31,1e31,J=1,MVAR)
	      go to 200
cclong
        ELSEIF(IERROR.EQ.0)THEN
C*********Matrix factorizations ok, so finish
C*********with the cokriging estimator.
          IF(IDUAL.EQ.1)THEN
            CALL DUAL(TCOKVA,XCB,YCB,ZCB)
          ELSE
            CALL RIGHT(TCOKVA,XCB,YCB,ZCB)
          ENDIF
C*********Write results to output files.
          DO 110 I = 1,MVAR
cc            IF(EST(I).LT.0.0)THEN
cclong              EST(I) = 0.0
cc            ENDIF
 110      CONTINUE
          IF(ILIST.GE.1)THEN
cclong            WRITE(IOUT,120) XMID,YMID,ZMID,TCOKVA
            WRITE(IOUT,*) XMID,YMID,ZMID,TCOKVA
cclong 120        FORMAT(1X,3F10.2,' Total Cok Std.      ',E13.6)
cclong            WRITE(IOUT,130) (NAME(J),WGT(J),COKVAR(J),EST(J),J=1,MVAR)
            WRITE(IOUT,*) (WGT(J),COKVAR(J),EST(J),J=1,MVAR)
cclong note use of '5' rather than maxv:
cclong 130        FORMAT(5(32X,A15,F5.2,2E13.6,/))
          ENDIF
cclong 140      FORMAT(3F10.2,20E15.7)
cclong          WRITE(IPCH,140) XMID,YMID,ZMID,
          WRITE(IPCH,*) XMID,YMID,ZMID,
     1                    (EST(J),COKVAR(J),J=1,MVAR)
cc
          NG = NG + 1
cclong          WRITE(*,160) NG,XMID,YMID,ZMID,(EST(J),COKVAR(J),J=1,MVAR)
          WRITE(stuff(1:8),'(i8)',err=199) ng
 199      call put str (stuff(1:8),8,20,2,0)
cclong 160      FORMAT(I5,3F10.2,/,5(4E15.7,/))
          IF(NG.GT.1) IDBUG = 0
        ENDIF
 200  CONTINUE
ccc      WRITE(*,210) NG
      WRITE(IOUT,210) NG
 210  FORMAT(//,' Done cokriging ',I5,' points/blocks!')
      RETURN
      END
