C----------------------------------------------------------------------
C     Plot Histogram - plot frequency distribution for STATS
C     
      
      SUBROUTINE Plot Histogram
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'stats.dec'
      
c     ***	local variables
      
      REAL*4	Xfudge, Yfudge, Xstart, Tx1, Tx2, Ty1, Ty2
      REAL*4    Width, Tmax, Tmin, Oldmax
      REAL*4	Xc, Yc, X, Y, Dx, Dy, Tx, Ty, Mx, My
      REAL*4    TQ1, TQ3, Tmedian, Tmean, Tsum
      INTEGER*4 I, J, Decimals, lenstr
      CHARACTER NumStr*12, message*72, menu choice*10
      
cclong11/30/93
      CALL New Screen (7)
      call put menu ('POSTSCR')
      call get character value('PSFILEN',message)
      if (lenstr(message) .eq. 0 .or. message .eq. 'probplot.ps')
     &     call set character value('PSFILEN','histogram.ps')
cclong11/30/93
      
C     Determine the rest of the scaling information
 1    message = 'Computing Histogram...'
      i = lenstr(message)
      CALL PutStr (message,i, 20, 2, 2)
      dx = xmax - xmin
      dy = ymax - ymin
      mx = (dx * .013)/aspect
      my = dy * .013
      xfudge = dx * 0.15
      yfudge = dy * 0.2
      minx = xmin - (xfudge*1.6)
      maxx = xmax + (xfudge*3.65)
      miny = ymin - yfudge
      maxy = ymax + Yfudge * 1.5
      
C     Start graphics mode
      CALL Zsetup (Gmode, Ierr)
      
C     Set text attributes (8x8, white on black border)
      CALL Zlbdir (0.0)
      CALL Zlborg (int2 (1))
      CALL Zlocat (0, Xmaxdev, 0, Ymaxdev)
      
C     Draw graph frame
      
C     Set scaling window
      Tx = (Maxx - Minx) * .05
      Ty = (Maxy - Miny) * .007	    
      
      CALL Zscale (Minx, Maxx+tx, Miny, Maxy)
      CALL Grframe (Xmaxdev, Ymaxdev, Blue)
      
      CALL Zcolor (White)
      
C     Draw and label the axes
      CALL Axes (Title1, Title3, Title4, Title2,
     +     xmin, xmax, ymin, ymax, xtinc, ytinc, DevCode)
      
C     Plot boxplot above graph area
      Width   = Dy *.05
      Tmin	= AMAX1 (Min,     Xmin)
      Tmax	= AMIN1 (Max,     Xmax)
      
      TQ1	= AMIN1 (Q1,      Xmax)
      TQ3	= AMIN1 (Q3,      Xmax)
      Tmean   = AMIN1 (Mean,    Xmax)
      Tmedian = AMIN1 (Median,  Xmax)
      
      TQ1	= AMAX1 (TQ1,      Xmin)
      TQ3	= AMAX1 (TQ3,      Xmin)
      Tmean   = AMAX1 (TMean,    Xmin)
      Tmedian = AMAX1 (TMedian,  Xmin)
      
      CALL Boxplot (TMin,TQ1, TMedian, TMean, TQ3, Tmax, .TRUE.,
     +     Ymax+Width*.7, Width, Dx*.007)
      
C     Plot histogram
      Tsum = 0.0
      CALL Zcolor (Green)
      DO 60 I = 1,  Nclass+1
         Tx = AMAX1 (Cutoff (I) - ClassInc, Xmin)
         X  = AMAX1 (Cutoff (I), Xmin)
         IF (Relative) THEN
            Y = Rfreq (I)
         ELSE
            Y = SumWClass (I)
         ENDIF
         
         IF (Tx .GT. Xmax .OR. X .GT. Xmax .OR. I .GT. Nclass) THEN
            Tsum = Tsum + Y
         ELSE
            Y = AMIN1 (Y, YMax)
            IF (Y .GT. Ymin .AND. Tx .NE. X) CALL Hbox (Tx,X,Ymin,Y)
         ENDIF
 60   CONTINUE
      CALL Zcolor (WHite)
      
 65   IF (Tsum .GT. 0.0) THEN
         IF (Relative) THEN 
            WRITE (NumStr(1:7),'(F7.3)') Tsum
         ELSE
            WRITE (NumStr,'(F12.3)') Tsum
         ENDIF
         CALL Left Justify (Numstr)
         CALL ZMove (Xmax + Dx * .05, Ymin)
         CALL Zlabel ('# >: '//Numstr)
      ENDIF 
      CALL PlotStat
      
cclong11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message =
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
 666  call reset()
cclong11/30/93
      
      RETURN
      END        

