cc$LARGE
C Readdata.for - file input routines for STATS
C
C----------------------------------------------------------------------
C ***  Read Header Data - get data from input file 

	SUBROUTINE Read Header Data  (Error)
	IMPLICIT INTEGER*4 (A-Z)
 	
          INCLUDE 'stats.dec'

	LOGICAL		Error
	CHARACTER*80	Header, Blanks*10, Scratch*5
	CHARACTER*65	File Name

	DATA Blanks /'          '/

C Build File name
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

C Open File for input
	CALL PutStr ('Reading Header Data ',20, 20, 2, 2)
	Error 	= .FALSE.
CCLONG CHANGED TO AVOID COMPILING ERROR
	OPEN(UNIT = 10, FILE = File Name, STATUS='UNKNOWN',ERR = 999)

C Read header string into header character variable
	READ(10, '(A)', ERR = 999, END = 999) Header

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) nvar

	IF (Nvar .LT. 1) THEN 
	   CALL Flash (20, 2, 
     +              'Too few variables in file  (press any key)') 
	   GOTO 999
	ELSEIF (Nvar .GT. MAXVAR) THEN
	   CALL Flash (20, 2, 
     +              'Too many variables in file  (press any key)') 
	   GOTO 999
	ENDIF

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
cc 	  READ (10,'(2A10)', ERR = 999, END = 999)
           READ (10,'(2A)', ERR = 999, END = 999)
     +                                Varnam (i), Units (i)
 20     CONTINUE        

C Load variable names into toggle fields for screen processing

	IF (Nvar .GE. 3) THEN
	   Pos = 2
	ELSE
	   Pos = Nvar - 1
	ENDIF

	CALL Load Toggle Values  ('VARIABLE  ',10,Nvar,  VarNam, Pos)
	CALL Load Toggle Values  ('WVARIABLE ',10,Nvar+1,VarNam, 0)
	CALL Set Toggle Value    ('WVARIABLE ', Nvar, 'None      ')
	CALL Set Toggle Position ('WVARIABLE ', Nvar)
	CALL Set Toggle Position ('LOGOPTION ', 0)
	Log = .FALSE.

C display new field values
	CALL Display One Field  ('VARIABLE ')
	CALL Display One Field  ('WVARIABLE ')
	CALL Display One Field  ('LOGOPTION ')

C display number of variables
	WRITE (Scratch, '(I5)') Nvar
	CALL PutStr (Scratch, 5, 6, 57, 0)
	Ndata 	= 0
	Var 	= 1
	Wvar 	= Nvar + 1
	Weighted = .FALSE.
	CLOSE (10)
	RETURN

C error has been found in data of file
 999	Error = .TRUE.
	CLOSE (10)
	CALL Beep
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered trying  ',33,12,43,0)
	CALL PutStr ('to read the header information in',33,13,43,0)
	CALL PutStr ('the specified file. Be sure that ',33,14,43,0)
	CALL PutStr ('the file has the proper format   ',33,15,43,0)
	CALL PutStr ('for use by this program.         ',33,16,43,0)
        CALL PutStr ('Consult the Users Manual for more',33,17,43,0)
        CALL PutStr ('information about file format.   ',33,18,43,0)
	CALL Erase Field ('VARIABLE  ')
	CALL Erase Field ('WVARIABLE ')
	CALL Flash (20, 2, ' Press any key to exit ')
	Ndata = 0
	Nvar  = 0
	RETURN
	END

C----------------------------------------------------------------------
C Read Data - read data into memory

	SUBROUTINE Read Data (Error)
	IMPLICIT INTEGER*4 (A-Z)
	
           INCLUDE '../common/screen.str'
           INCLUDE 'stats.dec'

	CHARACTER 	Dummy*75, Scratch*5, File Name*65, Ifmt*4
	LOGICAL		Error, force
	REAL*4		DataRec (MAXVAR), Dx, Dy

C Initialize Variables
	DATA Ifmt /'(I5)'/

	CALL PutStr ('Reading Data Values ...  ', 25, 20, 2, 2)

C Build File name
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF

C Open File for input
	Error 	= .FALSE.
cclong added status=unknown to avoid compile error
	OPEN(UNIT = 10, FILE = File Name, STATUS='UNKNOWN', ERR = 999)

C Read header string 
	READ(10, '(A)', ERR = 999, END = 999) Dummy

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) Nvar

	IF (Nvar .LT. 1 .OR. Nvar .GT. MAXVAR) GOTO 999

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999) Dummy, Dummy
 20     CONTINUE        

	MinValue  	= +1.E30
	MaxValue	= -1.E30
	Ndata  		= 0
	NMiss		= 0
	NumNeg		= 0

	DO 30 Nrec = 1, MAXDATA
	   READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	   Ndata 		= Ndata + 1
	   Data (Ndata) 	= DataRec (Var)
	   Ptr  (Ndata)		= Ndata
	   IF (Weighted) THEN
	      IF (Weights (Ndata) .LT. Missing) THEN
	         Weights (Ndata) = DataRec (Wvar)
	      ELSE
	         Weights (Ndata) = 1.0
	      ENDIF
	   ELSE
	      Weights (Ndata) = 1.0
	   ENDIF 
	   IF (Data (Ndata) .LT. Missing) THEN
              IF (Data (Ndata) .LE. 0.0) NumNeg = NumNeg + 1
	      IF (Log) THEN
	         IF (Data (Ndata) .LE. 0) THEN
	            Data (Ndata)	= Missing
	            NMiss		= NMiss + 1	
		    GOTO 30
		 ELSE
	            Data (Ndata)	= ALOG (DataRec (Var))
	         ENDIF
	      ENDIF

              IF (MinValue .GT. Data (Ndata)) MinValue = Data (Ndata)
              IF (MaxValue .LT. Data (Ndata)) MaxValue = Data (Ndata)
	   ELSE
	      Data (Ndata)     = Missing
	      NMiss = NMiss + 1
	   ENDIF
 30	CONTINUE

C check if more than MAXDATA records
	READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	CALL Beep
	CALL PutStr (' WARNING - TOO MANY DATA         ',33,11,43,2)
	CALL PutStr ('The number of data records read  ',33,13,43,0)
	CALL PutStr ('is over the program limit.  The  ',33,14,43,0)
	CALL PutStr ('remaining data will not be used  ',33,15,43,0)
	CALL PutStr ('by this program.                 ',33,16,43,0)
	CALL Flash (20, 2, 'Press any key to continue ')

 900	IF (Ndata .LE. 1) GOTO 999
 	CLOSE (10)

C Sort the data ascending
	CALL PutStr ('Sorting Data Values ...  ', 25, 20, 2, 2)
	CALL Qsort (Data, Ptr, Ndata)
cc
C Write out defaults and results to screen fields
	CALL Set 4 Floating Point Value ('MINVALUE  ', MinValue, 3)
	CALL Display One Field          ('MINVALUE  ')
	CALL Set 4 Floating Point Value ('MAXVALUE  ', MaxValue, 3)
	CALL Display One Field          ('MAXVALUE  ')

	WRITE (Scratch, Ifmt) NVar
	CALL PutStr (Scratch, 5, 6, 57, 0)
	WRITE (Scratch, Ifmt) Ndata
	CALL PutStr (Scratch, 5, 7, 57, 0)
	WRITE (Scratch, Ifmt) NMiss
	CALL PutStr (Scratch, 5, 8, 57, 0)
	IF (NumNeg .GT. 0) THEN
	   WRITE (Scratch, Ifmt) Numneg
	   CALL Left Justify (Scratch)
	   N = LENSTR (Scratch)
	   CALL PutStr ('('//Scratch (1:N)//' Obs<=0)',N+9, 8, 64, 0)
	ENDIF
	CALL Erase (20, 2, 75)

	RETURN

C error has been found in data
 999	if (force) goto 900
        Error 		= .TRUE.
	CLOSE (10)
	CALL Beep
	WRITE (Scratch, '(I5)') Ndata+Nvar+1
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered reading ',33,12,43,0)
	CALL PutStr ('record #         in the data file',33,13,43,0)
	CALL Putstr (Scratch, 5, 13, 52, 2) 
	CALL PutStr ('Check the file name, and that the',33,14,43,0)
	CALL PutStr ('  named file has the the standard',33,15,43,0)
	CALL PutStr ('  data file format.              ',33,16,43,0)
        CALL PutStr ('Consult the Users Manual for more',33,17,43,0)
        CALL PutStr ('information about file format.   ',33,18,43,0)
	CALL Erase Field ('VARIABLE  ')
	CALL Erase Field ('WVARIABLE ')
	CALL Erase Field ('MINVALUE  ')
	CALL Erase Field ('MAXVALUE  ')
cclong replacing this, and the ndata, nvar lines below
cc	CALL Flash (20, 2, ' Press any key to exit ')
cc    with (and added the force logical variable, note lines above and below)
        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           CALL putstr ('Type "f" to continue generally:  ',33,20, 2,0)
           call getthekey(i)
           if (char(i) .eq. 'f' .or. char(i) .eq. 'F') force = .true.
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        else
           Ndata = 0
           Nvar  = 0
        end if
        CALL Erase (20, 2, 75)
cc
	RETURN
	END



