clarge
c**********************************************************************
c*** File name: TRANSB.FOR (Source code for the program TRANS)
C**********************************************************************
C	 S e l e c t  U n a r y  O p e r a n d     (subroutine)
C**********************************************************************
      SUBROUTINE Select Unary Operand 

c*** This routine is called by the routine 'Unary process'.  A menu is
c*** displayed permitting the user a choice of the unary operand - variable 
c*** or constant.  If the user wishes to quit then the previous menu will be 
c*** displayed.	 After deciding upon a unary operand the routine 'Calculate',
c*** which initiates the unary operation, is called.
c*** 
c*** VARIABLES:
c*** Meusmain	 - stores the field name of the Unary Operation menu.
c*** Menu	 - stores the field name of the Select Unary Operand menu.
c*** Choice	 - stores a field name.
c*** Menu Choice - stores the user's menu selection.
c*** Error	 - logical that is true if an error occurs in some specific
c***               process.
c*** Uovflag	 - global logical variable.
c*** Uocflag	 - global logical variable.
c*** Calcomp     - global logical variable.
c*** Var         - stores the toggle position of the item selected by 
c***               the user.

      include 'trans.dec'
      include '../common/screen.str'

      CHARACTER*10   Meusmain, Menu, Choice
      CHARACTER      Menu Choice*12
      INTEGER*4      Var,Toggle,FLD Index
      LOGICAL      Error

      Meusmain = 'MEUSMAIN  '
      Menu     = 'MEUVMAIN  '
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice .EQ. 'Constant    ') THEN
c***  Prompt user for the unary constant operand.
	 Uocflag = .TRUE.
	 Uovflag = .FALSE.
	 Choice = 'UOPERCONST '
         CALL Check Constant Input Overflow(Choice, Error)
	 IF (Error) GOTO 10
	 CALL Calculate 
c***     If a calculation was performed (Calcomp=.true.) then return 
c***     to calling subroutine.
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Variable    ') THEN
c***  This option prompts the user for a unary variable operand. 
	 Uovflag = .TRUE.
	 Uocflag = .FALSE.
	 Choice = 'U OPERAND '
	 Var = Toggle (Choice)
	 CALL Calculate
c***     If a calculation was performed (Calcomp=.true.) then return
c***     to a calling subroutine else display Unary Operand menu.
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Quit        ') THEN
c***     Display Unary Operation menu.
	 CALL Put Menu (Meusmain)
	 RETURN
      ENDIF
      GOTO 10

      RETURN
      END
C**********************************************************************
C	 S e l e c t  B i n a r y  O p e r a n d  1    (subroutine)
C**********************************************************************
      SUBROUTINE Select Binary Operand 1 

c*** This routine displays a menu permitting the user to chose either
c*** a variable or constant as binary operand 1.  After choosing an
c*** operand, the routine 'Binary Process' is called.  If the user decides
c*** to quit, the previous menu will be displayed.    
c***
c*** VARIABLES:
c*** Mecmain	 - stores the field name of the Create New Variable menu.
c*** Menu	 - stores the field name of the Select Binary Operand 1
c***               menu.
c*** Choice	 - stores a field name.
c*** Menu Choice - stores the user's menu selection.
c*** Var	 - stores the toggle position of the item selected by
c**                user.
c*** B1vflag	 - global logical variable.
c*** B1cflag	 - global logical variable.

      include 'trans.dec'
      include '../common/screen.str'

      CHARACTER*10  Mecmain, Menu, Choice
      CHARACTER     Menu Choice*12, Heading1*6, Heading2*36
      CHARACTER     Equal1*3
      INTEGER*4     Var, FLD Index, Toggle
      LOGICAL     Error

c***  The following are label assignments.
      Menu         = 'MEBVMAIN1 '
      Heading1     = 'Binary'
      Heading2     = 'Operand 1     Operator     Operand 2'
      Equal1       = ' = '
      Mecmain      = 'MECMAIN   '
C***********  Place labels in operation box  ******************
      CALL Put Str (Heading1,  6, 8,  5, 0)
      CALL Put Str (Heading2, 36, 7, 33, 0)
      CALL Put Str (  Equal1,  3, 8, 28, 0)
C**********************************************************************
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice .EQ. 'Constant    ') THEN
c***  Prompt user to enter the binary operand 1 constant.
	 B1vflag = .FALSE.
	 B1cflag = .TRUE.
	 Choice = 'BOP1CONST '
         CALL Check Constant Input Overflow(Choice, Error)
	 IF (Error) GOTO 10
	 CALL Binary Process
c***     If a calculation was performed (Calcomp=.true.) then return
c***     to the calling subroutine else display Binary Operand1 menu.
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Variable    ') THEN
c***  This option prompts the user for an existing variable to be
c***  the binary operand 1.
	 B1vflag = .TRUE.
	 B1cflag = .FALSE.
	 Choice = 'B OPERAND1'
	 Var = Toggle (Choice)
	 CALL Erase (20, 2, 70)
	 CALL Binary Process
c***     If a calculation was performed (Calcomp=.true.) then return
c***     to the calling subroutine else display Binary Operand 1 menu.
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Quit        ') THEN
c***  Display New Variable menu and clear operation box.
         CALL Clear Operation Box
 	 CALL Put Menu (Mecmain)
	 RETURN
      ENDIF
      GOTO 10

      RETURN
      END
C**********************************************************************
C	 S e l e c t  B i n a r y  O p e r a n d  2    (subroutine)
C**********************************************************************
      SUBROUTINE Select Binary Operand 2 

c*** This routine is called by the routine 'Binary Process'.  A menu is
c*** displayed permitting the user to choose either a constant or a 
c*** variable for the operand.  After the operand choice the routine
c*** 'Calculate', which begins the binary operation, is called.  If the 
c***  user decides to 'Quit' the previous  menu is called.
c***
c*** VARIABLES:
c*** Mebsmain	 - stores the field name of the Binary Operations menu.
c*** Menu	 - stores the field name of the Select Binary Operand 2
c***               menu.
c*** Choice	 - stores a field name.
c*** Menu Choice - stores the user's menu selection.
c*** Var	 - stores the toggle position of the item selected by
c***               user.
c*** B2vflag	 - global logical variable.
c*** B2cflag	 - global logical variable.
c*** Calcomp     - global logical variable.

      include 'trans.dec'
      include '../common/screen.str'

      CHARACTER*10  Mebsmain, Menu, Choice
      CHARACTER     Menu Choice*12
      INTEGER*4     Var, Toggle, FLD Index
      LOGICAL     Error

      Mebsmain  = 'MEBSMAIN '
      Menu       = 'MEBVMAIN2 '
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice .EQ. 'Constant   ') THEN
c***  This options prompts the user for a constant that is to be
c***  the binary operand 2.
	 B2vflag = .FALSE.
	 B2cflag = .TRUE.
	 Choice = 'BOP2CONST '
         CALL Check Constant Input Overflow(Choice, Error)
	 IF (Error) GOTO 10
	 CALL Calculate
c***     If a calculation was performed (Calcomp = .true.) then return
c***     to the calling subroutine else display .
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
c***     Display Binary Operand2 menu.
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Variable   ') THEN
c***  This option prompts the user for an existing variable to
c***  be the binary operand 2.
	 B2vflag = .TRUE.
	 B2cflag = .FALSE.
	 Choice = 'B OPERAND2'
c***     User selects the existing variable via a toggle field.
	 Var = Toggle (Choice)
	 CALL Erase (20, 2, 70)
	 CALL Calculate
c***     If a calculation was performed (Calcomp=.true.) then return
c***     to the calling subroutine.
	 IF (Calcomp) THEN
	   RETURN
	 ELSE
c***     Display Binary Operand2 menu.
	   CALL Put Menu (Menu)
	 ENDIF
      ELSE IF (Menu Choice .EQ. 'Quit       ') THEN
c***     Display Binary Operations menu.
	 CALL Put Menu (Mebsmain)
	 RETURN
      ENDIF
      GOTO 10

      RETURN
      END
c**********************************************************************
c        C a l c u l a t e                (subroutine)
c**********************************************************************
      SUBROUTINE Calculate

c*** Displays a menu permitting the user to proceed with the calculation
c*** or to return to the previous menu via the quit option.
c***
c*** VARIABLES:
c*** Menu	 - stores the field name of the Calculate menu.
c*** Menu Choice - stores the user's menu selection.

      include '../common/screen.str'

      CHARACTER  Menu*10, Menu Choice*12

      Menu = 'MEUCALC   '
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice .EQ. 'Execute     ') THEN
c***    The routine 'Process' performs the calculations.
	CALL Process
	RETURN
      ELSE IF (Menu Choice .EQ. 'Quit        ') THEN
 	RETURN
      ENDIF
      GOTO 10

      RETURN
      END

c**********************************************************************
c	 I n i t  F l a g s               (subroutine)
C**********************************************************************
      SUBROUTINE Init Flags

c***  Initialize the logical flags.
c***  All variables are global.

      include 'trans.dec'

      B1vflag   = .FALSE.
      B2vflag   = .FALSE.
      B1cflag   = .FALSE.
      B2cflag   = .FALSE.
      Uovflag   = .FALSE.
      Uocflag   = .FALSE.
      Boperator = .FALSE.
      Uoperator = .FALSE.

      RETURN
      END
c**********************************************************************
c	 I n t r o   S c r e e n                (subroutine)
C**********************************************************************
      SUBROUTINE Intro Screen

c***  This routine displays the Introduction screen and prompts the
c***  user to press any key when finished reading the Intro.
 
      include '../common/screen.str'

      CALL Clear Screen
      CALL Set Screen(1)
      CALL Display Frame
      CALL Display Labels
      CALL Flash (20,2,'Press any key to begin the program ')
      RETURN
      END
c**********************************************************************
