cc$LARGE
C Compute2.for
C----------------------------------------------------------------------
C Display lag result for VARIO result screen
	
	SUBROUTINE Display Result (K, Np, D, E)
	INTEGER*4	K, Np, Row, C1, C2, C3
	REAL*4		D, E
	CHARACTER*13	Number, Ifmt*4, Rfmt*8

	DATA Ifmt /'(I5)'/, Rfmt /'(F13.3)'/

	IF (K .LT. 13) THEN
	   Row = K + 6
	   C1  = 5
	   C2  = 11
	   C3  = 24
	ELSE
	   Row = K - 6
	   C1  = 44
	   C2  = 50
	   C3  = 63
	ENDIF
	WRITE (Number (1:5), Ifmt) Np
	CALL PutStr (Number (1:5), 5, Row, C1, 0)
	WRITE (Number, Rfmt) D
	CALL PutStr (Number, 13, Row, C2, 0)
	WRITE (Number, Rfmt) E
	CALL PutStr (Number, 13, Row, C3, 0)
	RETURN
	END

C----------------------------------------------------------------------
C Load Results - put appropriate estimator into estimates array
	
	SUBROUTINE Load Results 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	DO 10 I = 1, Nlag+1
	  IF (Pairs (I) .LT. 1) GOTO 10 
        IF (GammaType .EQ. GAMREL) THEN
          Estimate (I) = GamRelative (I)
        ELSEIF (GammaType .EQ. GAMABS1) THEN
          Estimate (I) = GamPower1 (I)
        ELSEIF (GammaType .EQ. GAMABS2) THEN
          Estimate (I) = GamPower2 (I)
        ELSEIF (GammaType .EQ. GAMERGO) THEN
          Estimate (I) = NonErgodic (I)
        ENDIF
 10	CONTINUE
	RETURN
	END

C----------------------------------------------------------------------
C Display lag results for VARIO result screen
	
	SUBROUTINE Display Results 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	Kmax = AMIN0 (MAXLAG, Nlag+1)
	DO 10 I = 1, Kmax
	 IF (Pairs (I) .GT. 0) 
     +	 CALL Display Result (I, Pairs (I), AvgDist (I), Estimate (I))
 10	CONTINUE
	RETURN
	END

C----------------------------------------------------------------------
C Display results header - sets up header for VARIO results screen
C
	SUBROUTINE Display Results Header
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CHARACTER	Number*13, Rfmt*8, Gfmt*8, Scratch*10
cclong
        character       lilnum*10
c  Introduced because of writing errors to the screen.  It replaces the
c  variable number where it appears.
c
	INTEGER*4	L, LENSTR, Ipos
	DATA		Gfmt /'(F10.3)'/
	DATA		Rfmt /'(F13.3)'/

	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  CALL PutStr ('LN ('//VarNam (Var)(1:L)//')', L+5, 1, 12, 0)
	ELSE
	  CALL PutStr (VarNam (Var), 10, 1, 12, 0)
	ENDIF
	WRITE (Number , Rfmt) VarMin
	CALL PutStr (Number, 13, 2, 12, 0)
	WRITE (Number , Rfmt) VarMax
	CALL PutStr (Number, 13, 3, 12, 0)
	WRITE (lilnum, '(I10)') TotalPairs
	CALL PutStr (Lilnum, 10, 3, 42, 0)
	WRITE (Lilnum , Gfmt) Direction
	CALL PutStr (Lilnum, 10, 1, 67, 0)
	WRITE (Lilnum , Gfmt) Tolerance
	CALL PutStr (Lilnum, 10, 2, 67, 0)
	IF (BandWidth .LT. 1.E30) THEN
	   WRITE (Number(1:10) , Gfmt) BandWidth
	   CALL PutStr (Number, 10, 3, 67, 0)
        ELSE
	   CALL PutStr ('       n/a',10, 3, 67, 0)
	ENDIF
	RETURN
	END	

C----------------------------------------------------------------------
C Display lag results for VARIO result screen
	
	SUBROUTINE Write Lag Results (I)
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	REAL*4		Dmin, Dmax
	CHARACTER   Number*13, Ifmt*8, Rfmt*8
	DATA Ifmt /'(I13)'/, Rfmt /'(F13.3)'/

	Dmax = LagCutoff (I)
	IF (I .EQ. 1) THEN
	  Dmin = LagMinDist 
	ELSE
	  Dmin = LagCutoff (I-1)
	IF (I .GT. Nlag) Dmax = MaxDist
	ENDIF

	WRITE (Number (1:6), '(I6)') I
	CALL PutStr (Number(1:6), 6, 2, 22, 0)
	WRITE (Number (1:6), '(I6)') Pairs (I)
	CALL PutStr (Number(1:6), 6, 3, 22, 0)

	WRITE (Number, Rfmt) Dmin
	CALL PutStr (Number, 13, 1, 62, 0)
	WRITE (Number, Rfmt) Dmax
	CALL PutStr (Number, 13, 2, 62, 0)
	WRITE (Number, Rfmt) AvgDist (I)
	CALL PutStr (Number, 13, 3, 62, 0)

   	WRITE (Number, Rfmt) Mean
	CALL PutStr (Number, 13, 7, 13, 0)
   	WRITE (Number, Rfmt) Variance
	CALL PutStr (Number, 13, 8, 13, 0)
	WRITE (Number, Rfmt) LagMean (I)
	CALL PutStr (Number, 13, 7, 28, 0)
   	WRITE (Number, Rfmt) LagVariance (I)
	CALL PutStr (Number, 13, 8, 28, 0)
   	WRITE (Number, Rfmt) Mfrom (I)
	CALL PutStr (Number, 13, 7, 43, 0)
   	WRITE (Number, Rfmt) VarianceFrom (I)
	CALL PutStr (Number, 13, 8, 43, 0)
   	WRITE (Number, Rfmt) Mto (I)
	CALL PutStr (Number, 13, 7, 58, 0)
   	WRITE (Number, Rfmt) VarianceTo (I)
	CALL PutStr (Number, 13, 8, 58, 0)

	WRITE (Number, Rfmt) GamPower2 (I)
	CALL PutStr (Number, 13, 13, 21, 0)
	WRITE (Number, Rfmt) GamRelative (I)
	CALL PutStr (Number, 13, 14, 21, 0)
	WRITE (Number, Rfmt) GamPower1 (I)
	CALL PutStr (Number, 13, 15, 21, 0)
	WRITE (Number, Rfmt) NonErgodic (I)               
	CALL PutStr (Number, 13, 16, 21, 0)

	WRITE (Number, Rfmt) VMin    (I)
	CALL PutStr (Number, 13, 13, 62, 0)
	WRITE (Number, Rfmt) VQ1     (I)
	CALL PutStr (Number, 13, 14, 62, 0)
	WRITE (Number, Rfmt) VMedian (I)
	CALL PutStr (Number, 13, 15, 62, 0)
	WRITE (Number, Rfmt) Vmean   (I)
	CALL PutStr (Number, 13, 16, 62, 0)
	WRITE (Number, Rfmt) VQ3     (I)
	CALL PutStr (Number, 13, 17, 62, 0)
	WRITE (Number, Rfmt) VMax    (I)              
	CALL PutStr (Number, 13, 18, 62, 0)
	RETURN
	END

C----------------------------------------------------------------------
C Display lag results for VARIO models screen
	
	SUBROUTINE Display Model Results 
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

	CHARACTER   Number*13, Ifmt*4, Rfmt*8
	DATA Ifmt /'(I5)'/, Rfmt /'(F13.3)'/

	Kmax = AMIN0 (MAXLAG, Nlag+1)
	DO 10 I = 1, Kmax
	 IF (Pairs (I) .LE. 0) GOTO 10
	 IF (I .LT. 18) THEN
	   Row = I + 1
	   C1  = 5
	   C2  = 11
	   C3  = 25
	 ELSE
	   Row = I - 16
	   C1  = 44
	   C2  = 50
	   C3  = 63
	 ENDIF
	 WRITE (Number (1:5), Ifmt) Pairs (I)
	 CALL PutStr (Number (1:5), 5, Row, C1, 0)
	 WRITE (Number, Rfmt) AvgDist (I)
	 CALL PutStr (Number, 13, Row, C2, 0)
	 WRITE (Number, Rfmt) Estimate (I)
	 CALL PutStr (Number, 13, Row, C3, 0)
 10	CONTINUE
	RETURN
	END
