C	     GLOBAL PARAMETERS FOR PROGRAM AUTONEST

      integer models, points, types, maxiterates, numtries

C MODELS IS THE MAXIMUM NUMBER OF MODELS PERMITTED TO NEST:

      parameter (models = 4)
cclong 94/3/1: note that models must be the same as maxstruc in the
cc	vario.dec program, or you may have mega probs!

C NPOINTS IS THE MAXIMUM NUMBER OF DATA POINTS FROM LAG CLASSES TO 
C ACCEPT:

      parameter (points = 1000)

C TYPES IS THE NUMBER OF TYPES OF VARIOGRAMS FOR WHICH THE PROGRAM
C HAS BEEN IMPLEMENTED:

      parameter (types = 4)

C MAXITERATES IS THE NUMBER OF ITERATIONS THE PROGRAM WILL DO IN 
C SEARCHING FOR A BETTER FIT WITH THE GIVEN PARAMETER VALUES:

      parameter (maxiterates = 1500)

C NUMTRIES IS THE MAXIMUM NUMBER OF FAILURES THE PROGRAM WILL ALLOW
C BEFORE GIVING UP:

      parameter (numtries = 100)

C MODELS IS JUST THE ARRAY OF LABELS FOR THE TYPES OF VARIOGRAMS
C PERMITTED:

      character*15 model(0:types)
      data (model(i), i=0,types) / ' nugget',' exponential',
     &    ' gaussian',' spherical',' linear' /


c
c			Program use
c
c
c     Since input is from the keyboard, this program is perfect for 
c     batch use from a UNIX system.
c	A control file is created, which has the following form.  
c     Here is an example:
c
c   3				
c   0.16
c   1   0.45    16.7   
c   2   0.42    16.7
c   3   0.11    18.3
c   119
c         192  0.8966663      0.2135752
c         613   1.998740      0.2206272
c         798   3.278674      0.3094208
c         989   4.576615      0.4116396
c         ...    ...            ....   
c
c  line 1:  the number of non-nugget models (here it's 3)
c  line 2:  the nugget (here 0.16)
c  line 3:  the type of model(1),  its sill, and its range
c  line 4:  the type of model(2),  its sill, and its range
c  line 5:  the type of model(3),  its sill, and its range
c  line 6:  the number of lag classes represented
c  lines 7 - 125:  the data, given as
c	    number in class,  class distance,  variogram value
c
c  Model types are as follows:
c	1  exponential
c	2  gaussian
c	3  spherical
c	4  linear with sill

c In vario, 	
c	3  exponential
c	2  gaussian
c	1  spherical
c	4  linear with sill
