cc $LARGE
C Readdata.for - file input routines for VARIO
C
C----------------------------------------------------------------------
C ***  Read Header Data - get data from input file 

	SUBROUTINE Read Header Data  (Error)
	IMPLICIT INTEGER*4 (A-Z)
 	
	INCLUDE 'vario.dec'

	LOGICAL		Error
	CHARACTER	Blanks*10, Scratch*6, Ifmt*4, Signature*12

	DATA Blanks 	/'          '/
	DATA Ifmt 	/'(I6)'/

C Open File for input
	CALL PutStr ('Reading Header Data ',20, 20, 2, 2)
	Error 	= .FALSE.
cc	change 'binary' to 'unformatted'
CCNAB	OPEN (UNIT = 10, FILE = File Name, FORM = 'unformatted',ERR =
CCNAB     *  999)
	OPEN (UNIT = 10, FILE = File Name, FORM = 'unformatted',status
     *  = 'unknown', ERR = 999)

C Read Identifier to check for a valid File
	READ (10, END = 999, ERR = 999) Signature
cc	IF (Signature .NE. 'PREVAR') THEN
	IF (Signature(4:9) .NE. 'prevar') THEN
	   CLOSE (10)
	   CALL Beep
	   CALL Flash (20, 2, 'Invalid file: Press any key to exit ')
	   Ndata = 0
	   Npair = 0
	   Nvar  = 0
	   ERROR = .TRUE.
	   RETURN
	ENDIF

C READ Header information
	READ (10, END = 999, ERR = 999)  Data File, Xvar, Yvar, 
     +		   			 XCmin, XCmax, YCmin, YCmax, 
     +		   			 MinDist, MaxDist

C READ number of variables, number of data
	READ (10, END = 999, ERR = 999)  Nvar, Ndata, Npair

C READ variable names and units from pair file
 	READ (10, END = 999, ERR = 999)  (Varnam (i), i = 1, Nvar)
	READ (10, END = 999, ERR = 999)  (Units  (i), i = 1, Nvar)

C Load variable names into toggle fields for screen processing
	Log = .FALSE.
	Var = 3
	CALL Load Toggle Values  ('ZVARIABLE ',10, Nvar, VarNam, Var-1)
	CALL Set Toggle Position ('LOGOPTION ', 0)

C display new field values
	CALL Display One Field  ('ZVARIABLE ')
	CALL Display One Field  ('LOGOPTION ')

C display number of variables
	WRITE (Scratch, Ifmt) NVar
	CALL PutStr (Scratch, 6, 6, 50, 0)
	WRITE (Scratch, Ifmt) Ndata
	CALL PutStr (Scratch, 6, 7, 50, 0)
	WRITE (Scratch, Ifmt) Npair
	CALL PutStr (Scratch, 6, 8, 50, 0)
	CLOSE (10)
	IF ((Ndata .GT. MAXDATA) .OR. (Npair .GT. MAXPAIR) .OR.
     +	    (Nvar  .GT. MAXVAR)) GOTO 999
	RETURN

C error has been found in data of file
 999	Error = .TRUE.
	CLOSE (10)
	CALL Beep
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered while   ',33,12,43,0)
	CALL PutStr ('reading the pair comparison file.',33,13,43,0)
	CALL PutStr ('Check the file name, and that the',33,14,43,0)
	CALL PutStr ('  named file has the the correct ',33,15,43,0)
	CALL PutStr ('  pair comparison file format.   ',33,16,43,0)
        CALL PutStr ('Pair comparison files must be    ',33,17,43,0)
        CALL PutStr ('created using program PREVAR.    ',33,18,43,0)
	CALL Erase Field ('ZVARIABLE ')
	IF (Ndata .GT. MAXDATA) THEN
	   CALL Flash (20, 2, 'too many data in pair file ') 
	ELSEIF (Npair .GT. MAXPAIR) THEN
	   CALL Flash (20, 2, 'too many pairs in pair file ') 
	ELSEIF (Npair .GT. MAXVAR) THEN
	   CALL Flash (20, 2, 'too many variables in pair file ') 
	ENDIF

	CALL Flash (20, 2, ' Press any key to exit ')
	Pair File = ' '
	RETURN
	END

C----------------------------------------------------------------------
C Read Data - read data and pair links into memory - VARIO

	SUBROUTINE Read Data (Error)
	IMPLICIT INTEGER*4 (A-Z)
	
	INCLUDE 'vario.dec'

	CHARACTER 	Dummy*75, Scratch*6, Ifmt*4, Signature*12
	LOGICAL		Error
	REAL*4		DataRec (MAXVAR), Dx, Dy, DistMax, Sum, SumSq
	LOGICAL		Started
	COMMON /VFLAG/	Started 

C Initialize Variables
	DATA Ifmt /'(I6)'/

	CALL PutStr ('Reading Data Values ...  ', 25, 20, 2, 2)

C Open File for input
	Error 	= .FALSE.
cc 	change 'binary' to 'unformatted'
CCNAB	OPEN (UNIT = 10, FILE = File Name, FORM = 'unformatted', ERR = 
CCNAB     *  999)
	OPEN (UNIT = 10, FILE = File Name, FORM = 'unformatted', STATUS 
     *  = 'UNKNOWN', ERR = 999)

C READ Header information
	READ (10, END = 999, ERR = 999)  Signature
	READ (10, END = 999, ERR = 999)  Data File, Xvar, Yvar, 
     +		   			 XCmin, XCmax, YCmin, YCmax, 
     +		   			 MinDist, MaxDist

C READ number of variables, number of data
	READ (10, END = 999, ERR = 999)  Nvar, Ndata, Npair

C READ variable names and units from pair file
 	READ (10, END = 999, ERR = 999)  (Varnam (i), i = 1, Nvar)
	READ (10, END = 999, ERR = 999)  (Units  (i), i = 1, Nvar)
	NMiss		= 0
	NumNeg		= 0
	Nkept		= 0
	VarMin		= 1.E30
	VarMax		= -1.E30
	Variance    = 0.0
	Mean        = 0.0
	SumSq       = 0.0
	Sum         = 0.0
	DO 30 Nrec = 1, Ndata
	   READ (10, END = 999, ERR = 999) (DataRec (i), i=1, Nvar)
	   IF (Datarec ( Var) .LT. Missing .AND.
     +         Datarec (XVar) .LT. Missing .AND.
     +         Datarec (YVar) .LT. Missing) THEN
              IF (DataRec (Var) .LE. 0.0) NumNeg = NumNeg + 1
	      IF (Log) THEN
	         IF (DataRec (Var) .LE. 0) THEN
	            NMiss		= NMiss + 1	
		    GOTO 30
		 ELSE
	   	    Nkept		= Nkept + 1
	            Xdata (Nkept)	= DataRec (Xvar)
	            Ydata (Nkept)	= DataRec (Yvar)
	            Data  (Nkept)	= ALOG (DataRec (Var))
	         ENDIF
	      ELSE
	   	     Nkept	 	= Nkept + 1
	         Xdata (Nkept)	= DataRec (Xvar)
	         Ydata (Nkept)	= DataRec (Yvar)
	         Data  (Nkept)	= DataRec (Var)
	      ENDIF
	      VarMin = AMIN1 ( Data (Nkept), VarMin)
	      VarMax = AMAX1 ( Data (Nkept), VarMax)
	      Sum    = Sum + Data (Nkept)
	      SumSq  = SumSq + (Data (Nkept) * Data (Nkept))
	   ELSE
	      NMiss = NMiss + 1
	   ENDIF
 30	CONTINUE
	WRITE (Scratch, Ifmt) Nkept
	CALL PutStr (Scratch, 6, 6, 70, 0)
	WRITE (Scratch, Ifmt) NumNeg
	CALL PutStr (Scratch, 6, 7, 70, 0)
	WRITE (Scratch, Ifmt) Nmiss
	CALL PutStr (Scratch, 6, 8, 70, 0)
	WRITE (Scratch, Ifmt) NVar
	CALL PutStr (Scratch, 6, 6, 50, 0)
	WRITE (Scratch, Ifmt) Ndata
	CALL PutStr (Scratch, 6, 7, 50, 0)
	WRITE (Scratch, Ifmt) Npair
	CALL PutStr (Scratch, 6, 8, 50, 0)
	
	CALL Set 4Floating Point Value ('MINZ      ', VarMin, 3)
	CALL Display One Field         ('MINZ      ')
	CALL Set 4Floating Point Value ('MAXZ      ', VarMax, 3)
	CALL Display One Field         ('MAXZ      ')
	IF (Nkept .GT .1) THEN
	 Variance = ((FLOAT (Nkept) * SumSq) - (Sum * Sum))
     +         / FLOAT ((Nkept* (Nkept-1))) 
	  Mean = Sum / FLOAT (Nkept)
	ENDIF 

C READ Pair Comparison data 
	CALL PutStr ('Reading Pair Pointers ...', 25, 20, 2, 2)
	READ (10, END = 999, ERR = 999) (From     (nrec), nrec = 1, Npair)
	READ (10, END = 999, ERR = 999) (To       (i), i = 1, Npair)
	READ (10, END = 999, ERR = 999) (Distance (i), i = 1, Npair)
	READ (10, END = 999, ERR = 999) (Direct   (i), i = 1, Npair)
	CLOSE (10)

C Set default lag spacing for first time into program

cclong	IF (.NOT. Started) THEN
cc That's crazy!  Why only the first time?
	  CALL Default Lags
	  Started = .TRUE.
cclong	ENDIF

	Error = .FALSE.
	CALL Erase (20, 2, 75)
	RETURN

C error has been found in data
 999	Error 		= .TRUE.
	WRITE (Scratch, '(I5)') Nrec
	CLOSE (10)
	CALL Beep
	CALL PutStr ('     ERROR reading data file ... ',33,11,43,2)
	CALL PutStr ('An ERROR was encountered reading ',33,12,43,0)
	CALL PutStr ('Datum  #         in the data file',33,13,43,0)
	CALL Putstr (Scratch, 5, 13, 52, 2) 
	CALL PutStr ('Check the file name, and that the',33,14,43,0)
	CALL PutStr ('  named file has the the correct ',33,15,43,0)
	CALL PutStr ('  pair comparison file format.   ',33,16,43,0)
        CALL PutStr ('Pair comparison files must be    ',33,17,43,0)
        CALL PutStr ('created using program PREVAR.    ',33,18,43,0)
	CALL Erase Field ('ZVARIABLE ')
	CALL Flash (20, 2, ' Press any key to exit ')
	CALL Erase (20, 2, 75)
	Pair File = ' '
	RETURN
	END

C----------------------------------------------------------------------
C ***  Default Lags - set default lag spacing

	SUBROUTINE Default Lags
	IMPLICIT INTEGER*4 (A-Z)
	INCLUDE 'vario.dec'
	INTEGER*4	TnLag

C Compute 'nice' lag intervals
	LagMinDist = 0.0
	LagMaxDist = Distance (Npair) / 2.0 
	LagIncDist = Distance (Npair) / 20.0

	CALL Set 4 Floating Point Value ('LAGMINDIST', LagMinDist, 3)
	CALL Set 4 Floating Point Value ('LAGMAXDIST', LagMaxDist, 3)
	CALL Set 4 Floating Point Value ('LAGINCDIST', LagIncDist, 3)
	CALL Set Up Lags
	RETURN
	END

