cc $LARGE
C Vplot.for - variogram plotting routines
C----------------------------------------------------------------------
	SUBROUTINE Vplot (Type)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (PLOTMODEL = 1)

	INCLUDE  'vario.dec'
	
        REAL*4      Dx, Dy, Mx, My, Tx, Ty, RMIN, RMAX
	REAL*4	    X, Y, Xfudge, Yfudge, Width
        INTEGER*4   I, J, N, LENSTR, L, Type
        character*60 message, menu choice*10

C check for no data
	IF (Nkept .LT. 1) RETURN

cclong 11/30/93
        CALL New Screen (9)
        call put menu ('POSTSCR')
        call set character value('PSFILEN','variogram.ps')
cclong 11/30/93

C Compute symbol sizes, and scaling stuff
 1      message = 'Computing Vplot...' 
        i = lenstr(message)
        CALL PutStr (message,i, 20, 2, 2)
        Dx      = ABS (Xmax - Xmin)
	Dy 	= ABS (Ymax - Ymin)
	Xfudge  = Dx * 0.15
	Yfudge  = Dy * 0.2
	Minx 	= Xmin - (Xfudge*1.9)
	Miny 	= Ymin - Yfudge
	Maxx 	= Xmax + (Xfudge*3.8)
	Maxy 	= Ymax + (Yfudge*1.5)
	Mx 	= Dx * .01 / Aspect 
	My 	= Dy * .01

C graphics setup
	CALL Zsetup (INT2 (Gmode), Ierr)
	CALL Zcolor (White)
	CALL Zlbdir (0.0)
	CALL Zlocat (XMinDev, XmaxDev, YminDev, YmaxDev)
	CALL Zscale (Minx, Maxx, Miny, Maxy)
	CALL Grframe (Xmaxdev, Ymaxdev, Blue) 

C Draw and label the axes
	CALL Axes (Title (1), Title (3), Title (4), Title (2),
     +		   Xmin, Xmax, Ymin, Ymax, Xtinc, Ytinc, DevCode)


C Plot variogram Values
C replaced plains by zcolors and just versions
c        call system("xmessage -message vplot 23")
        call zcolor(green)
c        call system("xmessage -message vplot 24")
	DO 10 I = 1, Nlag
	   X = AvgDist  (I)
	   Y = Estimate (I)
         IF (Pairs (I) .LT. 1) GOTO 10
         IF (X .GE. Xmin .AND. X .LE. Xmax .AND.
     +       Y .GE. Ymin .AND. Y .LE. Ymax) THEN
            CALL justPlus  (X, Y, Mx, My)
            CALL justCross (X, Y, Mx, My)
         ENDIF
 10	CONTINUE
c        call system("xmessage -message vplot 25")
        call zcolor(white)
	IF (Type .EQ. PLOTMODEL) CALL Plot VModel	 	
c        call system("xmessage -message vplot 26")
	CALL Plot Vstats (Xmin, Xmax, Ymin, Ymax)
c        call system("xmessage -message vplot 27")

cclong 11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message = 
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF 
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
cclong 11/30/93
      
 666  call reset()

      CALL Erase (20, 2, 76)
      RETURN
      END

C----------------------------------------------------------------------
C Vplot defaults - compute default values for variogram plot
C
	SUBROUTINE Vplot Defaults
	IMPLICIT INTEGER*4 (A-Z)

 	INCLUDE 'vario.dec'

	REAL*4	    RMIN, RMAX
        CHARACTER   Blanks*60, Vlabel*30
	DATA Blanks
     +/'                                                            '/

C Set up labels
	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	Title (2) = Blanks
      Title (3) = 'Distance '
      IF (GammaType .EQ. GAMREL) THEN
	   Title (1) = 'Relative Variogram for '//Vlabel
         Title (4) = 'Relative Variogram'
      ELSEIF (GammaType .EQ. GAMABS1) THEN
	   Title (1) = 'Madogram for '//Vlabel
         Title (4) = 'Madogram'
      ELSEIF (GammaType .EQ. GAMABS2) THEN
	   Title (1) = 'Variogram for '//Vlabel
         Title (4) = 'Variogram'
      ELSEIF (GammaType .EQ. GAMERGO) THEN
	   Title (1) = 'NonErgodic Variogram for '//Vlabel
         Title (4) = 'NonErgodic Variogram'
      ENDIF
	CALL Set Character Value ('TITLE1    ',Title (1))
	CALL Set Character Value ('TITLE2    ',Title (2))
	CALL Set Character Value ('TITLE3    ',Title (3))
	CALL Set Character Value ('TITLE4    ',Title (4))

C Compute axis boundry and tic interval parameters
	Xmin	=  0.0
	Xmax	=  RMAX (AvgDist,  NLag)
	Ymin	=  RMIN (Estimate, Nlag)
	Ymax   	=  RMAX (Estimate, Nlag)
	CALL NeatAx (Xmin, Xmax, Xtinc, NxTic)
	CALL NeatAx (Ymin, Ymax, Ytinc, NyTic)
	Ymax    = Ymax + Ytinc*.5
	Xmin	= 0.0
	IF (Ymin .GT. 0.0) Ymin	= 0.0
 
	CALL Set 4 Floating Point Value ('GMINX     ', Xmin, 3)
	CALL Set 4 Floating Point Value ('GMAXX     ', Xmax, 3)
	CALL Set 4 Floating Point Value ('GMINY     ', Ymin, 3)
	CALL Set 4 Floating Point Value ('GMAXY     ', Ymax, 3)

	CALL Set 4 Floating Point Value ('XTICSPACE ', Xtinc, 3)
	CALL Set 4 Floating Point Value ('YTICSPACE ', Ytinc, 3)

	RETURN
	END

C----------------------------------------------------------------------
C Plot Vmodel - plot the variogram model curve 
C
	SUBROUTINE Plot Vmodel
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'
	
	REAL*4	X, Y, Dx, Gamma

C Set curve color
	CALL Zcolor (Red)

C Plot curve
	Dx = (Xmax - Xmin) * .01
	CALL Zmove (Xmin, Gamma (Xmin))
	DO 10 X = Xmin, Xmax, Dx
	   Y = Gamma (X)
	   IF (Y .GE. Ymax) THEN
	      CALL Zmove (X, Ymax)
	   ELSE	IF (Y .LE. Ymin) THEN
	      CALL Zmove (X, Ymin)
	   ELSE
	      CALL Zplot (X, Y)
	   ENDIF
 10	CONTINUE
	CALL Zcolor (White)
	RETURN
	END

C----------------------------------------------------------------------
C Gamma - function for calculating variogram value
C
        REAL*4  FUNCTION Gamma (H)

	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'vario.dec'

        REAL*4          H
	REAL*8		Slope, G, R

C variogram value for very small distances
	G     = Nugget
	Gamma = Nugget
cclong: what the hell is this?  It should be relative to the range,
cc so should occur after we look at that.
cccc	IF (H .LE. 1.E-10) RETURN
cc I'm removing it.
cc
        DO 10 I = 1, 4
           R = H / Range (I) 
C Spherical
           IF      (Mtype (I) .EQ. 1) THEN
              IF (R .GT. 1.0) R = 1.0
              G = G + Sill (I) * (1.5*R - 0.5*R*R*R)

C Gaussian (practical range is divided by SQRT (3))
           ELSE IF (Mtype (I) .EQ. 2) THEN
              G = G + Sill (I) * (1.-EXP(-3.0*R*R))

C Exponential (practical range is divided by 3)
           ELSE IF (Mtype (I) .EQ. 3) THEN
              G = G + Sill (I) * (1.- EXP (-3.0*R))

C Linear
           ELSE IF (Mtype (I) .EQ. 4) THEN
ccmyers	      IF (H .LE. Range (I)) THEN
cclong              Slope =  Sill (I)/ Range (I)
                G = G + Sill (I)*R
ccmyers	      ELSE
ccmyers	        G = G + Sill (I) 
ccmyers	      ENDIF
           ENDIF
 10     CONTINUE

        Gamma = G
        RETURN
        END


