
C Kriger.for
C----------------------------------------------------------------------
C Kriger  - Performs kriging for each sample -  XVALID
C
        SUBROUTINE Kriger (Quit)
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (EGA 	 = 3, 	UNDRAW 	= 1, 	DRAW = 0)
	PARAMETER (BEGIN = 0, 	TYPE1 	= 0)

		INCLUDE 'xvalid.dec'

        REAL*4      X0, Y0, X, Y, Z, Min, Max, Tmin, Tmax
	REAL*4	    Dx, Dy, Mx, My, RMIN, RMAX

        INTEGER*4   Neighbors (MAXNEIGHBOR), N, NZero
        INTEGER*4   TNeighbors (MAXNEIGHBOR), TN
        INTEGER*4   I, J, K, NumErrors, Kolor, NumNoFound
cc	INTEGER*4   Shift Status 
	character  Shift Status , message*60, menu choice*10

        CHARACTER   Ch*1, Str*13, Header*72, Ifmt*4, Rfmt*8, stuff*40

        LOGICAL     Error, Failed, DebugMode, Quit
	LOGICAL	    Plotting

	DATA Ifmt /'(I3)'/
	DATA Rfmt /'(G13.3)'/
	Header =   '#          X          Y             Z   '//   
     +    '         Z*        KsDev       N'

C Determine axes ticmarks, and permanent scaling info
	Xmin = RMIN (Xdata, Ndata)
	Ymin = RMIN (Ydata, Ndata)
	Xmax = RMAX (Xdata, Ndata)
	Ymax = RMAX (Ydata, Ndata)
	CALL Neatax (Xmin, Xmax, XTinc, Nxtic)
	CALL Neatax (Ymin, Ymax, YTinc, Nytic)

	Dx 	= ABS (Xmax-Xmin)
	Dy 	= ABS (Ymax-Ymin)
	Tmax 	= AMAX1 (Dx, Dy)
	Mx 	= Tmax * .008 / Aspect 
	My 	= Tmax * .008

C initialize debug states 
        Debug System    = .FALSE.
        Debug Weights   = .FALSE. 
	Debug Neighbors = .FALSE. 
	Debug Mode	= .FALSE.
        keep = .false.
        
        CALL Erase (20, 0, 79)
        CALL Put Str('To begin in debug mode, type the letter now '
     &       //'(else return):', 62, 20, 2, 2)
        CALL Put Str('System - Type "s", Weights - Type "w", Search'
     &       //' - Type "n", Print - "p"',69, 23,2,2)
        call getthekey(ikey)
        shift status = ''
        if (ikey .lt. 127 .and. ikey .gt. 31) then
           shift status = char(ikey)
           if (shift status .eq. 's') then
              Debug System = .TRUE.
              keep = .true.
           else IF (shift status .eq. 'w') then
              Debug Weights = .TRUE. 
              keep = .true.
           else IF (shift status .eq. 'n') then
              Debug Neighbors = .TRUE. 
              keep = .true.
           else IF (shift status .eq. 'p') then
cclong11/30/93              call turn_ps_on('xvalid.ps')
              CALL New Screen (6)
              call put menu ('POSTSCR')
              call set character value('PSFILEN','xvalid.ps')
 
              CALL Erase(20,2,76)
              call get character value('PSFILEN',message)
              CALL Erase(5,10,60)
              call putstr(message(1:60),60,5,10,2)
              CALL Get Menu Choice ('POSTSCR',Menu choice)
              if (menu choice .eq. 'File') then
                 CALL Get Field
                 call get character value('PSFILEN',message)
                 IF (lenstr(message) .EQ. 0) THEN
                    Message =
     &                   'Blank file name given - no can do !'
                    CALL Erase (20, 2, 76)
                    CALL Flash (20, 2,message)
                    goto 1
                 ENDIF
              else if (menu choice .eq. 'Quit') then
                 goto 1
              end if
              i = lenstr(message)
              call putstr(message(1:60),60,5,10,2)
              j = lenstr(fileprefix)
              call turn_ps_on(fileprefix(1:j)//message(1:i))
cclong 11/30/93
              keep = .true.
           else IF (shift status .eq. 'q') then
              goto 999
           end if
        end if

 1      Quit		= .FALSE.
	Plotting	= .FALSE.
	NumErrors	= 0
	NumNoFound	= 0
        NZeroDist   	= 0
	EN		= 0
	ZN 		= 0
	DN		= 0
	SN		= 0
	VN		= 0

C Put out graphics screen for EGA, or kriging message otherwise
ccc
        Plotting = .TRUE.
        CALL PlotData (BEGIN, TYPE1)
ccc   
        CALL Erase (22, 2, 76)
        CALL Erase (23, 2, 76)
        CALL PutStr('Kriging ..."q" will cancel, or use the '
     &       //'debug options...',55,20,2,2)
        CALL Locate Cursor (22, 5)
	CALL Put Characters (Header, 72, 0)

C Calculate GamMax (nugget + all sills) value: Covar = GamMax - Gamma ()
        GamMax = Nugget
        DO  5 I = 1, 4
             IF (Mtype (I) .NE. 0) GamMax = GamMax + Sill (I)
  5     CONTINUE

C Main kriging loop - perform kriging for each sample in data file
        DO 10 I = 1, Ndata
	   Error = .FALSE.
	   IF (Quit) GOTO 999

C initialize debug states      (Kriging System  = Scroll Lock
C            			Kriging Weights = Num Lock
C  	     			Search Area     = Caps Lock)

C check for debug modes
           if (.not. keep) then

              IF (Debug Weights.OR.Debug System.OR.
     &             Debug Neighbors) THEN
                 CALL Erase (20, 2, 76)
                 CALL PutStr('Kriging ..."q" will cancel, or use the '
     &                //'debug options...' ,55,20,2,2)
              end if

              Debug System    = .FALSE.
              Debug Weights   = .FALSE.
              Debug Neighbors = .FALSE.

              ikey = -666
              call checkkey(ikey)
              shift status = ''
              if (ikey .lt. 127 .and. ikey .gt. 31) 
     &             shift status = char(ikey)

              if (shift status .eq. 's') then
                 Debug System = .TRUE.
              else IF (shift status .eq. 'w') then
                 Debug Weights = .TRUE.
              else IF (shift status .eq. 'n') then
                 Debug Neighbors = .TRUE.
              else IF (shift status .eq. 'q') then
                 goto 999
              end if
           end if

   	   IF (Debug Weights.OR.Debug System.OR.Debug Neighbors) THEN
              keep = .true.
              DebugMode = .TRUE.
	   ELSE
C Restore proper screen if no debug mode set
	       IF (DebugMode) THEN
	           IF (Plotting) THEN
	             CALL PlotData (I-1, TYPE1)
	           ELSE
                     CALL NewScreen (2)
	           ENDIF
        	   CALL Locate Cursor (22, 5)
		   CALL Put Characters (Header, 72, 0)
	       ENDIF  
	       DebugMode = .FALSE.
	   ENDIF

C Set temporary coordinate and sample values, initialize neigbors to 0
	   Zptr (I)	= I
           X0 		= XData	(I)
           Y0 		= YData	(I)
	   Variable (I) = Data  (I)
           N 		= 0

C Initialize array values to missing
	   Estimate (I)   = Missing
	   StdDev (I)     = Missing 	
	   Difference (I) = Missing
	   Zscore (I)     = Missing	

C perform neighborhood search (for non-missing values)
	   IF (Data (I) .LT. Missing) THEN

              CALL Search (X0, Y0, Neighbors, N, Failed)

C Put out neighborhood debug screen (if debug mode set)
              IF (Debug Neighbors) THEN
                IF (Graphics) THEN
     		  CALL Show Neighbors (X0, Y0, Neighbors, N, Quit)
     		  CALL Plot Neighbors (X0, Y0, Neighbors, N, Quit)
	        ELSE
     		  CALL Show Neighbors (X0, Y0, Neighbors, N, Quit)
		ENDIF
              ENDIF
	   ENDIF

C If search failed to produce neigbors, then values get missing
           IF ((N .EQ. 0) .OR. Failed) THEN

	      IF (N .EQ. 0) NumNoFound = NumNoFound + 1
	      IF (NumNoFound .GT. 75) THEN
	         IF (Plotting) CALL Clear Screen 
	         CALL Beep
	         CALL Flash (20, 2,
     + 	 'Too many points with no neighbors - check search criteria')  
	         GOTO 999
	      ENDIF
C plot an X for no result
	      IF (Plotting) CALL Circle (X0, Y0, Mx*2., White, White)
           ELSE

C Build system (NZero is a count of neighbor pairs with Zero distance)
             CALL Build System (X0, Y0, Neighbors, N,
     +				        TNeighbors, TN, NZero)

             NZeroDist = NZeroDist + NZero

C Put out debug screen for kriging system
             IF (Debug System) 
     +          CALL Show System (X0, Y0, TN, Quit)

C Solve the kriging system of equations, and compute results
             CALL Solve System (TNeighbors, TN, Error)

C Put out debug screen for kriging weights and neighbors
             IF (Debug Weights) 
     +            CALL Show Weights (I, TNeighbors, TN, Quit)

C Keep a count of system solver errors, check for too many
	     IF (Error) THEN

	        Estimate (I)   = Missing
	        Difference (I) = Missing
                Num Errors = Num Errors + 1
        	IF (Num Errors .GT. 10) THEN
	           IF (Plotting) CALL Clear Screen 
	           CALL Beep
                   CALL Flash (20, 2, 
     +             'Too many System Solver errors - (press any key)')
	           GOTO 999
	        ENDIF
C plot an X for no result
	        IF (Plotting) CALL Circle (X0, Y0, Mx*2., White, White)
	     ELSE

C Store results into arrays

	      IF (Vk .LT. Missing) THEN
	 	Estimate (I)   	= Vk
	        Difference (I) 	= Vk - Data (I)
	        IF (Sk .LT. Missing) THEN
	            StdDev (I)	= Sk 	
	            IF (Sk .NE. 0.) Zscore (I) = Difference (I) / Sk
	        ENDIF
	      ENDIF	      

C Erase original observed value plot symbol, replace with estimate 
	      IF (Plotting .AND. (.NOT. Debug Neighbors)) THEN
	        CALL Plot Value (X0, Y0, Mx, My, Data (I),  UNDRAW) 
     		CALL Plot Value (X0, Y0, Mx*1.5, My*1.5, Vk, DRAW)
	      ENDIF
	     ENDIF 
           END IF

C put out results for the kriged sample
	   IF (.NOT. DebugMode) THEN
	      CALL Locate Cursor (23,2)
	      WRITE (Str(1:4), Ifmt) 			I
	      CALL Put Characters (Str, 4, 0)

	      CALL Locate Cursor (23, 8)
	      WRITE (Str, Rfmt) 			X0
	      CALL Put Characters (Str, 13, 0)

	      CALL Locate Cursor (23, 20)
	      WRITE (Str, Rfmt) 			Y0
	      CALL Put Characters (Str, 13, 0)

	      CALL Locate Cursor (23, 34)
	      WRITE (Str, Rfmt) 			Variable (I)
	      CALL Put Characters (Str, 13, 0)

	      CALL Locate Cursor (23, 48)
	      WRITE (Str, Rfmt) 			Estimate (I)
	      CALL Put Characters (Str, 13, 0)

	      CALL Locate Cursor (23, 62)
	      WRITE (Str, '(G11.3)') 			StdDev (I)
	      CALL Put Characters (Str, 11, 0)

	      CALL Locate Cursor (23, 74)
	      WRITE (Str, Ifmt) 		       TN
	      CALL Put Characters (Str, 3, 0)
	   ENDIF
 10     CONTINUE

C Done with kriging - compute stats and return
	IF (.NOT. Plotting) 
     +	   CALL PutStr ('Computing kriging statistics  ',30,20,2,2)

C compute stats
	CALL Stats (Variable,   Ndata, VN, VNmiss,
     +                          VMin, VQ1, Vmedian, VQ3, VMax, 
     +                          VMean, Vstd)
	CALL Stats (Estimate,   Ndata, EN, ENmiss,
     +                          EMin, EQ1, Emedian, EQ3, EMax, 
     +                          EMean, Estd)
	CALL Stats (StdDev,     Ndata, SN, SNmiss,
     +                          SMin, SQ1, Smedian, SQ3, SMax, 
     +                          SMean, Sstd)
	CALL Stats (Difference, Ndata, DN, DNmiss,
     +                          DMin, DQ1, Dmedian, DQ3, DMax, 
     +                          DMean, Dstd)
	CALL Stats (Zscore,     Ndata, ZN, ZNmiss,
     +                          ZMin, ZQ1, Zmedian, ZQ3, ZMax, 
     +                          ZMean, Zstd)

C Sort Differences and Zptr, so SUBROUTINE Examine can display sorted results
	CALL Qsort (Difference, ZPtr, Ndata)

C indicate that kriging is complete, put out message
	CALL Finish Beep
        CALL Flash (20, 2, 'Kriging completed ... (press any key)')
	CALL Erase (20, 2, 75)
	RETURN

C Error or quit exit
 999	CONTINUE
	EN 	= 0
	Quit 	= .TRUE.
	CALL Beep
	CALL Clear Screen
	RETURN
        END

C---------------------------------------------------------------------
	SUBROUTINE Finish Beep
	DO 10 I = 1, 10
	call beep
 10	CONTINUE	
	RETURN
	END 
               
                    
 
             

             
 
                
                
    
                       

