
C Scatter.for for XVALID
C----------------------------------------------------------------------
C Scatter - Scattergram 

	SUBROUTINE Scatter (TypeFlag) 
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

		include  'xvalid.dec'

C Local variables
	
	REAL*4		Xfudge, Yfudge, Xstart, Z
	REAL*4		X, Y, Dx, Dy, Tx, Ty, Mx, My, Xc, Yc
	REAL*4		Tmin, Tmax, Width, Factor, RMIN, RMAX
	REAL*4		TxMin, TxMax, TyMin, TyMax, Txtinc, TyTinc
	REAL*4		TMinx, Tmaxx, Tminy, TmaxY, tXfudge, tYfudge

	INTEGER*4       K, TypeFlag, Color, DevMaxX, DevMaxY
	INTEGER*4       L, LENSTR, Tptr

	CHARACTER       Plot Title*70, Xlabel*45, Ylabel*20
	CHARACTER*10    Rfmt, Ifmt
	CHARACTER       NumStr*12, Vlabel*15
	character*72	message, menu choice*10

	DATA		Ifmt /'(I12)'  /
	DATA		Rfmt /'(F12.3)'/

cclong 11/30/93
        CALL New Screen (6)
        call put menu ('POSTSCR')
        call set character value('PSFILEN','scatter.ps')
cclong 11/30/93
 
C Code for Square (corrected by pixel aspect ratio) Device Plotting Space
	DevMaxY		= YMaxDev
	   Factor 	= 29./45.
	DevMaxX = DevMaxY / Factor

	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	Plot Title = 'Cross Validation for '//Vlabel
	Ylabel = 'Kriged Estimate'
	IF (TypeFlag .EQ. 0) THEN
	   IF (VN .EQ. 0 .OR. EN .EQ. 0) RETURN
           Xlabel = Vlabel
	ELSE
	   IF (DN .EQ. 0 .OR. EN .EQ. 0) RETURN
	   Xlabel = 'Difference: Estimate - '//Vlabel
	ENDIF

C Calculate ticmark and max axis values
 1      message = 'Computing Scatterplot...type "q" to quit. '
        CALL PutStr (message,lenstr(message), 20, 2, 2)
        TYmin = 0.
	Dx    = 0.
	TyMin = Emin
	TyMax = Emax
	IF (TypeFlag .EQ. 0) THEN
	   TYmin = AMIN1 (TyMin, Vmin)
	   TYmax = AMAX1 (TyMax, Vmax)
	   CALL Neatax (TYmin, TYmax, TYtinc, K)
	   Txtinc 	= TYtinc		
	   TxMax  	= TyMax        
	   TxMin  	= TyMin        
	ELSE
	   DevMaxY 	= YmaxDev
	   DevMaxX 	= XmaxDev
         TXmin 	= Dmin
	   TXmax 	= Dmax
	   CALL Neatax (TXmin, TXmax, TXtinc, K)
	   CALL Neatax (TYmin, TYmax, TYtinc, K)
	ENDIF

C  Calculate other scaling information
	dx 	= Txmax - txmin
	dy 	= tymax - tymin
	txfudge	= dx * 0.15
	tyfudge	= dy * 0.2
	tminx 	= txmin - (txfudge*1.75)
	tmaxx 	= txmax + (txfudge*2.0)
	tminy 	= tymin - tyfudge
	tmaxy 	= tymax + (tyfudge*1.5)
	Tx 	= (tMaxx - tMinx) * .005
	Ty 	= (tMaxy - tMiny) * .007
	mx 	= (dx * .013)/aspect
	my 	= dy * .013

C Start graphics mode
	CALL Zsetup (Gmode, Ierr)

C Clear the screen
        call zclear()

C Set text attributes (8x8, white on black border)
	CALL Zlbdir (0.0)
	
C Draw graph frame
	CALL Grframe (DevMaxX, DevMaxY, Blue)
	CALL Zlocat (0, DevMaxX, 0, DevMaxY)

C Set scaling window
	CALL Zscale (tMinx, tMaxx+Tx, tMiny, tMaxy+Ty)
	CALL Zcolor (INT2 (White))

C Draw and label the axes
	CALL Axes ('Scatter Plot', Xlabel, Ylabel, Plot Title,
     +		   Txmin, Txmax, Tymin, Tymax, Txtinc, Tytinc, DevCode)

C Draw 45 degree line
	IF (TypeFlag .EQ. 0) THEN
	   CALL ZMove (TxMin, TYmin)
	   CALL Zplot (TxMax, TYmax)
	ENDIF
	
C Plot scattergram 
	DO 50 I = 1, Ndata
	   Tptr = Zptr (I)
	   IF (TypeFlag .EQ. 0) THEN
	      X = Variable (Tptr)
	      Y = Estimate (Tptr)
	   ELSE
	      X = Difference (I)
	      Y = Estimate (Tptr) 
	   ENDIF
	   IF (X .GE. Missing .OR. Y .GE. Missing) GOTO 50
	   IF (Difference (I) .GE. 0) THEN
             CALL Plus (X, Y, Mx, My, Red, White)
	   ELSE
             CALL Cross (X, Y, Mx, My, Blue, White)
	   ENDIF	        
 50	CONTINUE

C Draw box plot for X variable 
        Width = Dy *.04
	IF (TypeFlag .EQ. 0) THEN
           CALL Boxplot (VMin, VQ1, VMedian, Vmean, VQ3, Vmax, 
     +           .TRUE., tYmax + Width*.7, Width, (Dx*.007))
	ELSE
           CALL Boxplot (DMin, DQ1, DMedian, Dmean, DQ3, Dmax, 
     +           .TRUE., tYmax+Width*.7, Width, (Dx*.007))
	ENDIF

C Draw box plot for Y variable 
        Width = Dx *.04
        CALL Boxplot (EMin, EQ1, EMedian, Emean, EQ3, Emax, 
     +           .FALSE., tXmax+Width*.7, Width, (Dy*.007))

	CALL Set Toggle Position ('TYPSCATTER', 0)

cclong 11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message =
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
cclong 11/30/93
 
 666  call reset()
 
      RETURN
      END

